// ==EMEVD==
// @docs    ds1-common.emedf.json
// @compress    None
// @game    DarkSouls1
// @string    
// @linked    []
// @version    3.2.2
// ==/EMEVD==

// コンストラクタ
Event(0, Default, function() {
    InitializeEvent(0, 977, 0); // Gametype flag init
    InitializeEvent(0, 975, 0); // Hate
    
    /* Remove Temp Items */
    RemoveItemFromPlayer(ItemType.Goods, 265, 1); // Always remove teamchange and lobby items on game load.
    RemoveItemFromPlayer(ItemType.Goods, 266, 1);
    RemoveItemFromPlayer(ItemType.Goods, 267, 1);
    RemoveItemFromPlayer(ItemType.Goods, 268, 1);
    RemoveItemFromPlayer(ItemType.Goods, 269, 1);
    RemoveItemFromPlayer(ItemType.Goods, 9851, 1);
    RemoveItemFromPlayer(ItemType.Goods, 9852, 1);
    RemoveItemFromPlayer(ItemType.Goods, 9853, 1);
    RemoveItemFromPlayer(ItemType.Weapon, 2107000, 999); // Remove special arrows on area load
    RemoveItemFromPlayer(ItemType.Weapon, 2203000, 999);
    RemoveItemFromPlayer(ItemType.Weapon, 2204000, 999);
    
    /* Speff Disabler */
    InitializeEvent(0, 985, 10000, 612, 0);
    InitializeEvent(1, 985, 10000, 1070, 0);
    InitializeEvent(2, 985, 10000, 1080, 0);
    InitializeEvent(3, 985, 10000, 1081, 0);
    InitializeEvent(4, 985, 10000, 1082, 0);
    InitializeEvent(5, 985, 10000, 1083, 0);
    InitializeEvent(6, 985, 10000, 1060, 0);
    InitializeEvent(7, 985, 10000, 1800, 0);
    InitializeEvent(8, 985, 10000, 1120, 0);
    InitializeEvent(9, 985, 10000, 1330, 0);
    InitializeEvent(10, 985, 10000, 1500, 0);
    InitializeEvent(11, 985, 10000, 1510, 0);
    InitializeEvent(12, 985, 10000, 2020, 0);
    InitializeEvent(13, 985, 10000, 2023, 0);
    InitializeEvent(14, 985, 10000, 2270, 0);
    InitializeEvent(15, 985, 10000, 2271, 0);
    InitializeEvent(16, 985, 10000, 2998, 0);
    InitializeEvent(17, 985, 10000, 2988, 0);
    InitializeEvent(18, 985, 10000, 3160, 0);
    InitializeEvent(19, 985, 10000, 3170, 0);
    InitializeEvent(20, 985, 10000, 3190, 0);
    InitializeEvent(21, 985, 10000, 9031, 0);
    InitializeEvent(22, 985, 10000, 9032, 0);
    InitializeEvent(23, 985, 10000, 2010, 0);
    InitializeEvent(24, 985, 10000, 1000, 0);
    InitializeEvent(25, 985, 10000, 1020, 0);
    InitializeEvent(26, 985, 10000, 9450, 0);
    
    /* Left Hand Warning */
    InitializeEvent(0, 986, 10000, 0);
    
    /* Energy Sword Damage Mod */
    InitializeEvent(0, 949, 0);
    
    /* Grenade Limits */
    InitializeEvent(0, 989, 10000, 0);
    InitializeEvent(0, 988, 10000, 0);
    InitializeEvent(0, 987, 10000, 0);
    
    InitializeEvent(0, 997, 10000, 0); // Needler Detoante
    InitializeEvent(0, 998, 10000, 0); // Needler Tracking
    
    /* Other */
    InitializeEvent(0, 999, 0); // NoGrav Thing
    InitializeEvent(0, 950, 0);
    
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    SetEventFlag(760, OFF);
    SetEventFlag(762, OFF);
    SetEventFlag(765, OFF);
    InitializeEvent(0, 260, 11810000, 10010600, 0);
    InitializeEvent(1, 260, 257, 10010610, 0);
    InitializeEvent(2, 260, 710, 10010620, 0);
    InitializeEvent(0, 761, 0);
    InitializeEvent(0, 763, 0);
    InitializeEvent(0, 290, 0);
    InitializeEvent(0, 701, 0);
    InitializeEvent(0, 702, 0);
    InitializeEvent(0, 717, 0);
    InitializeEvent(0, 718, 0);
    InitializeEvent(0, 706, 0);
    InitializeEvent(0, 740, 0);
    InitializeEvent(0, 750, 0);
    InitializeEvent(0, 752, 0);
    InitializeEvent(0, 757, 0);
    InitializeEvent(0, 758, 0);
    InitializeEvent(0, 759, 0);
    InitializeEvent(0, 754, 0);
    InitializeEvent(0, 770, 0);
    InitializeEvent(0, 772, 0);
    InitializeEvent(0, 730, 0);
    InitializeEvent(0, 731, 0);
    InitializeEvent(0, 766, 0);
    InitializeEvent(0, 710, 0);
    InitializeEvent(0, 711, 2500, 711);
    InitializeEvent(1, 711, 2501, 712);
    InitializeEvent(2, 711, 2502, 713);
    InitializeEvent(3, 711, 2504, 714);
    InitializeEvent(0, 715, 0);
    InitializeEvent(0, 716, 0);
    InitializeEvent(0, 8131, 202, 203);
    InitializeEvent(1, 8131, 204, 205);
    InitializeEvent(2, 8131, 206, 207);
    InitializeEvent(3, 8131, 208, 209);
    InitializeEvent(4, 8131, 210, 211);
    InitializeEvent(5, 8131, 212, 213);
    InitializeEvent(6, 8131, 214, 215);
    InitializeEvent(0, 819, 0);
    InitializeEvent(0, 970, 2, 2500, 9020, 9030);
    InitializeEvent(1, 970, 11010901, 0, 9000, 9030);
    InitializeEvent(2, 970, 11010902, 2510, 9000, 9030);
    InitializeEvent(3, 970, 3, 0, 9020, 0);
    InitializeEvent(4, 970, 4, 2520, 9020, 0);
    InitializeEvent(5, 970, 11200900, 2530, 9000, 0);
    InitializeEvent(6, 970, 5, 2540, 9000, 9030);
    InitializeEvent(7, 970, 6, 2550, 9000, 9030);
    InitializeEvent(8, 970, 7, 2560, 9000, 0);
    InitializeEvent(9, 970, 9, 2570, 9020, 0);
    InitializeEvent(10, 970, 11410900, 0, 9000, 9030);
    InitializeEvent(11, 970, 11410410, 0, 9000, 0);
    InitializeEvent(12, 970, 11410901, 0, 9000, 9030);
    InitializeEvent(13, 970, 10, 2580, 9000, 0);
    InitializeEvent(14, 970, 11, 2590, 9000, 0);
    InitializeEvent(15, 970, 11510900, 2600, 0, 0);
    InitializeEvent(16, 970, 11510902, 2610, 9000, 0);
    InitializeEvent(17, 970, 11510903, 2620, 9000, 0);
    InitializeEvent(18, 970, 13, 2630, 9010, 0);
    InitializeEvent(19, 970, 14, 2640, 9000, 0);
    InitializeEvent(20, 970, 15, 2650, 0, 0);
    InitializeEvent(21, 970, 16, 2660, 9000, 0);
    InitializeEvent(22, 970, 11810900, 0, 9000, 9030);
    InitializeEvent(23, 970, 11210000, 2680, 9000, 0);
    InitializeEvent(24, 970, 11210001, 2690, 0, 0);
    InitializeEvent(25, 970, 17, 2700, 9040, 0);
    InitializeEvent(26, 970, 11210004, 2710, 0, 0);
    InitializeEvent(0, 250, 2600, 250);
    InitializeEvent(1, 250, 2601, 251);
    InitializeEvent(2, 250, 2602, 252);
    InitializeEvent(3, 250, 2603, 253);
    InitializeEvent(4, 250, 2604, 254);
    InitializeEvent(5, 250, 2605, 255);
    InitializeEvent(6, 250, 2606, 256);
    InitializeEvent(7, 250, 2607, 257);
    InitializeEvent(8, 250, 2608, 258);
    InitializeEvent(9, 250, 2609, 259);
    InitializeEvent(0, 350, 350, 800);
    InitializeEvent(1, 350, 351, 801);
    InitializeEvent(2, 350, 352, 802);
    InitializeEvent(6, 350, 356, 806);
    InitializeEvent(7, 350, 357, 807);
    InitializeEvent(8, 350, 358, 808);
    InitializeEvent(9, 350, 359, 809);
    InitializeEvent(10, 350, 360, 810);
    InitializeEvent(12, 350, 362, 812);
    InitializeEvent(13, 350, 363, 813);
    InitializeEvent(0, 780, 1000, 780);
    InitializeEvent(1, 780, 1010, 781);
    InitializeEvent(2, 780, 1020, 782);
    InitializeEvent(3, 780, 1030, 783);
    InitializeEvent(4, 780, 1040, 784);
    InitializeEvent(5, 780, 1050, 785);
    InitializeEvent(6, 780, 1060, 786);
    InitializeEvent(7, 780, 1070, 787);
    InitializeEvent(8, 780, 1080, 788);
    InitializeEvent(9, 780, 1090, 789);
    InitializeEvent(10, 780, 1100, 790);
    InitializeEvent(11, 780, 1110, 791);
    InitializeEvent(12, 780, 1120, 792);
    InitializeEvent(13, 780, 1130, 793);
    InitializeEvent(0, 870, 0, 850);
    InitializeEvent(1, 870, 1, 851);
    InitializeEvent(2, 870, 2, 852);
    InitializeEvent(3, 870, 3, 853);
    InitializeEvent(4, 870, 4, 854);
    InitializeEvent(5, 870, 5, 855);
    InitializeEvent(6, 870, 6, 856);
    InitializeEvent(7, 870, 7, 857);
    InitializeEvent(8, 870, 8, 858);
    InitializeEvent(9, 870, 9, 859);
    InitializeEvent(0, 840, 840, 7905, 6370, -1);
    InitializeEvent(1, 840, 841, 7905, 6072, -1);
    InitializeEvent(2, 840, 842, 7905, 6080, -1);
    InitializeEvent(3, 840, 843, 7905, 6001, -1);
    InitializeEvent(4, 840, 844, 7898, 10000, 7896);
    InitializeEvent(5, 840, 845, 7905, 6340, -1);
    InitializeEvent(6, 840, 846, 7905, 6341, -1);
    InitializeEvent(7, 840, 847, 7913, 10000, 7911);
    InitializeEvent(8, 840, 848, 7905, 6380, -1);
    InitializeEvent(9, 840, 849, 7905, 1400700, -1);
    InitializeEvent(0, 690, 600, 4, 16, 1175);
    InitializeEvent(0, 719, 0);
    InitializeEvent(0, 720, 0);
    InitializeEvent(0, 721, 0);
    InitializeEvent(0, 722, 0);
    InitializeEvent(0, 723, 0);
    InitializeEvent(0, 724, 0);
    InitializeEvent(0, 725, 0);
    InitializeEvent(0, 726, 0);
    InitializeEvent(0, 727, 0);
    InitializeEvent(0, 745, 0);
    InitializeEvent(0, 818, 0);
    InitializeEvent(0, 810, 0);
    InitializeEvent(0, 812, 51400350);
    InitializeEvent(1, 812, 51010050);
    InitializeEvent(0, 822, 0);
    InitializeEvent(0, 823, 0);
    InitializeEvent(0, 910, 11400591, 1280);
    InitializeEvent(0, 911, 11010591, 1000, 1);
    InitializeEvent(1, 911, 11510590, 1010, 1);
    InitializeEvent(2, 911, 11700591, 1020, 1);
    InitializeEvent(3, 911, 11000591, 1030, 1);
    InitializeEvent(4, 911, 11400590, 1040, 1);
    InitializeEvent(5, 911, 11410594, 1050, 1);
    InitializeEvent(6, 911, 11020594, 1060, 1);
    InitializeEvent(7, 911, 11020595, 1070, 1);
    InitializeEvent(8, 911, 11810590, 1082, 1);
    InitializeEvent(9, 911, 11810591, 1080, 1);
    InitializeEvent(10, 911, 11510592, 1090, 1);
    InitializeEvent(11, 911, 11600592, 1100, 1);
    InitializeEvent(12, 911, 11020602, 1110, 1);
    InitializeEvent(13, 911, 11010594, 1120, 1);
    InitializeEvent(14, 911, 11010595, 1130, 1);
    InitializeEvent(15, 911, 11020599, 1140, 1);
    InitializeEvent(16, 911, 11020607, 1150, 1);
    InitializeEvent(17, 911, 11200592, 1160, 1);
    InitializeEvent(18, 911, 11200593, 1170, 1);
    InitializeEvent(19, 911, 11200594, 1180, 1);
    InitializeEvent(20, 911, 11300590, 1190, 1);
    InitializeEvent(21, 911, 11300591, 1200, 1);
    InitializeEvent(22, 911, 11310590, 1210, 1);
    InitializeEvent(23, 911, 11310592, 1220, 1);
    InitializeEvent(24, 911, 11310593, 1230, 1);
    InitializeEvent(25, 911, 11310594, 1240, 1);
    InitializeEvent(26, 911, 11320590, 1250, 1);
    InitializeEvent(27, 911, 11320581, 1260, 1);
    InitializeEvent(28, 911, 11320593, 1270, 1);
    InitializeEvent(29, 911, 11400592, 1290, 1);
    InitializeEvent(30, 911, 11400594, 1300, 1);
    InitializeEvent(31, 911, 11400596, 1310, 1);
    InitializeEvent(32, 911, 11400597, 1320, 1);
    InitializeEvent(33, 911, 11400598, 1330, 1);
    InitializeEvent(34, 911, 11400599, 1340, 1);
    InitializeEvent(35, 911, 11510595, 1350, 1);
    InitializeEvent(36, 911, 11510596, 1360, 1);
    InitializeEvent(37, 911, 11510597, 1370, 1);
    InitializeEvent(38, 911, 11600594, 1380, 1);
    InitializeEvent(39, 911, 11600595, 1390, 1);
    InitializeEvent(40, 911, 11600596, 1400, 1);
    InitializeEvent(41, 911, 11010598, 1410, 0);
    InitializeEvent(42, 911, 11210590, 1500, 1);
    InitializeEvent(43, 911, 11210593, 1510, 1);
    InitializeEvent(44, 911, 11210594, 1520, 1);
    InitializeEvent(45, 911, 11600580, 1401, 1);
    InitializeEvent(46, 911, 11600581, 1402, 1);
    InitializeEvent(47, 911, 11600582, 1403, 1);
    InitializeEvent(48, 911, 11600583, 1404, 1);
    InitializeEvent(0, 890, 11310580, 1221, 1);
    InitializeEvent(1, 890, 11510580, 1361, 1);
    InitializeEvent(2, 890, 11510581, 1371, 1);
    InitializeEvent(3, 890, 11320592, 1261, 1);
    InitializeEvent(0, 960, 1322, 6190, 6190);
    InitializeEvent(1, 960, 1315, 6180, 1100);
    InitializeEvent(2, 960, 1402, 6230, 6230);
    InitializeEvent(3, 960, 1402, 6230, 6231);
    InitializeEvent(0, 8200, 3, 5500, 50000120, 11010594);
    InitializeEvent(1, 8200, 3, 5510, 50000130, 11010595);
    InitializeEvent(2, 8200, 2, 103, 50000160, 11200592);
    InitializeEvent(3, 8200, 3, 240, 50000170, 11200593);
    InitializeEvent(4, 8200, 2, 124, 50000180, 11200594);
    InitializeEvent(5, 8200, 0, 453000, 50000220, 11310592);
    InitializeEvent(6, 8200, 3, 5100, 50000225, 11310580);
    InitializeEvent(7, 8200, 3, 5110, 50000230, 11310593);
    InitializeEvent(8, 8200, 3, 114, 50000265, 11320581);
    InitializeEvent(9, 8200, 3, 377, 50000260, 11320592);
    InitializeEvent(10, 8200, 3, 378, 50000270, 11320593);
    InitializeEvent(11, 8200, 3, 4500, 50000310, 11400596);
    InitializeEvent(12, 8200, 3, 4520, 50000320, 11400597);
    InitializeEvent(13, 8200, 3, 4510, 50000330, 11400598);
    InitializeEvent(14, 8200, 2, 130, 50000350, 11510595);
    InitializeEvent(15, 8200, 3, 113, 50000360, 11510596);
    InitializeEvent(16, 8200, 2, 102, 50000365, 11510580);
    InitializeEvent(17, 8200, 3, 5910, 50000370, 11510597);
    InitializeEvent(18, 8200, 0, 1366000, 50000375, 11510581);
    InitializeEvent(19, 8200, 0, 904000, 50000380, 11600594);
    InitializeEvent(20, 8200, 3, 102, 50000390, 11600595);
    InitializeEvent(21, 8200, 0, 210000, 50000400, 11600596);
    InitializeEvent(22, 8200, 1, 40000, 50000410, 11600580);
    InitializeEvent(23, 8200, 1, 41000, 50000420, 11600581);
    InitializeEvent(24, 8200, 1, 42000, 50000430, 11600582);
    InitializeEvent(25, 8200, 1, 43000, 50000440, 11600583);
    InitializeEvent(0, 8300, 3, 100, 50000000);
    InitializeEvent(1, 8300, 3, 101, 51100330);
    InitializeEvent(2, 8300, 3, 102, 50000390);
    InitializeEvent(3, 8300, 3, 106, 11017020);
    InitializeEvent(4, 8300, 3, 108, 11607020);
    InitializeEvent(5, 8300, 3, 112, 11407080);
    InitializeEvent(6, 8300, 3, 2508, 11007010);
    InitializeEvent(0, 8090, 3, 510, 11217010);
    InitializeEvent(1, 8090, 3, 511, 11217020);
    InitializeEvent(2, 8090, 3, 512, 11217030);
    InitializeEvent(3, 8090, 3, 513, 11217040);
    InitializeEvent(4, 8090, 3, 514, 11217050);
    
    EndUnconditionally(EventEndType.End);
    SetEventFlag(19900000, ON);
    AwardItemLot(8500);
    AwardItemLot(8507);
    AwardItemLot(8514);
    AwardItemLot(8530);
});

// プリコンストラクタ
Event(50, Default, function() {
    SkipIfEventFlag(80, ON, TargetEventFlagType.EventFlag, 909);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1000, 1029);
    SetEventFlag(1000, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1030, 1059);
    SetEventFlag(1030, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1060, 1089);
    SetEventFlag(1060, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1090, 1109);
    SetEventFlag(1090, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1110, 1119);
    SetEventFlag(1110, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1120, 1139);
    SetEventFlag(1120, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1140, 1169);
    SetEventFlag(1140, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1170, 1189);
    SetEventFlag(1170, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1190, 1209);
    SetEventFlag(1202, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1210, 1219);
    SetEventFlag(1210, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1220, 1229);
    SetEventFlag(1220, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1230, 1239);
    SetEventFlag(1230, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1240, 1249);
    SetEventFlag(1240, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1250, 1259);
    SetEventFlag(1250, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1270, 1279);
    SetEventFlag(1270, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1280, 1289);
    SetEventFlag(1280, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1290, 1309);
    SetEventFlag(1290, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1310, 1319);
    SetEventFlag(1310, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1320, 1339);
    SetEventFlag(1320, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1340, 1359);
    SetEventFlag(1340, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1360, 1379);
    SetEventFlag(1360, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1380, 1399);
    SetEventFlag(1380, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1400, 1409);
    SetEventFlag(1400, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1410, 1419);
    SetEventFlag(1410, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1420, 1429);
    SetEventFlag(1420, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1430, 1459);
    SetEventFlag(1430, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1460, 1489);
    SetEventFlag(1460, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1490, 1539);
    SetEventFlag(1490, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1540, 1569);
    SetEventFlag(1540, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1570, 1599);
    SetEventFlag(1570, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1600, 1619);
    SetEventFlag(1600, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1620, 1639);
    SetEventFlag(1620, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1640, 1669);
    SetEventFlag(1640, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1670, 1679);
    SetEventFlag(1670, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1690, 1699);
    SetEventFlag(1690, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1700, 1709);
    SetEventFlag(1700, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1710, 1729);
    SetEventFlag(1710, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1760, 1769);
    SetEventFlag(1760, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1770, 1779);
    SetEventFlag(1770, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1780, 1789);
    SetEventFlag(1780, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1820, 1839);
    SetEventFlag(1820, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1840, 1859);
    SetEventFlag(1840, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1860, 1869);
    SetEventFlag(1860, ON);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1870, 1889);
    SetEventFlag(1870, ON);
    SkipIfEventFlag(24, ON, TargetEventFlagType.EventFlag, 909);
    SetEventFlag(11807020, ON);
    SetEventFlag(11807030, ON);
    SetEventFlag(11807040, ON);
    SetEventFlag(11807050, ON);
    SetEventFlag(11807060, ON);
    SetEventFlag(11807070, ON);
    SetEventFlag(11807080, ON);
    SetEventFlag(11807090, ON);
    SetEventFlag(11807100, ON);
    SetEventFlag(11807110, ON);
    SetEventFlag(11807120, ON);
    SetEventFlag(11807130, ON);
    SetEventFlag(11807170, ON);
    SetEventFlag(11807180, ON);
    SetEventFlag(11807190, ON);
    SetEventFlag(11807200, ON);
    SetEventFlag(11807210, ON);
    SetEventFlag(11807220, ON);
    SetEventFlag(11807230, ON);
    SetEventFlag(11807240, ON);
    SetEventFlag(11217060, ON);
    SetEventFlag(11217070, ON);
    SetEventFlag(11217080, ON);
    SetEventFlag(11217090, ON);
    SkipIfEventFlag(4, ON, TargetEventFlagType.EventFlag, 909);
    SetEventFlag(909, ON);
    SetEventFlag(814, ON);
    SetEventFlag(50006071, ON);
    SetEventFlag(50006080, ON);
});

// ジェスチャ監視
Event(290, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    BatchSetEventFlags(280, 290, ON);
    IfPlayersClass(OR_01, ClassType.Knight);
    IfPlayersClass(OR_01, ClassType.Cleric);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(AND_02, FAIL, OR_01);
    IfConditionGroup(OR_02, PASS, AND_01);
    IfConditionGroup(OR_02, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_02);
    SkipIfConditionGroupStateCompiled(2, PASS, AND_02);
    SetEventFlag(287, OFF);
    EndUnconditionally(EventEndType.End);
    SetEventFlag(288, OFF);
});

// ベイグラント切り替え
Event(701, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    DisableVagrantSpawning(false);
    IfPlayerInoutMap(MAIN, true, 18, 1);
    DisableVagrantSpawning(true);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11810000);
    DisableVagrantSpawning(false);
});

// 大墓にいる
Event(702, Default, function() {
    SetEventFlag(702, OFF);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11800210);
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(702, ON);
    IfPlayerInoutMap(OR_01, false, 18, 0);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11800210);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(702, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 深淵にいる
Event(717, Default, function() {
    SetEventFlag(717, OFF);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 710);
    IfPlayerInoutMap(AND_01, true, 16, 0);
    IfPlayerStandingOnHit(AND_01, 1603300);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(717, ON);
    IfPlayerStandingOnHit(AND_02, 1603300);
    IfConditionGroup(MAIN, FAIL, AND_02);
    SetEventFlag(717, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 闇に飲まれ死亡監視
Event(718, Default, function() {
    EndIfEventFlag(EventEndType.End, OFF, TargetEventFlagType.EventFlag, 8120);
    DisplayStatusMessage(10010650, Enabled);
    SetEventFlag(8120, OFF);
});

// 篝火転送メニュー 一時禁止
Event(706, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 710);
    SetEventFlag(706, ON);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11705170);
    IfPlayerInoutMap(OR_01, true, 11, 0);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(706, OFF);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11705170);
    IfPlayerInoutMap(AND_01, false, 11, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    EndUnconditionally(EventEndType.Restart);
});

// 王の器 所持チェック
Event(710, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfPlayerHasdoesntHaveItem(MAIN, ItemType.Goods, 2510, OwnershipState.Owns);
    SetEventFlag(710, ON);
});

// 偉大なソウル 所持チェック
Event(711, Default, function(X0_4, X4_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfPlayerHasdoesntHaveItem(MAIN, ItemType.Goods, X0_4, OwnershipState.Owns);
    SetEventFlag(X4_4, ON);
});

// 大王グウィンのソウル 所持チェック
Event(715, Default, function() {
    SetEventFlag(715, OFF);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11010595);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 702, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItemIncludingBbox(AND_01, ItemType.Goods, 5520, OwnershipState.DoesntOwn);
    IfPlayersCovenant(AND_01, 3);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(715, ON);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 702, OwnershipState.DoesntOwn);
    IfPlayerHasdoesntHaveItemIncludingBbox(OR_01, ItemType.Goods, 5520, OwnershipState.Owns);
    IfPlayersCovenant(AND_02, 3);
    IfConditionGroup(OR_01, FAIL, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    EndUnconditionally(EventEndType.Restart);
});

// エスト瓶を入手したことがある
Event(716, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 50000082);
    SetEventFlag(716, ON);
});

// エスト瓶強化状況監視_XX
Event(8131, Default, function(X0_4, X4_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, X0_4, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, X4_4, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfComparison(1, ComparisonType.NotEqual, X0_4, 202);
    SetEventFlag(8131, ON);
    SkipIfComparison(1, ComparisonType.NotEqual, X0_4, 204);
    BatchSetEventFlags(8131, 8132, ON);
    SkipIfComparison(1, ComparisonType.NotEqual, X0_4, 206);
    BatchSetEventFlags(8131, 8133, ON);
    SkipIfComparison(1, ComparisonType.NotEqual, X0_4, 208);
    BatchSetEventFlags(8131, 8134, ON);
    SkipIfComparison(1, ComparisonType.NotEqual, X0_4, 210);
    BatchSetEventFlags(8131, 8135, ON);
    SkipIfComparison(1, ComparisonType.NotEqual, X0_4, 212);
    BatchSetEventFlags(8131, 8136, ON);
    SkipIfComparison(1, ComparisonType.NotEqual, X0_4, 214);
    BatchSetEventFlags(8131, 8137, ON);
});

// 修理箱フラグ同期監視
Event(819, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11017040);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11017170);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(11017040, ON);
    SetEventFlag(11017170, ON);
});

// スクロール所持監視
Event(719, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3000, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3010, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3020, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3030, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3040, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3050, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3060, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3070, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3100, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3110, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3120, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3300, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3310, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3400, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3410, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3500, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3510, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3520, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3530, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3540, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3550, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3600, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3610, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3700, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4000, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4010, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4020, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4030, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4040, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4050, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4060, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4100, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4110, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4200, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4210, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4220, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4300, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4310, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4360, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4400, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4500, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4510, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4520, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5000, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5010, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5020, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5030, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5040, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5050, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5100, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5110, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5200, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5210, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5300, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5310, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5320, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5400, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5500, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5510, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5520, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5600, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5610, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5700, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5710, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5800, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5810, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5900, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 5910, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3710, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3720, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3730, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 3740, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4530, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(719, ON);
});

// 上位呪術スクロール所持監視
Event(720, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4020, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4030, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4040, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4060, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4110, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4500, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4510, OwnershipState.Owns);
    IfPlayerHasdoesntHaveItem(OR_01, ItemType.Goods, 4520, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(11020102, ON);
});

// ニト傾向禁止開始
Event(730, Default, function() {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 732);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 8000);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(732, ON);
    SetEventFlag(735, ON);
    EndUnconditionally(EventEndType.Restart);
});

// ニト傾向禁止解除
Event(731, Default, function() {
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 8000);
    SetEventFlag(732, OFF);
    SetEventFlag(735, OFF);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 8000);
    EndUnconditionally(EventEndType.Restart);
});

// 篝火メニュー開放チェック
Event(250, Default, function(X0_4, X4_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfPlayerHasdoesntHaveItem(MAIN, ItemType.Goods, X0_4, OwnershipState.Owns);
    SetEventFlag(X4_4, ON);
});

// 強化メニュー開放チェック
Event(350, Default, function(X0_4, X4_4) {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, X4_4, OwnershipState.Owns);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, AND_01);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    RemoveItemFromPlayer(ItemType.Goods, X4_4, 1);
});

// 強化素材XX_所持チェック
Event(780, Default, function(X0_4, X4_4) {
    SetEventFlag(X4_4, OFF);
    IfPlayerHasdoesntHaveItem(MAIN, ItemType.Goods, X0_4, OwnershipState.Owns);
    SetEventFlag(X4_4, ON);
    IfPlayerHasdoesntHaveItem(MAIN, ItemType.Goods, X0_4, OwnershipState.DoesntOwn);
    EndUnconditionally(EventEndType.Restart);
});

// 誓約ショップ解放チェック
Event(870, Default, function(X0_1, X4_4) {
    IfPlayersCovenant(MAIN, X0_1);
    SetEventFlag(X4_4, ON);
    IfPlayersCovenant(AND_01, X0_1);
    IfConditionGroup(MAIN, FAIL, AND_01);
    SetEventFlag(X4_4, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// Notice表示XX
Event(260, Default, function(X0_4, X4_4, X8_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X0_4);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    WaitFixedTimeSeconds(X8_4);
    DisplayStatusMessage(X4_4, Enabled);
});

// ボス撃破 アイテム取得_XX
Event(970, Default, function(X0_4, X4_4, X8_4, X12_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X0_4);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    SkipIfComparison(1, ComparisonType.Equal, X4_4, 0);
    AwardItemsIncludingClients(X4_4);
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(5);
    SkipIfComparison(1, ComparisonType.Equal, X8_4, 0);
    AwardItemsIncludingClients(X8_4);
    SkipIfComparison(1, ComparisonType.Equal, X12_4, 0);
    AwardItemsIncludingClients(X12_4);
});

// NPC アイテムXX進呈
Event(911, Default, function(X0_4, X4_4, X8_1) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X0_4);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    AwardItemsIncludingClients(X4_4);
    SetEventFlag(X0_4, X8_1);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X0_4);
    EndUnconditionally(EventEndType.Restart);
});

// NPC アイテムXX進呈2
Event(890, Default, function(X0_4, X4_4, X8_1) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X0_4);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    AwardItemsIncludingClients(X4_4);
    SetEventFlag(X0_4, X8_1);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X0_4);
    EndUnconditionally(EventEndType.Restart);
});

// NPC アイテムXX強奪
Event(960, Default, function(X0_4, X4_4, X8_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterDeadalive(AND_01, X4_4, DeathState.Dead);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(X8_4);
});

// 誓約アイテム所持監視_XX
Event(8200, Default, function(X0_1, X4_4, X8_4, X12_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X8_4);
    IfGameCycle(AND_01, ComparisonType.GreaterOrEqual, 1);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, AND_01);
    IfPlayerHasdoesntHaveItemIncludingBbox(AND_02, X0_1, X4_4, OwnershipState.Owns);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, AND_02);
    SetEventFlag(X8_4, ON);
    SetEventFlag(X12_4, ON);
});

// システムアイテム所持監視_XX
Event(8300, Default, function(X0_1, X4_4, X8_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X8_4);
    IfGameCycle(AND_01, ComparisonType.GreaterOrEqual, 1);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, AND_01);
    IfPlayerHasdoesntHaveItemIncludingBbox(AND_02, X0_1, X4_4, OwnershipState.Owns);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, AND_02);
    SetEventFlag(X8_4, ON);
});

// システムアイテム所持監視2_XX
Event(8090, Default, function(X0_1, X4_4, X8_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, X8_4);
    IfGameCycle(AND_01, ComparisonType.GreaterOrEqual, 1);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, AND_01);
    IfPlayerHasdoesntHaveItemIncludingBbox(AND_02, X0_1, X4_4, OwnershipState.Owns);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, AND_02);
    SetEventFlag(X8_4, ON);
});

// NPC たまごくだし進呈監視
Event(910, Default, function(X0_4, X4_4) {
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, X0_4);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    AwardItemsIncludingClients(X4_4);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, X0_4);
    EndUnconditionally(EventEndType.Restart);
});

// クリアカウント監視XX
Event(690, Default, function(X0_4, X4_4, X8_4, X12_4) {
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X12_4);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 2);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 2);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 3);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 3);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 4);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 4);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 5);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 5);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 6);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 6);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 7);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 7);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 8);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 8);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 9);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 9);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 10);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 10);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 11);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 12);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 12);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 13);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 13);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 14);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 14);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 15);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 15);
    IfConditionGroup(MAIN, PASS, OR_01);
    IncrementEventValue(X0_4, X4_4, X8_4);
    EndUnconditionally(EventEndType.Restart);
});

// SOLDOUT監視（ロガーン）
Event(721, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 728);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707000);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707010);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707020);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707030);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707040);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707050);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707060);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11707070);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(721, ON);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11707090);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11707100);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11707110);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetEventFlag(728, ON);
});

// SOLDOUT監視（さまよう混沌）
Event(722, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407120);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407130);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407150);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407160);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407170);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407140);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407180);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11407190);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 10);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Weapon, 1332500, OwnershipState.Owns);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(722, ON);
});

// SOLDOUT監視（ロガーン弟子）
Event(723, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027130);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027140);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027150);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027160);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027170);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027180);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027190);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027200);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027210);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027220);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027230);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11027240);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(723, ON);
});

// SOLDOUT監視（白の聖女）
Event(724, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017050);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017060);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017070);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017080);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017090);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017100);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017110);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017120);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11017130);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(724, ON);
});

// SOLDOUT監視（トリックスター・影町）
Event(725, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfCountEventFlags(MAIN, TargetEventFlagType.EventFlag, 11707100, 11707190, ComparisonType.GreaterOrEqual, 2);
    SetEventFlag(725, ON);
});

// SOLDOUT監視（トリックスター・深淵）
Event(726, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfCountEventFlags(MAIN, TargetEventFlagType.EventFlag, 11607000, 11607090, ComparisonType.GreaterOrEqual, 2);
    SetEventFlag(726, ON);
});

// SOLDOUT監視（トリックスター・地底湖）
Event(727, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327000);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327010);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327020);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327030);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327040);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327050);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327060);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327070);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327080);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11327090);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(727, ON);
});

// 生まれ監視 呪術師
Event(740, Default, function() {
    IfPlayersClass(MAIN, ClassType.Pyromancer);
    SetEventFlag(740, ON);
});

// 野武士or忍者を手にかけた
Event(745, Default, function() {
    IfEventFlag(AND_07, ON, TargetEventFlagType.EventFlag, 1604);
    IfEventFlag(AND_07, ON, TargetEventFlagType.EventFlag, 1764);
    SkipIfConditionGroupStateUncompiled(1, FAIL, AND_07);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 703);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 1604);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1604);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 1764);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1764);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    EndUnconditionally(EventEndType.End);
});

// 解呪イベント
Event(754, Default, function() {
    SetEventFlag(754, OFF);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 754);
    SetEventFlag(754, OFF);
    SetSpeffect(10000, 4600);
    SetSpeffect(10000, 4601);
    SpawnOneshotSFX(TargetEntityType.Character, 10000, 7, 22715);
    EndUnconditionally(EventEndType.Restart);
});

// 免罪イベント
Event(770, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 755);
    SetEventFlag(755, OFF);
    SetEventFlag(742, OFF);
    SetEventFlag(743, OFF);
    SetEventFlag(744, OFF);
    SetEventFlag(745, OFF);
    SetEventFlag(746, OFF);
    BatchSetEventFlags(11000501, 11000519, OFF);
    BatchSetEventFlags(11010501, 11010519, OFF);
    BatchSetEventFlags(11020501, 11020529, OFF);
    BatchSetEventFlags(11100501, 11100519, OFF);
    BatchSetEventFlags(11200501, 11200519, OFF);
    BatchSetEventFlags(11300501, 11300519, OFF);
    BatchSetEventFlags(11310501, 11310519, OFF);
    BatchSetEventFlags(11320501, 11320519, OFF);
    BatchSetEventFlags(11400501, 11400519, OFF);
    BatchSetEventFlags(11410501, 11410519, OFF);
    BatchSetEventFlags(11500501, 11500519, OFF);
    BatchSetEventFlags(11510501, 11510519, OFF);
    BatchSetEventFlags(11600501, 11600519, OFF);
    BatchSetEventFlags(11700501, 11700519, OFF);
    BatchSetEventFlags(11800501, 11800519, OFF);
    BatchSetEventFlags(11810501, 11810519, OFF);
    BatchSetEventFlags(11210501, 11210519, OFF);
    SetEventFlag(1004, OFF);
    SetEventFlag(1033, OFF);
    SetEventFlag(1096, OFF);
    SetEventFlag(1114, OFF);
    SetEventFlag(1176, OFF);
    SetEventFlag(1179, OFF);
    SetEventFlag(1195, OFF);
    SetEventFlag(1197, OFF);
    SetEventFlag(1213, OFF);
    SetEventFlag(1223, OFF);
    SetEventFlag(1241, OFF);
    SetEventFlag(1253, OFF);
    SetEventFlag(1282, OFF);
    SetEventFlag(1283, OFF);
    SetEventFlag(1287, OFF);
    SetEventFlag(1294, OFF);
    SetEventFlag(1314, OFF);
    SetEventFlag(1321, OFF);
    SetEventFlag(1341, OFF);
    SetEventFlag(1361, OFF);
    SetEventFlag(1381, OFF);
    SetEventFlag(1401, OFF);
    SetEventFlag(1411, OFF);
    SetEventFlag(1421, OFF);
    SetEventFlag(1434, OFF);
    SetEventFlag(1461, OFF);
    SetEventFlag(1512, OFF);
    SetEventFlag(1547, OFF);
    SetEventFlag(1574, OFF);
    SetEventFlag(1603, OFF);
    SetEventFlag(1627, OFF);
    SetEventFlag(1646, OFF);
    SetEventFlag(1675, OFF);
    SetEventFlag(1691, OFF);
    SetEventFlag(1710, ON);
    SetEventFlag(1711, OFF);
    SetEventFlag(1712, OFF);
    SetEventFlag(11200596, OFF);
    SetEventFlag(71200035, OFF);
    SetEventFlag(71200042, OFF);
    SetEventFlag(1763, OFF);
    SetEventFlag(1822, OFF);
    SetEventFlag(1841, OFF);
    SetEventFlag(1863, OFF);
    SetEventFlag(1871, OFF);
    SetCharacterTeamType(6001, TeamType.Ally);
    SetCharacterTeamType(6040, TeamType.Ally);
    SetCharacterTeamType(6072, TeamType.Ally);
    SetCharacterTeamType(6190, TeamType.Ally);
    SetCharacterTeamType(6230, TeamType.Ally);
    SetCharacterTeamType(6300, TeamType.Ally);
    EndUnconditionally(EventEndType.Restart);
});

// 罪人
Event(772, Default, function() {
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 744);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1004);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1033);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1096);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1114);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1176);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1179);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1195);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1197);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1213);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1223);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1241);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1253);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1282);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1283);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1287);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1294);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1314);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1321);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1341);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1361);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1381);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1401);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1411);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1421);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1434);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1461);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1512);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1547);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1574);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1603);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1627);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1646);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1675);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1691);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1711);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1712);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 71200035);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 71200042);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1763);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1822);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1841);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1863);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1871);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(744, ON);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 744);
    EndUnconditionally(EventEndType.Restart);
});

// 人間性捧げる監視
Event(761, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 760);
    WaitFixedTimeFrames(200);
    SetEventFlag(760, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 復活する監視
Event(763, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 762);
    ForceAnimationPlayback(10000, 7697, false, false, false);
    WaitFixedTimeSeconds(3.5);
    SetEventFlag(762, OFF);
    WaitFixedTimeSeconds(2.8);
    SetEventFlag(764, OFF);
    ForceAnimationPlayback(10000, 7701, true, false, false);
    EndUnconditionally(EventEndType.Restart);
});

// 呪い状態監視
Event(750, Default, function() {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(OR_01, 10000, 71, true);
    IfCharacterHasSpeffect(OR_01, 10000, 72, true);
    IfCharacterHasSpeffect(OR_01, 10000, 73, true);
    IfCharacterHasSpeffect(OR_01, 10000, 74, true);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 751);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(751, ON);
    IfCharacterHasSpeffect(AND_01, 10000, 71, false);
    IfCharacterHasSpeffect(AND_01, 10000, 72, false);
    IfCharacterHasSpeffect(AND_01, 10000, 73, false);
    IfCharacterHasSpeffect(AND_01, 10000, 74, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(751, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 卵状態監視
Event(752, Default, function() {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(OR_01, 10000, 5213, true);
    IfCharacterHasSpeffect(OR_01, 10000, 5214, true);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 753);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(753, ON);
    IfCharacterHasSpeffect(AND_01, 10000, 5213, false);
    IfCharacterHasSpeffect(AND_01, 10000, 5214, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(753, OFF);
    SetEventFlag(11400591, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 呪死監視
Event(757, Default, function() {
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 757);
    DisplayStatusMessage(10010660, Enabled);
    SetEventFlag(757, OFF);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfCharacterHasSpeffect(AND_01, 10000, 71, false);
    IfCharacterHasSpeffect(AND_01, 10000, 72, false);
    IfCharacterHasSpeffect(AND_01, 10000, 73, false);
    IfCharacterHasSpeffect(AND_01, 10000, 74, false);
    IfCharacterHasSpeffect(OR_01, 10000, 33, true);
    IfCharacterHasSpeffect(OR_01, 10000, 34, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    EndUnconditionally(EventEndType.End);
});

// 犠牲死亡監視
Event(758, Default, function() {
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventID, 0);
    DisplayStatusMessage(10010670, Enabled);
    SetEventFlag(758, OFF);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfHPRatio(AND_01, 10000, ComparisonType.LessOrEqual, 0);
    IfCharacterHasSpeffect(AND_01, 10000, 2130, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfMultiplayerState(AND_02, MultiplayerState.Host);
    IfCharacterDeadalive(AND_02, 10000, DeathState.Dead);
    IfCharacterHasSpeffect(AND_02, 10000, 2130, false);
    IfConditionGroup(MAIN, PASS, AND_02);
    EndUnconditionally(EventEndType.End);
});

// 尊い犠牲死亡監視
Event(759, Default, function() {
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventID, 0);
    DisplayStatusMessage(10010680, Enabled);
    SetEventFlag(759, OFF);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfHPRatio(AND_01, 10000, ComparisonType.LessOrEqual, 0);
    IfCharacterHasSpeffect(AND_01, 10000, 2131, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    IfMultiplayerState(AND_02, MultiplayerState.Host);
    IfCharacterDeadalive(AND_02, 10000, DeathState.Dead);
    IfCharacterHasSpeffect(AND_02, 10000, 2131, false);
    IfConditionGroup(MAIN, PASS, AND_02);
    EndUnconditionally(EventEndType.End);
});

// 黒い瞳のオーブ監視
Event(818, Default, function() {
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11510150);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11510150);
    DisplayStatusMessage(10010690, Enabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11510150);
    IfPlayerInoutMap(AND_01, false, 15, 1);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11510150, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 灰色の聖女の魂 監視
Event(810, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 50001031);
    SetEventFlag(810, ON);
});

// 火防女の魂 所持監視XX
Event(812, Default, function(X0_4) {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    EndUnconditionally(EventEndType.End);
});

// 大墓フラムト監視
Event(822, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 830);
    IfElapsedSeconds(AND_01, 0.5);
    IfPlayerInoutMap(AND_01, false, 18, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(830, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 大墓カアス監視
Event(823, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 831);
    IfElapsedSeconds(AND_01, 0.5);
    IfPlayerInoutMap(AND_01, false, 18, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(831, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 誓約イベント_XX
Event(840, Default, function(X0_4, X4_4, X8_4, X12_4) {
    SetEventFlag(X0_4, OFF);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, X0_4);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 844);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 847);
    RotateCharacter(10000, X8_4);
    ForceAnimationPlayback(10000, X4_4, false, false, false);
    WaitFixedTimeSeconds(1);
    PlaySE(10000, SoundType.sSFX, 123456789);
    WaitFixedTimeSeconds(4);
    SkipIfComparison(1, ComparisonType.Equal, X12_4, -1);
    ForceAnimationPlayback(10000, X12_4, true, false, false);
    EndUnconditionally(EventEndType.Restart);
});

// オフラインモードか
Event(766, Default, function() {
    IfOnlineMode(AND_01, true);
    EndIfConditionGroupStateUncompiled(EventEndType.End, PASS, AND_01);
    SetEventFlag(765, ON);
});

// NoGrav
Event(999, Default, function() {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(MAIN, 10000, 9086, true);
    SetCharacterGravity(10000, Disabled);
    IfCharacterHasSpeffect(MAIN, 10000, 9086, false);
    SetCharacterGravity(10000, Enabled);
    EndUnconditionally(EventEndType.Restart);
});

// Needler Tracking
Event(998, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(MAIN, X0_4, 9375, true);
    
    ClearSpeffect(X0_4, 9375);
    
    IfCharacterHasSpeffect(AND_01, X0_4, 9376, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    SetSpeffect(X0_4, 9376);
    EndUnconditionally(EventEndType.Restart);
    
    IfCharacterHasSpeffect(AND_02, X0_4, 9377, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);
    SetSpeffect(X0_4, 9377);
    EndUnconditionally(EventEndType.Restart);
    
    IfCharacterHasSpeffect(AND_03, X0_4, 9378, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_03);
    SetSpeffect(X0_4, 9378);
    EndUnconditionally(EventEndType.Restart);
    
    IfCharacterHasSpeffect(AND_04, X0_4, 9379, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_04);
    SetSpeffect(X0_4, 9379);
    EndUnconditionally(EventEndType.Restart);
    
    IfCharacterHasSpeffect(AND_05, X0_4, 9380, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_05);
    SetSpeffect(X0_4, 9380);
    EndUnconditionally(EventEndType.Restart);
    
    IfCharacterHasSpeffect(AND_06, X0_4, 9381, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_06);
    SetSpeffect(X0_4, 9381);
    EndUnconditionally(EventEndType.Restart);
    
    IfCharacterHasSpeffect(AND_07, X0_4, 9382, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_07);
    SetSpeffect(X0_4, 9382);
    EndUnconditionally(EventEndType.Restart);
    
    //IfCharacterHasSpeffect(OR_01, X0_4, 9383, true);
    //SkipIfConditionGroupStateUncompiled(2, PASS, OR_01);
    //SetSpeffect(X0_4, 9383);
    //EndUnconditionally(EventEndType.Restart);
    
    //IfCharacterHasSpeffect(OR_02, X0_4, 9384, true);
    //SkipIfConditionGroupStateUncompiled(2, PASS, OR_02);
    //SetSpeffect(X0_4, 9384);
    //EndUnconditionally(EventEndType.Restart);
    
    EndUnconditionally(EventEndType.Restart);
});

// Needler Detonate
Event(997, Default, function(X0_4) {
    IfCharacterHasSpeffect(AND_01, X0_4, 9376, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9377, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9378, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9379, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9380, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9381, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9382, true);
    //IfCharacterHasSpeffect(AND_01, X0_4, 9383, true);
    //IfCharacterHasSpeffect(AND_01, X0_4, 9384, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(X0_4, 9374);
    ClearSpeffect(X0_4, 9376);
    ClearSpeffect(X0_4, 9377);
    ClearSpeffect(X0_4, 9378);
    ClearSpeffect(X0_4, 9379);
    ClearSpeffect(X0_4, 9380);
    ClearSpeffect(X0_4, 9381);
    ClearSpeffect(X0_4, 9382);
    //ClearSpeffect(X0_4, 9383);
    //ClearSpeffect(X0_4, 9384);
    
    EndUnconditionally(EventEndType.Restart);
});


/* Gun Stuff */
// 19900000 - Ammo Unlock
// ...
// 19900010 - SMG Unlock
// 19900011 - Magnum Unlock
// 19900012 - Battle Rifle Unlock
// ...
// 19900030 - Multiplayer Guns Enabled
// 19900031 - Multiplayer Lethal Damage Mode
// 19900032 - Multiplayer No Lock-On
// 19900033 - Multiplayer Free-For-All

/* Ammo Stock Check */
Event(996, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 19900000);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Weapon, 2200000, OwnershipState.DoesntOwn);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 19900030);
    IfPlayerHasdoesntHaveItem(AND_02, ItemType.Weapon, 2200000, OwnershipState.DoesntOwn);
    
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    
    SetSpeffect(10000, 9400);
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* Give Ammo Unsync */
Event(995, Default, function() {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(MAIN, 10000, 9400, true);
    ClearSpeffect(10000, 9400);
    AwardItemsIncludingClients(8520);
    EndUnconditionally(EventEndType.Restart);
});

/* Ammo Ban Check */
Event(994, Default, function() {
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Weapon, 2200000, OwnershipState.Owns);
    IfEventFlag(OR_01, OFF, TargetEventFlagType.EventFlag, 19900000);
    IfEventFlag(OR_02, ON, TargetEventFlagType.EventFlag, 19900030);
    IfMultiplayerState(OR_02, MultiplayerState.Singleplayer);
    IfConditionGroup(OR_01, FAIL, OR_02);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    RemoveItemFromPlayer(ItemType.Weapon, 2200000, 999);
    WaitFixedTimeFrames(90);
    
    EndUnconditionally(EventEndType.Restart);
});

/* Multiplayer Enable Guns : Set */
Event(993, Default, function() {
    IfCharacterHasSpeffect(MAIN, 10000, 9410, true);
    SetEventFlag(19900030, ON);
});

/* Multiplayer Enable Guns : Message */
Event(992, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 19900030);
    DisplayGenericDialog(9020, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
});

/* Resync Jank */
Event(990, Default, function(X0_4) {
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(X0_4, ON);
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* Grenade Limit Tracking */
Event(989, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    
    IfCharacterHasSpeffect(MAIN, X0_4, 9391, true);
    WaitFixedTimeFrames(15);
    ClearSpeffect(X0_4, 9391);
    
    IfCharacterHasSpeffect(AND_01, X0_4, 9392, true);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    SetSpeffect(X0_4, 9392);
    EndUnconditionally(EventEndType.Restart);
    
    SetSpeffect(X0_4, 9393);
    EndUnconditionally(EventEndType.Restart);
});

/* Grenade Limit On */
Event(988, Default, function(X0_4) {
    IfCharacterHasSpeffect(AND_01, X0_4, 9392, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9393, true);
    IfCharacterHasSpeffect(AND_02, X0_4, 9390, false);
    IfConditionGroup(AND_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(X0_4, 9390);
    
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* Grenade Limit Off */
Event(987, Default, function(X0_4) {
    IfCharacterHasSpeffect(AND_01, X0_4, 9392, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9393, true);
    IfCharacterHasSpeffect(AND_02, X0_4, 9390, true);
    IfConditionGroup(AND_02, FAIL, AND_01);
    IfConditionGroup(MAIN, PASS, AND_02);
    ClearSpeffect(X0_4, 9390);
    
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* Gun Left-Hand Warning */
Event(986, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    
    IfCharacterHasSpeffect(AND_01, X0_4, 9351, true);
    IfCharacterHasSpeffect(AND_01, X0_4, 9352, true);
    IfConditionGroup(OR_01, PASS, AND_01);
    
    IfCharacterHasSpeffect(AND_02, X0_4, 9352, true);
    IfCharacterHasSpeffect(AND_02, X0_4, 9353, true);
    IfConditionGroup(OR_01, PASS, AND_02);
    
    IfCharacterHasSpeffect(AND_03, X0_4, 9351, true);
    IfCharacterHasSpeffect(AND_03, X0_4, 9353, true);
    IfConditionGroup(OR_01, PASS, AND_03);
    
    IfConditionGroup(MAIN, PASS, OR_01);
    DisplayGenericDialog(9025, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    
    WaitFixedTimeSeconds(10.0);
    EndUnconditionally(EventEndType.Restart);
});


/* Disable unsupported Speffs */
Event(985, Default, function(X0_4, X4_4) {
    SetNetworkSyncState(Disabled);
    
    IfCharacterHasSpeffect(OR_01, X0_4, 9351, true);
    IfCharacterHasSpeffect(OR_01, X0_4, 9352, true);
    IfCharacterHasSpeffect(OR_01, X0_4, 9353, true);
    
    IfCharacterHasSpeffect(AND_01, X0_4, X4_4, true);
    IfConditionGroup(AND_01, PASS, OR_01);

    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(X0_4, X4_4);
    
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});


/* Multiplayer Lethal : Set */
Event(984, Default, function() {
    IfCharacterHasSpeffect(MAIN, 10000, 9411, true);
    SetEventFlag(19900031, ON);
});

/* Multiplayer Lethal : Message */
Event(983, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 19900031);
    DisplayGenericDialog(9021, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
});

/* Multiplayer Lethal : Apply */
Event(976, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 19900031);
    ClearSpeffect(10000, 1520); // No dragons
    ClearSpeffect(10000, 1530);
    ClearSpeffect(10000, 6310); // No thorns
    ClearSpeffect(10000, 6320);
    ClearSpeffect(10000, 6330);
    ClearSpeffect(10000, 6340);
    SetSpeffect(10000, 9412);
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* Multiplayer No Lock : Set */
Event(982, Default, function() {
    IfCharacterHasSpeffect(MAIN, 10000, 9413, true);
    SetEventFlag(19900032, ON);
});

/* Multiplayer No Lock : Message */
Event(981, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 19900032);
    DisplayGenericDialog(9022, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    SetLockcamSlotNumber(10, 3, 1);
});

/* Multiplayer FreeForAll : Set */
Event(980, Default, function() {
    IfCharacterHasSpeffect(MAIN, 10000, 9415, true);
    SetEventFlag(19900033, ON);
    SetSpeffect(10000, 9416);
});

/* Multiplayer FreeForAll : Message */
Event(979, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 19900033);
    DisplayGenericDialog(9023, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
});

/* Multiplayer FreeForAll : Apply Speff */
Event(978, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 19900033);
    SetCharacterTeamType(10000, 16);
    SetSpeffect(10000, 9416);
    
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* Multipaler FreeForAll : Apply Speff */
Event(974, Default, function() {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(AND_01, 10000, 9416, true);
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, FAIL, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    EzstateInstructionRequest(10000, 6969, 2);
    
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

Event(977, Default, function() {
    IfCharacterType(OR_01, 10000, TargetType.Alive);
    IfCharacterType(OR_01, 10000, TargetType.Hollow);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(19900030, OFF);  // Gametype modifiers
    SetEventFlag(19900031, OFF);
    SetEventFlag(19900032, OFF);
    SetEventFlag(19900033, OFF);
});

Event(950, Default, function() {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(AND_01, 10000, 1530, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9450, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9450);
    EndUnconditionally(EventEndType.Restart);
});

/* Energy Sword Damage Mod */
Event(949, Default, function() {
    IfCharacterHasSpEffect(AND_01, 10000, 9325, true);
    IfCharacterHasSpEffect(AND_01, 10000, 9412, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    ClearSpEffect(10000, 9325);
    SetSpEffect(10000, 9326);
    
    EndUnconditionally(EventEndType.Restart);
});

Event(975, Default, function() {
    InitializeEvent(0, 977, 0);
    
    /* Game settings stuff */
    InitializeEvent(0, 992, 0);
    InitializeEvent(0, 994, 0);
    InitializeEvent(0, 995, 0);
    InitializeEvent(0, 996, 0);
    
    InitializeEvent(0, 983, 0);
    InitializeEvent(0, 981, 0);
    InitializeEvent(0, 979, 0);
    InitializeEvent(0, 978, 0);
    InitializeEvent(0, 976, 0);
    InitializeEvent(0, 974, 0);
    
    /* pls */
    InitializeEvent(0, 993, 0);
    InitializeEvent(0, 984, 0);
    InitializeEvent(0, 982, 0);
    InitializeEvent(0, 980, 0);
    
    InitializeEvent(0, 990, 19900000, 0);
    InitializeEvent(1, 990, 19900030, 0);
    InitializeEvent(2, 990, 19900031, 0);
    InitializeEvent(3, 990, 19900032, 0);
    InitializeEvent(4, 990, 19900033, 0);
});
