// ==EMEVD==
// @docs    ds1-common.emedf.json
// @compress    None
// @game    DarkSouls1
// @string    
// @linked    []
// @version    3.2.2
// ==/EMEVD==

// コンストラクタ
Event(0, Default, function() {
    InitializeEvent(0, 11509050, 0);
    InitializeEvent(0, 11508001, 0);
    CreateBulletOwner(1500200);
    SetNetworkUpdateRate(1500100, true, CharacterUpdateFrequency.AlwaysUpdate);
    RegisterBonfire(11500984, 1501961, 2, 180, 0);
    RegisterLadder(11500010, 11500011, 1501140);
    RegisterLadder(11500012, 11500013, 1501141);
    RegisterLadder(11500014, 11500015, 1501142);
    RegisterLadder(11500016, 11500017, 1501143);
    SkipIfMultiplayerState(2, MultiplayerState.Host);
    SetEventFlag(11505240, ON);
    SetEventFlag(11505360, OFF);
    SkipIfMultiplayerState(2, MultiplayerState.Client);
    DeactivateObject(1501994, Disabled);
    DeleteMapSFX(1501995, false);
    ActivateHit(1503210, Disabled);
    DeactivateObject(1501800, Disabled);
    DeactivateObject(1501801, Disabled);
    DeactivateObject(1501802, Disabled);
    DeactivateObject(1501803, Disabled);
    DeactivateObject(1501804, Disabled);
    DeactivateObject(1501805, Disabled);
    DeactivateObject(1501806, Disabled);
    DeactivateObject(1501807, Disabled);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 11500803);
    ReproduceObjectAnimation(1501790, 3);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11500806);
    ReproduceObjectAnimation(1501790, 0);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11500809);
    ReproduceObjectAnimation(1501790, 1);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11500812);
    ReproduceObjectAnimation(1501790, 2);
    ActivateHit(1503200, Disabled);
    ActivateHit(1503201, Disabled);
    ActivateHit(1503202, Disabled);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500821);
    DeactivateObject(1501801, Enabled);
    ReproduceObjectAnimation(1501801, 5);
    ActivateHit(1503200, Enabled);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500822);
    DeactivateObject(1501802, Enabled);
    ReproduceObjectAnimation(1501802, 6);
    ActivateHit(1503201, Enabled);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500823);
    DeactivateObject(1501803, Enabled);
    ReproduceObjectAnimation(1501803, 7);
    ActivateHit(1503202, Enabled);
    SkipIfEventFlag(21, OFF, TargetEventFlagType.EventFlag, 11500100);
    SkipIfEventFlag(10, ON, TargetEventFlagType.EventFlag, 11500101);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503110, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503111, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503112, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503113, NavimeshType.WalltouchingFloor, BitopType.Add);
    ReproduceObjectAnimation(1501011, 12);
    SkipUnconditionally(9);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503110, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503111, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503112, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503113, NavimeshType.Wall, BitopType.Add);
    ReproduceObjectAnimation(1501011, 11);
    SkipUnconditionally(4);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Solid, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Solid, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Solid, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Solid, BitopType.Add);
    InitializeEvent(0, 11500090, 1501700, 1501701, 1502600, 1502601);
    InitializeEvent(1, 11500090, 1501702, 1501703, 1502602, 1502603);
    InitializeEvent(0, 11505090, 0);
    InitializeEvent(0, 11505091, 0);
    InitializeEvent(0, 11505092, 0);
    InitializeEvent(0, 11500201, 0);
    InitializeEvent(0, 11505300, 0);
    InitializeEvent(0, 11500840, 0);
    InitializeEvent(0, 11500841, 11500803);
    InitializeEvent(1, 11500841, 11500806);
    InitializeEvent(2, 11500841, 11500809);
    InitializeEvent(3, 11500841, 11500812);
    InitializeEvent(0, 11500790, 0);
    InitializeEvent(0, 11500791, 0);
    InitializeEvent(0, 11500795, 0);
    InitializeEvent(0, 11500796, 0);
    InitializeEvent(0, 11500797, 0);
    InitializeEvent(0, 11500798, 0);
    InitializeEvent(0, 11500830, 0);
    InitializeEvent(0, 11500831, 0);
    InitializeEvent(0, 11500850, 0);
    InitializeEvent(0, 11505255, 0);
    InitializeEvent(0, 11500100, 0);
    InitializeEvent(0, 11500102, 0);
    InitializeEvent(0, 11500103, 0);
    InitializeEvent(0, 11500106, 0);
    InitializeEvent(0, 11500107, 0);
    InitializeEvent(0, 11500110, 1501030, 11500110);
    InitializeEvent(1, 11500110, 1501031, 11500111);
    InitializeEvent(2, 11500110, 1501032, 11500112);
    InitializeEvent(3, 11500110, 1501033, 11500113);
    InitializeEvent(5, 11500110, 1501035, 11500115);
    InitializeEvent(6, 11500110, 1501036, 11500116);
    InitializeEvent(0, 11505050, 0);
    InitializeEvent(0, 11505051, 0);
    InitializeEvent(0, 11505055, 0);
    InitializeEvent(0, 11505110, 0);
    InitializeEvent(0, 11505101, 0);
    InitializeEvent(0, 11505102, 0);
    InitializeEvent(0, 11505111, 11505111, 1502700, 1);
    InitializeEvent(1, 11505111, 11505112, 1502701, 2);
    InitializeEvent(2, 11505111, 11505113, 1502702, 3);
    InitializeEvent(3, 11505111, 11505114, 1502703, 4);
    InitializeEvent(4, 11505111, 11505115, 1502704, 5);
    InitializeEvent(5, 11505111, 11505116, 1502705, 6);
    InitializeEvent(6, 11505111, 11505117, 1502710, -1);
    InitializeEvent(0, 11505060, 1500100);
    InitializeEvent(1, 11505060, 1500101);
    InitializeEvent(2, 11505060, 1500102);
    InitializeEvent(0, 11505070, 1500100);
    InitializeEvent(1, 11505070, 1500101);
    InitializeEvent(2, 11505070, 1500102);
    InitializeEvent(0, 11505080, 0);
    InitializeEvent(0, 11500210, 0);
    InitializeEvent(0, 11500835, 0);
    SetMapSoundState(1503800, Disabled);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11);
    InitializeEvent(0, 11505392, 0);
    DeactivateObject(1501990, Disabled);
    DeleteMapSFX(1501991, false);
    SkipUnconditionally(9);
    InitializeEvent(0, 11505390, 0);
    InitializeEvent(0, 11505391, 0);
    InitializeEvent(0, 11505393, 0);
    InitializeEvent(0, 11505392, 0);
    InitializeEvent(0, 11500001, 0);
    InitializeEvent(0, 11505394, 0);
    InitializeEvent(0, 11505395, 0);
    InitializeEvent(0, 11505350, 0);
    InitializeEvent(0, 11505353, 0);
    InitializeEvent(0, 11505010, 0);
    InitializeEvent(0, 11505011, 0);
    InitializeEvent(0, 11505012, 0);
    InitializeEvent(0, 11505013, 0);
    InitializeEvent(0, 11505014, 0);
    InitializeEvent(0, 11500900, 0);
    InitializeEvent(0, 11505015, 0);
    InitializeEvent(0, 11505270, 1502200, 1501200, 1503500, 1501210, 0, 11505280);
    InitializeEvent(1, 11505270, 1502201, 1501201, 1503500, 1501211, 90, 11505281);
    InitializeEvent(2, 11505270, 1502202, 1501202, 1503500, 1501212, 90, 11505282);
    InitializeEvent(3, 11505270, 1502203, 1501203, 1503500, 1501213, 270, 11505283);
    InitializeEvent(4, 11505270, 1502204, 1501204, 1503500, 1501214, 180, 11505284);
    InitializeEvent(5, 11505270, 1502205, 1501205, 1503500, 1501213, 270, 11505285);
    InitializeEvent(0, 11505260, 0);
    InitializeEvent(0, 11500860, 6600);
    InitializeEvent(1, 11500860, 1500300);
    InitializeEvent(2, 11500860, 1500301);
    InitializeEvent(3, 11500860, 1500302);
    InitializeEvent(4, 11500860, 1500303);
    InitializeEvent(5, 11500860, 1500100);
    InitializeEvent(7, 11500860, 1500102);
    InitializeEvent(0, 11500600, 1501650, 11500600);
    InitializeEvent(2, 11500600, 1501652, 11500602);
    InitializeEvent(4, 11500600, 1501654, 11500604);
    InitializeEvent(9, 11500600, 1501659, 11500609);
    InitializeEvent(10, 11500600, 1501660, 11500610);
});

// プリコンストラクタ
Event(50, Default, function() {
    RegisterNPCHumanityEventValue(6600, 8980);
    RegisterNPCHumanityEventValue(6510, 8924);
    InitializeEvent(0, 11505030, 0);
    InitializeEvent(0, 11505032, 0);
    RegisterNPCHumanityEventValue(6030, 8334);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 1090);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 1091);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 1096);
    ChangeCharacterEnableState(6030, Disabled);
    InitializeEvent(0, 11500510, 6030, 1096);
    InitializeEvent(0, 11500520, 6030, 1090, 1109, 1097);
    InitializeEvent(0, 11500530, 0);
    InitializeEvent(0, 11500531, 6030, 1090, 1109, 1091);
    InitializeEvent(0, 11500532, 6030, 1090, 1109, 1092);
    ChangeCharacterTeamTypeAndForceExitSpecialAnimations(6043, TeamType.HostileAlly);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 1117);
    ChangeCharacterEnableState(6043, Disabled);
    InitializeEvent(1, 11500520, 6043, 1110, 1119, 1115);
    InitializeEvent(0, 11500533, 6043, 1110, 1119, 1117);
    RegisterNPCHumanityEventValue(6280, 8446);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 1514);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 1513);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1493, 1511);
    SkipUnconditionally(1);
    ChangeCharacterEnableState(6280, Disabled);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 11500200);
    SkipUnconditionally(1);
    WarpCharacterAndSetFloor(6280, TargetEntityType.Area, 1502510, -1, 1503300);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1491, 1492);
    SkipUnconditionally(2);
    ForceCharacterDeath(1500120, false);
    ForceCharacterDeath(1500121, false);
    InitializeEvent(2, 11500510, 6280, 1512);
    InitializeEvent(2, 11500520, 6280, 1490, 1539, 1513);
    InitializeEvent(0, 11500534, 6280, 1490, 1539, 1491);
    InitializeEvent(0, 11500535, 6280, 1490, 1539, 1492);
    InitializeEvent(0, 11500536, 6280, 1490, 1539, 1493);
    RegisterNPCHumanityEventValue(6250, 8422);
    SkipIfBatchEventFlags(1, LogicalOperationType.NotAllOFF, TargetEventFlagType.EventFlag, 1420, 1429);
    SetEventFlag(1420, ON);
    InitializeEvent(3, 11500510, 6250, 1421);
    InitializeEvent(3, 11500520, 6250, 1420, 1429, 1422);
});

// 敵リスポン
Event(1000000000, Default, function() {
    ChangeCharacterEnableState(1500200, Disabled);
    SetNetworkUpdateRate(1500100, true, CharacterUpdateFrequency.AlwaysUpdate);
});

// 王城1 チェックポイント通過XX
Event(11500090, Default, function(X0_4, X4_4, X8_4, X12_4) {
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    DeactivateObject(X0_4, Disabled);
    DeleteMapSFX(X4_4, false);
    EndUnconditionally(EventEndType.End);
    IfActionButtonLineSegment(AND_01, TargetEntityType.Area, X8_4, 0, 0, 0, 10010403, ReactionType.HollowHuman, 0, X0_4);
    IfActionButtonLineSegment(AND_02, TargetEntityType.Area, X12_4, 0, 0, 0, 10010407, ReactionType.HollowHuman, 0, X0_4);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(2, PASS, AND_02);
    IssueShortWarpRequest(10000, TargetEntityType.Area, X8_4, -1);
    SkipUnconditionally(1);
    IssueShortWarpRequest(10000, TargetEntityType.Area, X12_4, -1);
    ForceAnimationPlayback(10000, 7410, false, false, false);
    DeactivateObject(X0_4, Disabled);
    DeleteMapSFX(X4_4, true);
});

// 王城1 黒敵出現
Event(11505090, Restart, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    ChangeCharacterEnableState(1500900, Disabled);
    ChangeCharacterEnableState(1500901, Disabled);
    ChangeCharacterEnableState(1500902, Disabled);
    ChangeCharacterEnableState(1500903, Disabled);
    ChangeCharacterEnableState(1500904, Disabled);
    ChangeCharacterEnableState(1500905, Disabled);
    ChangeCharacterEnableState(1500906, Disabled);
    ChangeCharacterEnableState(1500907, Disabled);
    ChangeCharacterEnableState(1500908, Disabled);
    ChangeCharacterEnableState(1500909, Disabled);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11500050);
    IfConditionGroup(MAIN, PASS, OR_01);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 735);
    SetEventFlag(5000, ON);
    ChangeCharacterEnableState(1500900, Enabled);
    ChangeCharacterEnableState(1500901, Enabled);
    ChangeCharacterEnableState(1500902, Enabled);
    ChangeCharacterEnableState(1500903, Enabled);
    ChangeCharacterEnableState(1500904, Enabled);
    ChangeCharacterEnableState(1500905, Enabled);
    ChangeCharacterEnableState(1500906, Enabled);
    ChangeCharacterEnableState(1500907, Enabled);
    ChangeCharacterEnableState(1500908, Enabled);
    ChangeCharacterEnableState(1500909, Enabled);
});

// 王城1 黒敵消滅
Event(11505091, Restart, function() {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11505095);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 735);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 735);
    SetEventFlag(735, OFF);
    SetEventFlag(11500050, OFF);
    SetEventFlag(11505095, OFF);
    SetEventFlag(5001, ON);
    ForceCharacterDeath(1500900, false);
    ForceCharacterDeath(1500901, false);
    ForceCharacterDeath(1500902, false);
    ForceCharacterDeath(1500903, false);
    ForceCharacterDeath(1500904, false);
    ForceCharacterDeath(1500905, false);
    ForceCharacterDeath(1500906, false);
    ForceCharacterDeath(1500907, false);
    ForceCharacterDeath(1500908, false);
    ForceCharacterDeath(1500909, false);
});

// 王城1 黒敵タイマー
Event(11505092, Restart, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    IfWorldTendency(AND_01, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_01, true, 15, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11500050);
    IfConditionGroup(MAIN, PASS, OR_01);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_02, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_02, true, 15, 0);
    IfConditionGroup(OR_02, PASS, AND_02);
    IfEventFlag(OR_02, ON, TargetEventFlagType.EventFlag, 11500050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_02);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_03, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_03, true, 15, 0);
    IfConditionGroup(OR_03, PASS, AND_03);
    IfEventFlag(OR_03, ON, TargetEventFlagType.EventFlag, 11500050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_03);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_04, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_04, true, 15, 0);
    IfConditionGroup(OR_04, PASS, AND_04);
    IfEventFlag(OR_04, ON, TargetEventFlagType.EventFlag, 11500050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_04);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_05, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_05, true, 15, 0);
    IfConditionGroup(OR_05, PASS, AND_05);
    IfEventFlag(OR_05, ON, TargetEventFlagType.EventFlag, 11500050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_05);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_06, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_06, true, 15, 0);
    IfConditionGroup(OR_06, PASS, AND_06);
    IfEventFlag(OR_06, ON, TargetEventFlagType.EventFlag, 11500050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_06);
    SetEventFlag(11500050, ON);
    WaitFixedTimeSeconds(600);
    IfWorldTendency(AND_07, TendencyType.BlackTendency, ComparisonType.LessOrEqual, 50);
    IfPlayerInoutMap(AND_07, true, 15, 0);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, AND_07);
    SetEventFlag(11500050, OFF);
    SetEventFlag(11505095, ON);
});

// OBJダメージまとめ
Event(11505300, Default, function() {
    CreateDamagingObject(11505301, 1501850, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505302, 1501851, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505303, 1501852, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505304, 1501853, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505305, 1501854, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505306, 1501855, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505307, 1501856, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505308, 1501857, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505309, 1501858, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505310, 1501859, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505311, 1501860, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505312, 1501861, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505313, 1501862, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505314, 1501863, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505315, 1501864, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505316, 1501865, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505317, 1501866, 101, 5040, DamageTargetType.Character, 0.3, 0, 2);
    CreateDamagingObject(11505290, 1501010, 101, 5060, DamageTargetType.Character, 1.2, 0, 0.5);
});

// ホストが王城1ボス部屋入場
Event(11505390, Default, function() {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11);
    IfActionButtonLineSegmentBossRoom(AND_01, TargetEntityType.Area, 1502998, 0, -1, 0, 10010403, ReactionType.HollowHuman, 0, 1501990);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1502997);
    ForceAnimationPlayback(10000, 7410, false, false, false);
    EndUnconditionally(EventEndType.Restart);
});

// クライアントが王城1ボス部屋入場
Event(11505391, Default, function() {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505393);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterHasSpeffect(OR_01, 10000, 9531, true);
    IfActionButtonLineSegment(AND_01, TargetEntityType.Area, 1502998, 0, -1, 0, 10010403, ReactionType.All, 0, 1501990);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1502997);
    ForceAnimationPlayback(10000, 7410, false, false, false);
    EndUnconditionally(EventEndType.Restart);
});

// ホストが王城1ボス部屋入場完了
Event(11505393, Default, function() {
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1502996);
    IfConditionGroup(MAIN, PASS, AND_01);
    SkipIfMultiplayerState(1, MultiplayerState.Client);
    IssueBossRoomEntryNotification(0);
    ActivateMultiplayerdependantBuffs(1500800);
    SetEventFlag(11509045, ON);
    SetSpEffect(1500800, 9539); // Dumb bug fix to make sure bosses don't spawn at half hp. Heals them to full as soon as fight starts.
});

// 王城1ボスが動き出す
Event(11505392, Restart, function() {
    SkipIfEventFlag(7, OFF, TargetEventFlagType.EventFlag, 11);
    ChangeCharacterEnableState(1500800, Disabled);
    ForceCharacterTreasure(1500800);
    SetCharacterBackreadState(1500800, true);
    IfCharacterBackreadStatus(MAIN, 1500100, true);
    RequestCharacterAICommand(1500100, 10, 0);
    RequestCharacterAIReplan(1500100);
    EndUnconditionally(EventEndType.End);
    SetCharacterAIState(1500800, Disabled);
    SetSpecialAnimations(1500800, 9000, -1, -1, -1, -1);
    InitializeEvent(0, 11505351, 0);
    InitializeEvent(0, 11505352, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505393);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1502996);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterAIState(1500800, Enabled);
    SetSpecialAnimations(1500800, -1, -1, 9060, -1, -1);
    DisplayBossHealthBar(Enabled, 1500800, 0, 2320);
});

// 王城1ボス撃破
Event(11500001, Default, function() {
    DeleteMapSFX(1503010, false);
    IfCharacterDeadalive(MAIN, 1500800, DeathState.Dead);
    SetEventFlag(11, ON);
    HandleBossDefeat(1500800);
    DeactivateObject(1501990, Disabled);
    DeleteMapSFX(1501991, true);
    SpawnMapSFX(1503010);
    RequestCharacterAICommand(1500100, 10, 0);
    RequestCharacterAIReplan(1500100);
    SetEventFlag(11807020, OFF);
    SetEventFlag(11807030, OFF);
    SetEventFlag(11807040, OFF);
    SetEventFlag(11807050, OFF);
    SetEventFlag(11509004, ON);
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(3);
    ChangeCharacterEnableState(1500800, Disabled);
    SetCharacterBackreadState(1500800, true);
});

// 王城1ボスBGM ON
Event(11505394, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505392);
    SkipIfMultiplayerState(1, MultiplayerState.Host);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505391);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1502996);
    IfCharacterDeadalive(AND_01, 1500800, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetMapSoundState(1503800, Enabled);
});

// 王城1ボスBGM OFF
Event(11505395, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505394);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetMapSoundState(1503800, Disabled);
    PlaySE(1502990, SoundType.aEnvironmentalSound, 150100002);
});

// 王城1ボスが落下死亡
Event(11505350, Default, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    IfCharacterHasEventMessage(MAIN, 1500800, 100, true);
    IfCharacterDeadalive(MAIN, 1500800, DeathState.Dead);
});

// 王城1ボスがよろける
Event(11505351, End, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 11);
    SetNetworkSyncState(Enabled);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505355);
    CreateNPCPart(1500800, 2320, NPCPartType.Part2, 200, 1, 1, false, false);
    SetNPCPartSEAndSFX(1500800, 2320, 56, 56);
    IfNPCPartHP(MAIN, 1500800, 2320, 0, ComparisonType.LessOrEqual);
    EzstateInstructionRequest(1500800, 1300, 0);
    IfCharacterHasEventMessage(MAIN, 1500800, 1204, true);
    SetEventFlag(11505355, ON);
    CreateNPCPart(1500800, 2321, NPCPartType.Part2, 100, 1, 1, false, false);
    SetNPCPartSEAndSFX(1500800, 2321, 56, 56);
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(15);
    SetNetworkSyncState(Enabled);
    SetEventFlag(11505355, OFF);
    SetEventState(11505352, 0, EventEndType.Restart);
    SetNPCPartHP(1500800, 2321, -1, false);
    EzstateInstructionRequest(1500800, 1303, 0);
    EndUnconditionally(EventEndType.Restart);
});

// 王城1ボスが倒れる
Event(11505352, End, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 11);
    SetNetworkSyncState(Enabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505355);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505355);
    IfNPCPartHP(AND_01, 1500800, 2321, 0, ComparisonType.LessOrEqual);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventState(11505351, 0, EventEndType.Restart);
    EzstateInstructionRequest(1500800, 1301, 0);
    IfCharacterHasEventMessage(MAIN, 1500800, 1203, true);
    SetNetworkSyncState(Disabled);
    WaitFixedTimeSeconds(15);
    SetNetworkSyncState(Enabled);
    EzstateInstructionRequest(1500800, 1304, 0);
    SetEventFlag(11505355, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// ボス用ヒットの切り替え
Event(11505353, Default, function() {
    IfCharacterHasEventMessage(AND_01, 1500800, 400, true);
    IfCharacterHasEventMessage(AND_02, 1500800, 300, true);
    IfHPRatio(AND_03, 1500800, ComparisonType.LessOrEqual, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(OR_01, PASS, AND_03);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(2, FAIL, AND_01);
    ActivateHit(1503000, Disabled);
    SkipUnconditionally(1);
    ActivateHit(1503000, Enabled);
    EndIfConditionGroupStateCompiled(EventEndType.End, PASS, AND_03);
    IfCharacterHasEventMessage(AND_04, 1500800, 400, false);
    IfCharacterHasEventMessage(AND_04, 1500800, 300, false);
    IfConditionGroup(MAIN, PASS, AND_04);
    EndUnconditionally(EventEndType.Restart);
});

// 正門の初期化
Event(11500201, Default, function() {
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11500200);
    ReproduceObjectAnimation(1501000, 0);
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, 1502050);
    IfInoutsideArea(MAIN, InsideOutsideState.Outside, 10000, 1502050);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄球トラップ制御
Event(11500790, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11500791);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11505050);
    IfCharacterDeadalive(AND_01, 1500101, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11505052, ON);
    WaitFixedTimeSeconds(5);
    DeactivateObject(1501800, Enabled);
    ForceAnimationPlayback(1501800, 0, false, false, false);
    WaitFixedTimeSeconds(1.5);
    ActivateHit(1503210, Enabled);
    WaitFixedTimeSeconds(3.5);
    WaitForNetworkApproval(10);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11505210);
    SetEventFlag(11505220, ON);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11505211);
    SetEventFlag(11505221, ON);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11505212);
    SetEventFlag(11505222, ON);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 11505213);
    SetEventFlag(11505223, ON);
    EndUnconditionally(EventEndType.Restart);
});

// はじめての鉄球トラップ
Event(11500791, Restart, function() {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventID, 0);
    ChangeCharacterEnableState(1500110, Disabled);
    EndUnconditionally(EventEndType.End);
    SetCharacterAIState(1500110, Disabled);
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, 1502110);
    SetEventFlag(11500791, ON);
    DeactivateObject(1501800, Enabled);
    ForceAnimationPlayback(1500110, 500, false, true, false);
    ForceAnimationPlayback(1500110, 603, false, true, false);
    SetCharacterAIState(1500110, Enabled);
    CreateDamagingObject(11505200, 1501800, 101, 5050, DamageTargetType.Character, 1.7, 1, 0);
    ForceAnimationPlayback(1501800, 12, false, true, false);
    DeactivateObject(1501800, Disabled);
});

// 鉄球トラップ１
Event(11500795, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505220);
    SetEventFlag(11505220, OFF);
    SetEventFlag(11505210, ON);
    DeactivateObject(1501800, Disabled);
    DeactivateObject(1501804, Enabled);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500812);
    InitializeEvent(0, 11500700, 11505200, 1501804, 1, 1075838976, 1501812, 11505210);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500803);
    InitializeEvent(10, 11500700, 11505200, 1501804, 2, 1089470464, 1501813, 11505210);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500806);
    InitializeEvent(20, 11500700, 11505200, 1501804, 3, 1089470464, 1501810, 11505210);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500830);
    InitializeEvent(30, 11500700, 11505200, 1501804, 4, 1095237632, 1501811, 11505210);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500821);
    InitializeEvent(0, 11500750, 11505200, 1501801, 5, 1503200, 1501811, 11505210, 11500821, 1501804);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500822);
    InitializeEvent(1, 11500750, 11505200, 1501802, 6, 1503201, 1501811, 11505210, 11500822, 1501804);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500823);
    InitializeEvent(2, 11500750, 11505200, 1501803, 7, 1503202, 1501811, 11505210, 11500823, 1501804);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
    InitializeEvent(40, 11500700, 11505200, 1501804, 8, 1100218368, 1501811, 11505210);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505210);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄球トラップ２
Event(11500796, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505221);
    SetEventFlag(11505221, OFF);
    SetEventFlag(11505211, ON);
    DeactivateObject(1501800, Disabled);
    DeactivateObject(1501805, Enabled);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500812);
    InitializeEvent(1, 11500700, 11505201, 1501805, 1, 1075838976, 1501812, 11505211);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500803);
    InitializeEvent(11, 11500700, 11505201, 1501805, 2, 1089470464, 1501813, 11505211);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500806);
    InitializeEvent(21, 11500700, 11505201, 1501805, 3, 1089470464, 1501810, 11505211);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500830);
    InitializeEvent(31, 11500700, 11505201, 1501805, 4, 1095237632, 1501811, 11505211);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500821);
    InitializeEvent(0, 11500750, 11505201, 1501801, 5, 1503200, 1501811, 11505211, 11500821, 1501805);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500822);
    InitializeEvent(1, 11500750, 11505201, 1501802, 6, 1503201, 1501811, 11505211, 11500822, 1501805);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500823);
    InitializeEvent(2, 11500750, 11505201, 1501803, 7, 1503202, 1501811, 11505211, 11500823, 1501805);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
    InitializeEvent(41, 11500700, 11505201, 1501805, 8, 1100218368, 1501811, 11505211);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505211);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄球トラップ３
Event(11500797, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505222);
    SetEventFlag(11505222, OFF);
    SetEventFlag(11505212, ON);
    DeactivateObject(1501800, Disabled);
    DeactivateObject(1501806, Enabled);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500812);
    InitializeEvent(2, 11500700, 11505202, 1501806, 1, 1075838976, 1501812, 11505212);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500803);
    InitializeEvent(12, 11500700, 11505202, 1501806, 2, 1089470464, 1501813, 11505212);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500806);
    InitializeEvent(22, 11500700, 11505202, 1501806, 3, 1089470464, 1501810, 11505212);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500830);
    InitializeEvent(32, 11500700, 11505202, 1501806, 4, 1095237632, 1501811, 11505212);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500821);
    InitializeEvent(0, 11500750, 11505202, 1501801, 5, 1503200, 1501811, 11505212, 11500821, 1501806);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500822);
    InitializeEvent(1, 11500750, 11505202, 1501802, 6, 1503201, 1501811, 11505212, 11500822, 1501806);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500823);
    InitializeEvent(2, 11500750, 11505202, 1501803, 7, 1503202, 1501811, 11505212, 11500823, 1501806);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
    InitializeEvent(42, 11500700, 11505202, 1501806, 8, 1100218368, 1501811, 11505212);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505212);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄球トラップ４
Event(11500798, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505223);
    SetEventFlag(11505223, OFF);
    SetEventFlag(11505213, ON);
    DeactivateObject(1501800, Disabled);
    DeactivateObject(1501807, Enabled);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500812);
    InitializeEvent(3, 11500700, 11505203, 1501807, 1, 1075838976, 1501812, 11505213);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500803);
    InitializeEvent(13, 11500700, 11505203, 1501807, 2, 1089470464, 1501813, 11505213);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 11500806);
    InitializeEvent(23, 11500700, 11505203, 1501807, 3, 1089470464, 1501810, 11505213);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500830);
    InitializeEvent(33, 11500700, 11505203, 1501807, 4, 1095237632, 1501811, 11505213);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500821);
    InitializeEvent(0, 11500750, 11505203, 1501801, 5, 1503200, 1501811, 11505213, 11500821, 1501807);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500822);
    InitializeEvent(1, 11500750, 11505203, 1501802, 6, 1503201, 1501811, 11505213, 11500822, 1501807);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500823);
    InitializeEvent(2, 11500750, 11505203, 1501803, 7, 1503202, 1501811, 11505213, 11500823, 1501807);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
    InitializeEvent(43, 11500700, 11505203, 1501807, 8, 1100218368, 1501811, 11505213);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505213);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄球トラップ 射出XX
Event(11500700, Default, function(X0_4, X4_4, X8_4, X12_4, X16_4, X20_4) {
    ActivateHit(1503210, Disabled);
    ForceAnimationPlayback(X16_4, 1, false, false, false);
    CreateDamagingObject(X0_4, X4_4, 101, 5050, DamageTargetType.Character, 1.7, X12_4, 0.2);
    ForceAnimationPlayback(X4_4, X8_4, false, true, false);
    DeleteObjectEvent(X0_4);
    DeactivateObject(X4_4, Disabled);
    ReproduceObjectAnimation(X4_4, 0);
    SetEventFlag(X20_4, OFF);
});

// 鉄球トラップ 蓄積XX
Event(11500750, Default, function(X0_4, X4_4, X8_4, X12_4, X16_4, X20_4, X24_4, X28_4) {
    ActivateHit(1503210, Disabled);
    SetEventFlag(X24_4, ON);
    DeactivateObject(X4_4, Enabled);
    DeactivateObject(X28_4, Disabled);
    ForceAnimationPlayback(X16_4, 1, false, false, false);
    CreateDamagingObject(X0_4, X4_4, 101, 5050, DamageTargetType.Character, 1.7, 12.5, 0.2);
    ForceAnimationPlayback(X4_4, X8_4, false, true, false);
    ActivateHit(X12_4, Enabled);
    DeleteObjectEvent(X0_4);
    SetEventFlag(X20_4, OFF);
});

// 鉄球蓄積場を目撃する
Event(11500830, Default, function() {
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 10000, 1502810);
    SetEventFlag(11500830, ON);
});

// 鉄球蓄積場で挟まれ死
Event(11500831, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11500751);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1502811);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11500752);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1502812);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    ForceCharacterDeath(10000, false);
});

// 鉄球スイッチ
Event(11500850, Default, function() {
    SetEventFlag(11505250, OFF);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11505250);
    IfActionButton(AND_01, TargetEntityType.Object, 1501790, 60, 104, 1.5, 10010502, ReactionType.All, 0);
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11505250);
    IfActionButton(AND_02, TargetEntityType.Object, 1501790, 60, 102, 1.5, 10010502, ReactionType.All, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    WaitForNetworkApproval(3);
    SetEventFlag(11505250, ON);
    SetEventFlag(11505251, OFF);
    SetEventFlag(11505252, OFF);
    SkipIfConditionGroupStateCompiled(23, FAIL, AND_01);
    IssueShortWarpRequest(10000, TargetEntityType.Object, 1501790, 101);
    ForceAnimationPlayback(10000, 8020, false, false, false);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500812);
    SetEventFlag(11500812, OFF);
    SetEventFlag(11500803, OFF);
    ForceAnimationPlayback(1501790, 3, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500809);
    SetEventFlag(11500809, OFF);
    SetEventFlag(11500812, ON);
    ForceAnimationPlayback(1501790, 2, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500806);
    SetEventFlag(11500806, OFF);
    SetEventFlag(11500809, ON);
    ForceAnimationPlayback(1501790, 1, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(4, ON, TargetEventFlagType.EventFlag, 11500803);
    SetEventFlag(11500803, ON);
    SetEventFlag(11500806, ON);
    ForceAnimationPlayback(1501790, 0, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    EndIfConditionGroupStateCompiled(EventEndType.Restart, FAIL, AND_02);
    IssueShortWarpRequest(10000, TargetEntityType.Object, 1501790, 103);
    ForceAnimationPlayback(10000, 8021, false, false, false);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500812);
    SetEventFlag(11500812, OFF);
    SetEventFlag(11500809, ON);
    ForceAnimationPlayback(1501790, 5, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(4, ON, TargetEventFlagType.EventFlag, 11500803);
    SetEventFlag(11500803, ON);
    SetEventFlag(11500812, ON);
    ForceAnimationPlayback(1501790, 4, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500806);
    SetEventFlag(11500806, OFF);
    SetEventFlag(11500803, OFF);
    ForceAnimationPlayback(1501790, 7, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500809);
    SetEventFlag(11500809, OFF);
    SetEventFlag(11500806, ON);
    ForceAnimationPlayback(1501790, 6, false, true, false);
    EndUnconditionally(EventEndType.Restart);
    SetEventFlag(11500802, ON);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄球スイッチ自動切替
Event(11505255, Default, function() {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11505250);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11505251);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11500809);
    IfElapsedSeconds(AND_01, 2);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1502800);
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11505250);
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11505252);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11500803);
    IfElapsedSeconds(AND_02, 2);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1502801);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    WaitForNetworkApproval(3);
    SetEventFlag(11505250, ON);
    SkipIfConditionGroupStateCompiled(19, PASS, AND_02);
    SetEventFlag(11505251, ON);
    SetEventFlag(11505252, OFF);
    SkipIfEventFlag(5, ON, TargetEventFlagType.EventFlag, 11500803);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SetEventFlag(11500803, ON);
    SetEventFlag(11500809, ON);
    ForceAnimationPlayback(1501790, 0, false, true, false);
    ForceAnimationPlayback(1501790, 1, false, true, false);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500806);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SetEventFlag(11500806, OFF);
    SetEventFlag(11500809, ON);
    ForceAnimationPlayback(1501790, 1, false, true, false);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500812);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SetEventFlag(11500812, OFF);
    SetEventFlag(11500809, ON);
    ForceAnimationPlayback(1501790, 5, false, true, false);
    SkipUnconditionally(18);
    SetEventFlag(11505251, OFF);
    SetEventFlag(11505252, ON);
    SkipIfEventFlag(5, OFF, TargetEventFlagType.EventFlag, 11500809);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SetEventFlag(11500809, OFF);
    SetEventFlag(11500803, OFF);
    ForceAnimationPlayback(1501790, 6, false, true, false);
    ForceAnimationPlayback(1501790, 7, false, true, false);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500806);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SetEventFlag(11500806, OFF);
    SetEventFlag(11500803, OFF);
    ForceAnimationPlayback(1501790, 7, false, true, false);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 11500812);
    SpawnOneshotSFX(TargetEntityType.Object, 1501790, -1, 150001);
    SetEventFlag(11500812, OFF);
    SetEventFlag(11500803, OFF);
    ForceAnimationPlayback(1501790, 3, false, true, false);
    SetEventFlag(11505250, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// クライアント ロード直後同期確認
Event(11500840, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505240);
    SetEventFlag(11505240, ON);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505240);
    EndUnconditionally(EventEndType.Restart);
});

// クライアント ロード直後確認要請_XX
Event(11500841, Default, function(X0_4) {
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505240);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, X0_4);
    IfMultiplayerState(AND_02, MultiplayerState.Host);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11505240);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(11505240, OFF);
    SkipIfConditionGroupStateCompiled(2, PASS, AND_02);
    SetEventFlag(X0_4, OFF);
    SkipUnconditionally(1);
    SetEventFlag(X0_4, ON);
    EndUnconditionally(EventEndType.Restart);
});

// クライアント ロード直後同期完了
Event(11500835, Default, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Host);
    WaitFixedTimeFrames(10);
    SetEventFlag(11505360, ON);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505250);
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11505250);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(1, PASS, AND_02);
    WaitFixedTimeSeconds(3);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 11500803);
    ReproduceObjectAnimation(1501790, 3);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11500806);
    ReproduceObjectAnimation(1501790, 0);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11500809);
    ReproduceObjectAnimation(1501790, 1);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11500812);
    ReproduceObjectAnimation(1501790, 2);
});

// SCエレベータ
Event(11500100, Default, function() {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventID, 0);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1502060);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11500101);
    IfInoutsideArea(AND_02, InsideOutsideState.Inside, 10000, 1502061);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_03, OFF, TargetEventFlagType.EventFlag, 11500101);
    IfInoutsideArea(AND_03, InsideOutsideState.Inside, 10000, 1502062);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11500101);
    IfInoutsideArea(AND_04, InsideOutsideState.Inside, 10000, 1502060);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11500101);
    IfInoutsideArea(AND_05, InsideOutsideState.Inside, 10000, 1502063);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(OR_01, PASS, AND_03);
    IfConditionGroup(OR_01, PASS, AND_04);
    IfConditionGroup(OR_01, PASS, AND_05);
    IfConditionGroup(MAIN, PASS, OR_01);
    WaitForNetworkApproval(3);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Solid, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Solid, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Solid, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Solid, BitopType.Add);
    SkipIfConditionGroupStateCompiled(16, FAIL, AND_01);
    SetEventFlag(11500100, ON);
    ForceAnimationPlayback(1501011, 0, false, true, false);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503110, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503111, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503112, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503113, NavimeshType.WalltouchingFloor, BitopType.Add);
    IfAllPlayersInoutsideArea(MAIN, InsideOutsideState.Outside, 1502062);
    EndUnconditionally(EventEndType.Restart);
    SkipIfConditionGroupStateCompiled(27, PASS, AND_04);
    SkipIfConditionGroupStateCompiled(26, PASS, AND_05);
    SetEventFlag(11500101, ON);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Wall, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503110, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503111, NavimeshType.Wall, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503112, NavimeshType.Wall, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Wall, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503113, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ForceAnimationPlayback(1501011, 1, false, true, false);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503110, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503111, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503112, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503113, NavimeshType.Wall, BitopType.Add);
    IfAllPlayersInoutsideArea(AND_06, InsideOutsideState.Outside, 1502060);
    IfAllPlayersInoutsideArea(AND_06, InsideOutsideState.Outside, 1502063);
    IfConditionGroup(MAIN, PASS, AND_06);
    EndUnconditionally(EventEndType.Restart);
    SetEventFlag(11500101, OFF);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503110, NavimeshType.Wall, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Wall, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503111, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Wall, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503112, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.WalltouchingFloor, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503113, NavimeshType.Wall, BitopType.Delete);
    ForceAnimationPlayback(1501011, 2, false, true, false);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Solid, BitopType.Delete);
    ModifyNavimeshConnectionBitflag(1503100, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503110, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503101, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503111, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503102, NavimeshType.WalltouchingFloor, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503112, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503103, NavimeshType.Wall, BitopType.Add);
    ModifyNavimeshConnectionBitflag(1503113, NavimeshType.WalltouchingFloor, BitopType.Add);
    IfAllPlayersInoutsideArea(AND_07, InsideOutsideState.Outside, 1502061);
    IfAllPlayersInoutsideArea(AND_07, InsideOutsideState.Outside, 1502062);
    IfConditionGroup(MAIN, PASS, AND_07);
    EndUnconditionally(EventEndType.Restart);
});

// SCエレベータ最初の扉
Event(11500102, Default, function() {
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventID, 0);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 11500100);
    ReproduceObjectAnimation(1501011, 20);
    EndUnconditionally(EventEndType.End);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventID, 0);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 2003, OwnershipState.Owns);
    IfActionButton(AND_01, TargetEntityType.Object, 1501011, 60, 105, 2, 10010400, ReactionType.HollowHuman, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    IssueShortWarpRequest(10000, TargetEntityType.Object, 1501011, 120);
    ForceAnimationPlayback(10000, 7111, false, false, false);
    ForceAnimationPlayback(1501011, 10, false, false, false);
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    DisplayGenericDialog(10010862, PromptType.YESNO, NumberofOptions.NoButtons, -1, 3);
});

// SCエレベータが開かない
Event(11500103, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11500102);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 2003, OwnershipState.DoesntOwn);
    IfActionButton(AND_01, TargetEntityType.Object, 1501011, 60, 105, 2, 10010400, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayGenericDialog(10010163, PromptType.YESNO, NumberofOptions.NoButtons, -1, 3);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄格子の扉が開かない
Event(11500106, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11500105);
    IfActionButton(AND_01, TargetEntityType.Object, 1501001, 60, 101, 1.5, 10010400, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayGenericDialog(10010161, PromptType.OKCANCEL, NumberofOptions.NoButtons, 1501001, 3);
    EndUnconditionally(EventEndType.Restart);
});

// 鉄格子の扉が裏から開く
Event(11500107, Default, function() {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventID, 0);
    ReproduceObjectAnimation(1501001, 0);
    EndUnconditionally(EventEndType.End);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11500105);
    IfActionButton(AND_01, TargetEntityType.Object, 1501001, 60, 100, 1.5, 10010400, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11500105, ON);
    IssueShortWarpRequest(10000, TargetEntityType.Object, 1501001, 120);
    ForceAnimationPlayback(10000, 7112, false, false, false);
    ForceAnimationPlayback(1501001, 0, false, false, false);
});

// 籠牢解除メッセージ_XX
Event(11500110, Default, function(X0_4, X4_4) {
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    ReproduceObjectAnimation(X0_4, 0);
    SetObjactState(X0_4, -1, Disabled);
    EndUnconditionally(EventEndType.End);
    IfObjactEventFlag(MAIN, X4_4);
    SetEventFlag(X4_4, ON);
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 2003, OwnershipState.Owns);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_01);
    DisplayGenericDialog(10010883, PromptType.YESNO, NumberofOptions.NoButtons, X0_4, 3);
    SkipUnconditionally(1);
    DisplayGenericDialog(10010862, PromptType.YESNO, NumberofOptions.NoButtons, X0_4, 3);
});

// 矢射出トラップX作動
Event(11505270, Default, function(X0_4, X4_4, X8_4, X12_4, X16_4, X20_4) {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventFlag, X20_4);
    ReproduceObjectAnimation(X4_4, 0);
    SkipUnconditionally(12);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, X0_4);
    IfObjectHitBy(OR_01, X4_4, -1);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(X20_4, ON);
    SpawnOneshotSFX(TargetEntityType.Object, X4_4, 101, 150005);
    DeleteMapSFX(X8_4, false);
    ForceAnimationPlayback(X4_4, 0, false, true, false);
    SkipIfComparison(5, ComparisonType.Equal, X20_4, 11505284);
    ShootBullet(1500200, X12_4, 101, 5070, 0, X16_4, 0);
    WaitFixedTimeSeconds(0.7);
    ShootBullet(1500200, X12_4, 101, 5070, 0, X16_4, 0);
    WaitFixedTimeSeconds(0.7);
    ShootBullet(1500200, X12_4, 101, 5070, 0, X16_4, 0);
    IfCountEventFlags(MAIN, TargetEventFlagType.EventFlag, 11505280, 11505285, ComparisonType.GreaterOrEqual, 2);
    SetEventFlag(X20_4, OFF);
    ForceAnimationPlayback(X4_4, 1, false, true, false);
    EndUnconditionally(EventEndType.Restart);
});

// 矢射出トラップ補助
Event(11505260, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505284);
    WaitFixedTimeSeconds(0.7);
    ShootBullet(1500200, 1501214, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501215, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501216, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501217, 101, 5070, 0, 180, 0);
    WaitFixedTimeSeconds(0.7);
    ShootBullet(1500200, 1501214, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501215, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501216, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501217, 101, 5070, 0, 180, 0);
    WaitFixedTimeSeconds(0.7);
    ShootBullet(1500200, 1501214, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501215, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501216, 101, 5070, 0, 180, 0);
    ShootBullet(1500200, 1501217, 101, 5070, 0, 180, 0);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505284);
    EndUnconditionally(EventEndType.Restart);
});

// 玉入れ巨人奴隷がやめる
Event(11505050, Restart, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    SetCharacterAIState(1500101, Disabled);
    IfInoutsideArea(OR_01, InsideOutsideState.Inside, 10000, 1502101);
    IfCharacterDamagedBy(OR_01, 1500101, 10000);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetEventFlag(11505050, ON);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505052);
    SetCharacterAIState(1500101, Enabled);
});

// 玉入れ巨人が玉を入れる
Event(11505051, Restart, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505050);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11505052);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    EndIfConditionGroupStateCompiled(EventEndType.End, PASS, AND_01);
    IssueShortWarpRequest(1500101, TargetEntityType.Area, 1502100, -1);
    ForceAnimationPlayback(1500101, 9001, false, true, false);
    SetEventFlag(11505052, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 玉投げ巨人が玉投げを諦める
Event(11505055, Restart, function() {
    SkipIfMultiplayerState(1, MultiplayerState.Client);
    SetNetworkUpdateAuthority(1500100, AuthorityLevel.Forced);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501100);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501101);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501102);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501103);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501104);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501105);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501106);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501107);
    IfObjectDestroyed(AND_01, DestructionState.Destroyed, 1501108);
    IfConditionGroup(MAIN, PASS, AND_01);
    RequestCharacterAICommand(1500100, 20, 1);
    RequestCharacterAIReplan(1500100);
});

// 玉投げ巨人の玉投げ
Event(11505110, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_06, ON, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_07, ON, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505111);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11505112);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11505113);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11505114);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11505115);
    IfEventFlag(AND_06, ON, TargetEventFlagType.EventFlag, 11505116);
    IfBatchEventFlags(AND_07, LogicalOperationType.AllOFF, TargetEventFlagType.EventFlag, 11505111, 11505116);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(OR_01, PASS, AND_03);
    IfConditionGroup(OR_01, PASS, AND_04);
    IfConditionGroup(OR_01, PASS, AND_05);
    IfConditionGroup(OR_01, PASS, AND_06);
    IfConditionGroup(OR_01, PASS, AND_07);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(8, FAIL, AND_06);
    ShootBullet(1500200, 1500100, 50, 5305, 0, 0, 0);
    BatchSetEventFlags(11505111, 11505116, OFF);
    RequestCharacterAICommand(1500100, -1, 2);
    SetEventFlag(11505105, OFF);
    SetEventState(11505102, 0, EventEndType.Restart);
    WaitFixedTimeSeconds(1);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
    SkipIfConditionGroupStateCompiled(8, FAIL, AND_05);
    ShootBullet(1500200, 1500100, 50, 5304, 0, 0, 0);
    BatchSetEventFlags(11505111, 11505116, OFF);
    RequestCharacterAICommand(1500100, -1, 2);
    SetEventFlag(11505105, OFF);
    SetEventState(11505102, 0, EventEndType.Restart);
    WaitFixedTimeSeconds(1);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
    SkipIfConditionGroupStateCompiled(8, FAIL, AND_04);
    ShootBullet(1500200, 1500100, 50, 5303, 0, 0, 0);
    BatchSetEventFlags(11505111, 11505116, OFF);
    RequestCharacterAICommand(1500100, -1, 2);
    SetEventFlag(11505105, OFF);
    SetEventState(11505102, 0, EventEndType.Restart);
    WaitFixedTimeSeconds(1);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
    SkipIfConditionGroupStateCompiled(8, FAIL, AND_03);
    ShootBullet(1500200, 1500100, 50, 5302, 0, 0, 0);
    BatchSetEventFlags(11505111, 11505116, OFF);
    RequestCharacterAICommand(1500100, -1, 2);
    SetEventFlag(11505105, OFF);
    SetEventState(11505102, 0, EventEndType.Restart);
    WaitFixedTimeSeconds(1);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
    SkipIfConditionGroupStateCompiled(8, FAIL, AND_02);
    ShootBullet(1500200, 1500100, 50, 5301, 0, 0, 0);
    BatchSetEventFlags(11505111, 11505116, OFF);
    RequestCharacterAICommand(1500100, -1, 2);
    SetEventFlag(11505105, OFF);
    SetEventState(11505102, 0, EventEndType.Restart);
    WaitFixedTimeSeconds(1);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
    SkipIfConditionGroupStateCompiled(8, FAIL, AND_01);
    ShootBullet(1500200, 1500100, 50, 5300, 0, 0, 0);
    BatchSetEventFlags(11505111, 11505116, OFF);
    RequestCharacterAICommand(1500100, -1, 2);
    SetEventFlag(11505105, OFF);
    SetEventState(11505102, 0, EventEndType.Restart);
    WaitFixedTimeSeconds(1);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
    ShootBullet(1500200, 1500100, 50, 5304, 0, 0, 0);
    BatchSetEventFlags(11505111, 11505116, OFF);
    RequestCharacterAICommand(1500100, -1, 2);
    SetEventFlag(11505105, OFF);
    SetEventState(11505102, 0, EventEndType.Restart);
    WaitFixedTimeSeconds(1);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 玉投げ巨人の意思決定_XX
Event(11505111, Default, function(X0_4, X4_4, X8_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11505100);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11505105);
    IfElapsedSeconds(AND_01, 2);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, X0_4);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, X4_4);
    SkipIfComparison(1, ComparisonType.GreaterOrEqual, X0_4, 11505112);
    IfAllPlayersInoutsideArea(AND_01, InsideOutsideState.Outside, 1502701);
    SkipIfComparison(1, ComparisonType.GreaterOrEqual, X0_4, 11505113);
    IfAllPlayersInoutsideArea(AND_01, InsideOutsideState.Outside, 1502702);
    SkipIfComparison(1, ComparisonType.GreaterOrEqual, X0_4, 11505114);
    IfAllPlayersInoutsideArea(AND_01, InsideOutsideState.Outside, 1502703);
    SkipIfComparison(1, ComparisonType.GreaterOrEqual, X0_4, 11505115);
    IfAllPlayersInoutsideArea(AND_01, InsideOutsideState.Outside, 1502704);
    SkipIfComparison(1, ComparisonType.GreaterOrEqual, X0_4, 11505116);
    IfAllPlayersInoutsideArea(AND_01, InsideOutsideState.Outside, 1502705);
    SkipIfComparison(1, ComparisonType.GreaterOrEqual, X0_4, 11505117);
    IfAllPlayersInoutsideArea(AND_01, InsideOutsideState.Outside, 1502710);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(11505111, 11505116, OFF);
    SetEventFlag(X0_4, ON);
    RequestCharacterAICommand(1500100, X8_4, 2);
    EndUnconditionally(EventEndType.Restart);
});

// 玉投げ意思決定フラグ同期
Event(11505101, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505105);
    SetEventFlag(11505105, ON);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11505105);
    SetEventFlag(11505105, OFF);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 玉投げ意思決定フラグ寿命切れ
Event(11505102, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11505105);
    WaitFixedTimeSeconds(30);
    SetEventFlag(11505105, OFF);
    SetEventFlag(11505100, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 巨人奴隷XXが貧血ダウン
Event(11505060, Restart, function(X0_4) {
    IfCharacterHasEventMessage(MAIN, X0_4, 500, true);
    EzstateInstructionRequest(X0_4, 1500, 0);
    IfCharacterHasEventMessage(MAIN, X0_4, 500, false);
    EndUnconditionally(EventEndType.Restart);
});

// 巨人奴隷XXが貧血から回復
Event(11505070, Restart, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasEventMessage(MAIN, X0_4, 1400, true);
    WaitFixedTimeSeconds(10);
    EzstateInstructionRequest(X0_4, 1501, 0);
    EndUnconditionally(EventEndType.Restart);
});

// 強敵蛇人 居眠り解除
Event(11505080, Restart, function() {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventID, 0);
    SetSpecialAnimations(1500122, -1, -1, -1, -1, -1);
    EndUnconditionally(EventEndType.End);
    IfCharacterDamagedBy(OR_01, 1500122, 10000);
    IfHPRatio(OR_01, 1500122, ComparisonType.NotEqual, 1);
    IfConditionGroup(MAIN, PASS, OR_01);
    SetSpecialAnimations(1500122, -1, -1, -1, -1, -1);
    ForceAnimationPlayback(1500122, 2000, false, false, false);
});

// ミミックが奇襲する
Event(11505010, Restart, function() {
    IfCharacterDeadalive(AND_01, 1500010, DeathState.Alive);
    IfCharacterBackreadStatus(AND_01, 1500010, true);
    IfCharacterHasSpeffect(AND_01, 1500010, 5421, true);
    IfCharacterType(AND_02, 10000, TargetType.BlackPhantom);
    IfConditionGroup(AND_01, FAIL, AND_02);
    IfActionButton(AND_01, TargetEntityType.Character, 1500010, 45, 7, 1.2, 10010400, ReactionType.All, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    WarpCharacterAndCopyFloor(10000, TargetEntityType.Character, 1500010, 100, 1500010);
    ForceAnimationPlayback(10000, 7521, false, false, false);
    RequestCharacterAICommand(1500010, 10, 0);
    RequestCharacterAIReplan(1500010);
    WaitFixedTimeSeconds(0.1);
    RequestCharacterAICommand(1500010, -1, 0);
    EndUnconditionally(EventEndType.Restart);
});

// ミミックが立ち上がる(damaged)
Event(11505011, Restart, function() {
    IfCharacterHasSpeffect(AND_01, 1500010, 5420, false);
    IfCharacterDamagedBy(AND_01, 1500010, 10000);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(1500010, 3150);
    ClearSpeffect(1500010, 3151);
    IfCharacterBackreadStatus(AND_07, 1500010, false);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, PASS, AND_07);
    IfCharacterHasSpeffect(AND_02, 1500010, 5421, true);
    SkipIfConditionGroupStateUncompiled(1, FAIL, AND_02);
    ForceAnimationPlayback(1500010, 3001, false, true, false);
    IfCharacterHasSpeffect(AND_03, 1500010, 5422, true);
    SkipIfConditionGroupStateUncompiled(1, FAIL, AND_03);
    ForceAnimationPlayback(1500010, 3001, false, true, false);
    IfCharacterHasSpeffect(AND_04, 1500010, 5423, true);
    SkipIfConditionGroupStateUncompiled(1, FAIL, AND_04);
    ForceAnimationPlayback(1500010, 3001, false, true, false);
    IfCharacterHasSpeffect(AND_05, 1500010, 5424, true);
    SkipIfConditionGroupStateUncompiled(1, FAIL, AND_05);
    ForceAnimationPlayback(1500010, 3006, false, true, false);
    RequestCharacterAIReplan(1500010);
    ClearSpeffect(1500010, 3150);
    ClearSpeffect(1500010, 3151);
    EndUnconditionally(EventEndType.Restart);
});

// ミミックが居眠りする
Event(11505012, Restart, function() {
    IfCharacterHasSpeffect(AND_01, 1500010, 5421, true);
    IfCharacterHasSpeffect(AND_01, 1500010, 3150, true);
    IfCharacterHasSpeffect(AND_02, 1500010, 5420, true);
    IfCharacterHasSpeffect(AND_02, 1500010, 3150, true);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(5, PASS, AND_02);
    RequestCharacterAICommand(1500010, 200, 0);
    RequestCharacterAIReplan(1500010);
    WaitFixedTimeSeconds(0.1);
    RequestCharacterAICommand(1500010, -1, 0);
    SkipUnconditionally(4);
    RequestCharacterAICommand(1500010, 210, 0);
    RequestCharacterAIReplan(1500010);
    WaitFixedTimeSeconds(0.1);
    RequestCharacterAICommand(1500010, -1, 0);
    IfCharacterHasSpeffect(OR_02, 1500010, 5420, true);
    IfCharacterHasSpeffect(OR_02, 1500010, 5421, true);
    IfConditionGroup(MAIN, PASS, OR_02);
    EndUnconditionally(EventEndType.Restart);
});

// ミミックが目覚める
Event(11505013, Restart, function() {
    IfCharacterHasSpeffect(AND_01, 1500010, 5422, true);
    IfCharacterHasSpeffect(AND_01, 1500010, 3150, false);
    IfCharacterHasSpeffect(AND_02, 1500010, 5423, true);
    IfCharacterHasSpeffect(AND_02, 1500010, 3150, false);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    ClearSpeffect(1500010, 3150);
    ClearSpeffect(1500010, 3151);
    SkipIfConditionGroupStateCompiled(5, PASS, AND_02);
    RequestCharacterAICommand(1500010, 201, 0);
    RequestCharacterAIReplan(1500010);
    WaitFixedTimeSeconds(0.1);
    RequestCharacterAICommand(1500010, -1, 0);
    SkipUnconditionally(4);
    RequestCharacterAICommand(1500010, 211, 0);
    RequestCharacterAIReplan(1500010);
    WaitFixedTimeSeconds(0.1);
    RequestCharacterAICommand(1500010, -1, 0);
    IfCharacterHasSpeffect(OR_02, 1500010, 5420, true);
    IfCharacterHasSpeffect(OR_02, 1500010, 5421, true);
    IfConditionGroup(MAIN, PASS, OR_02);
    EndUnconditionally(EventEndType.Restart);
});

// ミミックが再擬態化
Event(11505014, Restart, function() {
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 1500010, 1502010);
    IfCharacterBackreadStatus(AND_01, 1500010, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetSpeffect(1500010, 5421);
    ClearCharactersAITarget(1500010);
    RequestCharacterAIReplan(1500010);
    IssueShortWarpRequest(1500010, TargetEntityType.Area, 1502010, -1);
    IfCharacterBackreadStatus(MAIN, 1500010, true);
    EndUnconditionally(EventEndType.Restart);
});

// ミミックの同期用アニメ初期化
Event(11505015, Restart, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Host);
    IfCharacterBackreadStatus(AND_01, 1500010, false);
    EndIfConditionGroupStateUncompiled(EventEndType.End, PASS, AND_01);
    RequestCharacterAnimationReset(1500010, Interpolation.Uninterpolated);
    ForceAnimationPlayback(1500010, 0, false, false, false);
    RequestCharacterAIReplan(1500010);
});

// ミミックが死亡済み
Event(11500900, Restart, function() {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    ChangeCharacterEnableState(1500010, Disabled);
    EndUnconditionally(EventEndType.End);
    IfCharacterDeadalive(MAIN, 1500010, DeathState.Dead);
    EndUnconditionally(EventEndType.End);
});

// 王城2へワープ
Event(11500210, Default, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    IfPlayerInoutMap(MAIN, true, 15, 0);
    IfElapsedSeconds(MAIN, 5);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11);
    IfActionButton(MAIN, TargetEntityType.Area, 1502505, 0, -1, 0, 10010120, ReactionType.HollowHuman, 0);
    SetCharacterBackreadState(1500201, true);
    WaitFixedTimeFrames(1);
    SkipIfEventFlag(2, ON, TargetEventFlagType.EventFlag, 11510400);
    PlayCutsceneAndWarpPlayer(150000, CutscenePlayMode.Skippable, 1502501, 15, 1, 10000);
    SkipUnconditionally(1);
    PlayCutsceneAndWarpPlayer(150002, CutscenePlayMode.Skippable, 1502501, 15, 1, 10000);
    WaitFixedTimeFrames(1);
    AwardAchievement(33);
    EndUnconditionally(EventEndType.Restart);
});

// 王城1 強敵出現制御XX
Event(11500860, Restart, function(X0_4) {
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    ChangeCharacterEnableState(X0_4, Disabled);
    ForceCharacterDeath(X0_4, false);
    EndUnconditionally(EventEndType.End);
    IfCharacterDeadalive(MAIN, X0_4, DeathState.Dead);
    EndUnconditionally(EventEndType.End);
});

// 王城1 宝箱XX
Event(11500600, Default, function(X0_4, X4_4) {
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    ReproduceObjectAnimation(X0_4, 0);
    SetObjactState(X0_4, -1, Disabled);
    SetObjectTreasureState(X0_4, Enabled);
    EndUnconditionally(EventEndType.End);
    SetObjectTreasureState(X0_4, Disabled);
    IfObjactEventFlag(MAIN, X4_4);
    WaitFixedTimeFrames(10);
    SetObjectTreasureState(X0_4, Enabled);
});

// NPC敵対（王城1）
Event(11500510, Default, function(X0_4, X4_4) {
    IfHPRatio(AND_01, X0_4, ComparisonType.LessOrEqual, 0.9);
    IfHPRatio(AND_01, X0_4, ComparisonType.Greater, 0);
    IfCharacterDamagedBy(AND_01, X0_4, 10000);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X4_4);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, X4_4);
    IfEventFlag(AND_03, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(OR_01, PASS, AND_03);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(2, FAIL, AND_03);
    ChangeCharacterEnableState(X0_4, Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 703);
    SetEventFlag(X4_4, ON);
    ChangeCharacterTeamTypeAndForceExitSpecialAnimations(X0_4, TeamType.HostileAlly);
    SaveRequest(0);
});

// NPC死亡（王城1）
Event(11500520, Default, function(X0_4, X4_4, X8_4, X12_4) {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    ForceCharacterTreasure(X0_4);
    EndUnconditionally(EventEndType.End);
    IfHPRatio(MAIN, X0_4, ComparisonType.LessOrEqual, 0);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// ロガーン 牢操作OK
Event(11500530, Default, function() {
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11500593);
    SetObjactState(1501032, -1, Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11500593);
    SetObjactState(1501032, -1, Enabled);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11500112);
    SetEventFlag(71500021, OFF);
});

// ロガーン 感謝する
Event(11500531, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1096);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1090);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11500112);
    IfCharacterDeadalive(AND_01, X0_4, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// ロガーン  魔法を教えたい（王城1離れ）
Event(11500532, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1096);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1092);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11500594);
    IfConditionGroup(MAIN, PASS, AND_01);
    SkipIfConditionGroupStateCompiled(2, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
    ChangeCharacterEnableState(X0_4, Disabled);
});

// ロガーン弟子 敵対（王城1）
Event(11500533, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1114);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1113);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 723);
    IfPlayerInoutMap(AND_01, true, 15, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
    ChangeCharacterEnableState(X0_4, Enabled);
});

// たまねぎ騎士 助けて欲しい2（王城1）
Event(11500534, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1512);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1490);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11500591);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11500200);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
    WarpCharacterAndSetFloor(X0_4, TargetEntityType.Area, 1502510, -1, 1503300);
    SetCharacterHome(X0_4, 1502510);
    ForceCharacterDeath(1500120, false);
    ForceCharacterDeath(1500121, false);
});

// たまねぎ騎士 助けて欲しい2・初対面（王城1）
Event(11500535, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1512);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1490);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11500591);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11500200);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
    WarpCharacterAndSetFloor(X0_4, TargetEntityType.Area, 1502510, -1, 1503300);
    SetCharacterHome(X0_4, 1502510);
    ForceCharacterDeath(1500120, false);
    ForceCharacterDeath(1500121, false);
});

// たまねぎ騎士 助けて欲しい（王城1離れ）
Event(11500536, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1512);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1491);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11500850);
    IfCharacterBackreadStatus(AND_01, X0_4, false);
    IfMultiplayerState(AND_02, MultiplayerState.Host);
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 1512);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 1492);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11500592);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11500850);
    IfCharacterBackreadStatus(AND_02, X0_4, false);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
    ChangeCharacterEnableState(X0_4, Disabled);
});

// NPC 協力召喚（王城1）
Event(11505030, Default, function() {
    SkipIfMultiplayerState(1, MultiplayerState.Client);
    SetNetworkUpdateAuthority(6510, AuthorityLevel.Forced);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11505033);
    IfMultiplayerState(AND_02, MultiplayerState.Client);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11505031);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    ChangeCharacterEnableState(6510, Disabled);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 11);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfCharacterBackreadStatus(AND_01, 6510, true);
    IfEntityInoutsideRadiusOfEntity(AND_01, InsideOutsideState.Inside, 6510, 10000, 10);
    IfConditionGroup(MAIN, PASS, AND_01);
    PlaceNPCSummonSign(SummonSignType.WhiteSign, 6510, 1502000, 11505031, 11505033);
});

// NPC ボス部屋入場（王城1）
Event(11505032, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505031);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11505393);
    IfConditionGroup(MAIN, PASS, AND_01);
    RequestCharacterAICommand(6510, 10, 0);
    RequestCharacterAIReplan(6510);
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, 6510, 1502998);
    RotateCharacter(6510, 1502997);
    ForceAnimationPlayback(6510, 7410, false, false, false);
    RequestCharacterAICommand(6510, -1, 0);
    RequestCharacterAIReplan(6510);
});

/* TTT Main Init */
Event(11509050, Default, function() {
    
    /* Always remove any temp items at game load. Skip if loading into a multiplayer session. */
    SkipIfMultiplayerState(27, MultiplayerState.Multiplayer);
    RemoveItemFromPlayer(ItemType.Goods, 361, 1);
    RemoveItemFromPlayer(ItemType.Goods, 362, 1);
    RemoveItemFromPlayer(ItemType.Goods, 363, 1);
    RemoveItemFromPlayer(ItemType.Goods, 364, 1);
    RemoveItemFromPlayer(ItemType.Goods, 365, 1);
    RemoveItemFromPlayer(ItemType.Goods, 366, 1);
    RemoveItemFromPlayer(ItemType.Goods, 367, 1);
    RemoveItemFromPlayer(ItemType.Goods, 9510, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9520, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9530, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9540, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9550, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9560, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9570, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9580, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9590, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9600, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9610, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9620, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9630, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9640, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9650, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9660, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9670, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9700, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9710, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9750, 99);
    
    /* Always reset all relevant eventflags at game load. Skip if loading into a multiplayer session. */
    SkipIfMultiplayerState(24, MultiplayerState.Multiplayer);
    SetEventFlag(11509000, OFF); // Match Queue
    SetEventFlag(11509001, OFF); // Match Start
    SetEventFlag(11509002, OFF); // Traitor Win
    SetEventFlag(11509003, OFF); // Match Cancel
    SetEventFlag(11509004, OFF); // Innocent Win
    SetEventFlag(11509010, OFF); // Ready flags [4]
    SetEventFlag(11509011, OFF);
    SetEventFlag(11509012, OFF);
    SetEventFlag(11509013, OFF);
    SetEventFlag(11509015, OFF); // Heartbeat flags [3]
    SetEventFlag(11509016, OFF);
    SetEventFlag(11509017, OFF);
    SetEventFlag(11509020, OFF); // Dead Flags [4]
    SetEventFlag(11509021, OFF);
    SetEventFlag(11509022, OFF);
    SetEventFlag(11509023, OFF);
    SetEventFlag(11509030, OFF); // Role selection flags [4]
    SetEventFlag(11509031, OFF);
    SetEventFlag(11509032, OFF);
    SetEventFlag(11509033, OFF);
    SetEventFlag(11509040, OFF); // Difficulty flags [3]
    SetEventFlag(11509041, OFF);
    SetEventFlag(11509042, OFF);
    SetEventFlag(11509045, OFF); // Bosses
    
    /* Traitor is randomly chosen BEFORE multiplayer starts. To reduce chance of a desync. */
    InitializeEvent(0, 11509070, 0); // Randomly choose traitor
    
    /* Summon init before multiplayer */
    InitializeEvent(0, 11509083, 9620, 1509080, 450); // Summon A1 Handler
    InitializeEvent(1, 11509083, 9620, 1509081, 520); // Summon A2 Handler
    InitializeEvent(2, 11509083, 9620, 1509082, 590); // Summon A3 Handler
    InitializeEvent(3, 11509083, 9630, 1509083, 750); // Summon B Handler
    InitializeEvent(4, 11509083, 9640, 1509084, 420); // Summon C1 Handler
    InitializeEvent(5, 11509083, 9640, 1509085, 450); // Summon C2 Handler
    InitializeEvent(6, 11509083, 9640, 1509086, 480); // Summon C3 Handler
    InitializeEvent(7, 11509083, 9640, 1509087, 520); // Summon C4 Handler
    InitializeEvent(8, 11509083, 9640, 1509088, 550); // Summon C5 Handler
    InitializeEvent(9, 11509083, 9660, 1509089, 600); // Summon E Handler
    
    /* If you try to queue a match in singleplayer... */
    InitializeEvent(0, 11509053, 0); // Match Queue Fail
    
    /* Do not fully init until we are on the appropriate map and in multiplayer. */
    IfPlayerInoutMap(AND_01, true, 15, 0);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    /* Init some core stuff */
    InitializeEvent(0, 11509051, 0); // Match Queue    
    InitializeEvent(0, 11509052, 0); // Match Queue Notification
    InitializeEvent(0, 11509054, 0); // Match Fail/Disconnect
    InitializeEvent(0, 11509055, 0); // Add Temp Items
    InitializeEvent(0, 11509056, 0); // Remove Temp Items
    
    /* Init full game */
    InitializeEvent(0, 11509057, 11509040, 9510); // Set Difficulty : Easy
    InitializeEvent(1, 11509057, 11509041, 9511); // Set Difficulty : Medium
    InitializeEvent(2, 11509057, 11509042, 9512); // Set Difficulty : Hard
    InitializeEvent(0, 11509058, 11509011, 9501); // Player Ready : A
    InitializeEvent(1, 11509058, 11509012, 9502); // Player Ready : B
    InitializeEvent(2, 11509058, 11509013, 9503); // Player Ready : C
    InitializeEvent(0, 11509059, 0); // Match Start
    InitializeEvent(0, 11509060, 0); // Match Start Notification
    InitializeEvent(0, 11509061, 0); // Update Player Speffs
    InitializeEvent(0, 11509062, 11509020, 9500); // Player OnDeath : Host
    InitializeEvent(1, 11509062, 11509021, 9501); // Player OnDeath : A
    InitializeEvent(2, 11509062, 11509022, 9502); // Player OnDeath : B
    InitializeEvent(3, 11509062, 11509023, 9503); // Player OnDeath : C
    InitializeEvent(0, 11509063, 11509030, 9500, 11509021, 11509022, 11509023); // Traitor Win : Host
    InitializeEvent(1, 11509063, 11509031, 9501, 11509020, 11509022, 11509023); // Traitor Win : A
    InitializeEvent(2, 11509063, 11509032, 9502, 11509021, 11509020, 11509023); // Traitor Win : B
    InitializeEvent(3, 11509063, 11509033, 9503, 11509021, 11509022, 11509020); // Traitor Win : C
    InitializeEvent(0, 11509064, 9710); // Handle Traitor Win
    InitializeEvent(0, 11509065, 0); // Match End Item Trigger
    InitializeEvent(0, 11509066, 0); // Match End Item
    InitializeEvent(0, 11509067, 0); // Host Heartbeat
    InitializeEvent(0, 11509068, 11509015, 9501); // Player Heartbeat Response : A
    InitializeEvent(1, 11509068, 11509016, 9502); // Player Heartbeat Response : B
    InitializeEvent(2, 11509068, 11509017, 9503); // Player Heartbeat Response : C
    InitializeEvent(0, 11509071, 11509000); // Resync fix
    InitializeEvent(1, 11509071, 11509010); // Resync fix
    InitializeEvent(2, 11509071, 11509011); // Resync fix
    InitializeEvent(3, 11509071, 11509012); // Resync fix
    InitializeEvent(4, 11509071, 11509013); // Resync fix
    InitializeEvent(5, 11509071, 11509020); // Resync fix
    InitializeEvent(6, 11509071, 11509021); // Resync fix
    InitializeEvent(7, 11509071, 11509022); // Resync fix
    InitializeEvent(8, 11509071, 11509023); // Resync fix
    InitializeEvent(9, 11509071, 11509015); // Resync fix
    InitializeEvent(10, 11509071, 11509016); // Resync fix
    InitializeEvent(11, 11509071, 11509017); // Resync fix
    InitializeEvent(12, 11509071, 11509030); // Resync fix
    InitializeEvent(13, 11509071, 11509031); // Resync fix
    InitializeEvent(14, 11509071, 11509032); // Resync fix
    InitializeEvent(15, 11509071, 11509033); // Resync fix
    InitializeEvent(0, 11509084, 11509045); // Resync fix all
    InitializeEvent(1, 11509084, 11509046); // Resync fix all
    InitializeEvent(2, 11509084, 11509047); // Resync fix all
    InitializeEvent(3, 11509084, 11509048); // Resync fix all
    InitializeEvent(0, 11509072, 11509030); // Resync fix off
    InitializeEvent(1, 11509072, 11509031); // Resync fix off
    InitializeEvent(2, 11509072, 11509032); // Resync fix off
    InitializeEvent(3, 11509072, 11509033); // Resync fix off
    InitializeEvent(0, 11509073, 1509073, 1509074, 1509099); // Fall Out : 0
    InitializeEvent(0, 11509073, 1509078, 1509074, 1509099); // Fall Out : 1
    InitializeEvent(0, 11509074, 0); // Dead character freeze
    InitializeEvent(0, 11509075, 11509045, 1500800, 1509075); // Spectate Boss : Golem
    InitializeEvent(0, 11509076, 11509045, 1500800, 9538); // Fix Boss HP : Golem
    InitializeEvent(0, 11509077, 0); // Disable Boss Health Bars
    InitializeEvent(0, 11509078, 11509045, 1500800, 0, 2320); // Enable Boss Health Bar : Golem
    InitializeEvent(0, 11509080, 11509045); // Boss Healing Items : Golem
    InitializeEvent(0, 11509081, 0); // Malfunction Notifier
    InitializeEvent(0, 11509082, 0); // Revive [Traitor] Desync Handler
    InitializeEvent(0, 11509085, 0); // Revive [Traitor] Sync Handler
    InitializeEvent(0, 11509086, 11509020, 9500); // Revive Sync Handler : Host
    InitializeEvent(1, 11509086, 11509021, 9501); // Revive Sync Handler : Player A
    InitializeEvent(2, 11509086, 11509022, 9502); // Revive Sync Handler : Player B
    InitializeEvent(3, 11509086, 11509023, 9503); // Revive Sync Handler : Player C
    InitializeEvent(0, 11509087, 9710); // Handle Innocent Win
    InitializeEvent(0, 11509088, 1509095, 1509096, 1500995); // Checkpoint Win : Sen's Gate -> Upper Sen's Bonfire
    InitializeEvent(0, 11509089, 0); // All dead : Traitor DC fix
    InitializeEvent(0, 11509091, 0); // Curse Handler
});

/* TTT Match Queue */
/* When the host uses the Match Queue item we setup the basics for the game. This is a host only script */
Event(11509051, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11509000, ON);
    SetEventFlag(11509010, ON);
    
    /* Reset these boss flags at init just incase! */
    SetEventFlag(11509045, OFF); // Bosses
});

/* Randomly choose tratitor */
/* Cycles through each player slot until a MP session starts. */
Event(11509070, Default, function() {
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11509030, ON);
    SetEventFlag(11509031, OFF);
    SetEventFlag(11509032, OFF);
    SetEventFlag(11509033, OFF);
    WaitFixedTimeFrames(7);
    
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetEventFlag(11509030, OFF);
    SetEventFlag(11509031, ON);
    SetEventFlag(11509032, OFF);
    SetEventFlag(11509033, OFF);
    WaitFixedTimeFrames(7);
    
    IfMultiplayerState(AND_03, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_03);
    SetEventFlag(11509030, OFF);
    SetEventFlag(11509031, OFF);
    SetEventFlag(11509032, ON);
    SetEventFlag(11509033, OFF);
    WaitFixedTimeFrames(7);
    
    IfMultiplayerState(AND_04, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_04);
    SetEventFlag(11509030, OFF);
    SetEventFlag(11509031, OFF);
    SetEventFlag(11509032, OFF);
    SetEventFlag(11509033, ON);
    WaitFixedTimeFrames(7);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Match Queue Notification */
/* If a match is queued, display a message. Unsync since this is a message that should show reatroactively. */
Event(11509052, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509000);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayGenericDialog(9000, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
});

/* TTT Match Queue Fail */
/* If the player is not in a multiplayer session the queue fails. */
Event(11509053, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11509000);
    IfPlayerInoutMap(AND_01, true, 15, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9500);
    SetCharacterTeamType(10000, TeamType.Human);
    DisplayGenericDialog(9001, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Match Fail/Disconnect */
/* If a match is in progress, or queued and the game reverst to singleplayer, we reload the game. */
Event(11509054, Default, function() {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11509000);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayGenericDialog(9002, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    WaitFixedTimeSeconds(4);
    SetSpeffect(10000, 3220); // Homeward bone effect
});

/* TTT Add Temp items */
/* Add game items when needed. Desync & Uses flow control. */
Event(11509055, Default, function() {
    SetNetworkSyncState(Disabled);
    
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509000);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(AND_02, 10000, TargetType.Alive);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);
    AwardItemsIncludingClients(9600);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(9610);
});

/* TTT Remove Temp Items */
/* Remove items from users inventories based on game state. Desync & Uses flow control. */
Event(11509056, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11509000);
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11509011);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 361, 1);
    
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11509012);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    RemoveItemFromPlayer(ItemType.Goods, 362, 1);
    
    IfEventFlag(AND_03, OFF, TargetEventFlagType.EventFlag, 11509013);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_03);
    RemoveItemFromPlayer(ItemType.Goods, 363, 1);
    
    IfEventFlag(AND_04, OFF, TargetEventFlagType.EventFlag, 11509040);
    IfEventFlag(AND_04, OFF, TargetEventFlagType.EventFlag, 11509041);
    IfEventFlag(AND_04, OFF, TargetEventFlagType.EventFlag, 11509042);
    SkipIfConditionGroupStateUncompiled(3, PASS, AND_04);
    RemoveItemFromPlayer(ItemType.Goods, 365, 1);
    RemoveItemFromPlayer(ItemType.Goods, 366, 1);
    RemoveItemFromPlayer(ItemType.Goods, 367, 1);
    
    WaitFixedTimeFrames(1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Set Difficulty */
/* Sets difficulty flag for match. */
Event(11509057, Default, function(X0_4, X4_4) {
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(X0_4, ON);
    ClearSpeffect(10000, X4_4);
    //DisplayGenericDialog(9010, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1); //Debug
});


/* TTT Player Ready */
/* Sets ready flag for player after they use "ready" item. */
Event(11509058, Default, function(X0_4, X4_4) {
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(X0_4, ON);
    //DisplayGenericDialog(9010, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1); //Debug
});

/* TTT Match Start */
/* Flags match as started when all players ready and difficulty is set. */
Event(11509059, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509010);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509011);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509012);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509013);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11509040);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11509041);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11509042);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11509001, ON);
});

/* TTT Match Start Notification */
/* If a match is started, display a message and inform player of role. Unsync & Uses flow control. */
Event(11509060, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(9003, 1);
    WaitFixedTimeSeconds(3.0);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9500, true);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11509030);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_02);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_03, 10000, 9501, true);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11509031);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_03);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_04, 10000, 9502, true);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11509032);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_04);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_05, 10000, 9503, true);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11509033);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_05);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    DisplayStatusMessage(9004, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9650);
});

/* TTT Update Player Speffs */
/* Continually sets speffs needed for TTT. EX: NoDead  Unsync. */
Event(11509061, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    SetSpeffect(10000, 9530);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Player OnDeath */
/* When a player dies. Flag it and apply TTT Dead state to trigger the death animation. Repeats just to prevent rare desync softlock. */
Event(11509062, Default, function(X0_4, X4_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(X0_4, ON);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 1303);
    ClearSpeffect(10000, 3151);
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Traitor Win */
/* If you are the traitor, and all other players are dead. You win. */
Event(11509063, Default, function(X0_4, X4_4, X8_4, X12_4, X16_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X8_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X12_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X16_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11509002, ON);
    
    WaitFixedTimeSeconds(7.5);
    SetSpeffect(10000, 7);
    
    WaitFixedTimeSeconds(2.0);
    SetSpeffect(10000, 3220);
});

/* TTT Match Handle Traitor Win */
/* If traitor win flag is on, show messages then kick players back to their own worlds. Unsync & Uses flow control. */
Event(11509064, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509002);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(2.0);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9500, true);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11509030);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_02);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_03, 10000, 9501, true);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11509031);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_03);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_04, 10000, 9502, true);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11509032);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_04);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_05, 10000, 9503, true);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11509033);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_05);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_06, 10000, 9612, true);
    SkipIfConditionGroupStateUncompiled(5, FAIL, AND_06);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    DisplayBanner(TextBannerType.YouLose);
});

/* TTT Match End Item Trigger */
/* If a player uses the Match End item we flag "match end" so everyone can disconnect. */
Event(11509065, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9514, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11509003, ON);
});

/* TTT Match End Item */
/* If match end flag is on we kick everyone out and return host to bonfire. */
Event(11509066, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509003);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    DisplayStatusMessage(9006, Enabled);
    
    WaitFixedTimeSeconds(2.5);
    SetSpeffect(10000, 7);
    
    WaitFixedTimeSeconds(1.0);
    
    SkipIfMultiplayerState(1, MultiplayerState.Client);
    WaitFixedTimeSeconds(3.0);
    
    SetSpeffect(10000, 3220);
});

/* TTT Host Heartbeat */
/* In order to properly detect a DC, we send out a hearbeat every 10 seconds via flags. If the clients dont respond by flipping the flags back then we count them dead. */
Event(11509067, Default, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11509015, ON);
    SetEventFlag(11509016, ON);
    SetEventFlag(11509017, ON);
    
    WaitFixedTimeSeconds(15.0);
    
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11509015);
    SetEventFlag(11509021, ON);
    
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11509016);
    SetEventFlag(11509022, ON);
    
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11509017);
    SetEventFlag(11509023, ON);
    
    EndUnconditionally(EventEndType.Restart);
});
    
    
/* TTT Player Heartbeat */
/* As a client, every 10 seconds our heartbeat flag will be flipped, we must flip it back or the host will assume we have DC'd. */
Event(11509068, Default, function(X0_4, X4_4) {
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, OFF);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Player Resync Flag Fix ON */
/* For flags that are changed in desync functions, the host (only) resends the values. Additionally, used just to ensure shit isn't fucked. */
/* It may seem insane to just constantly send if(i == 1) { i=1; } but dark souls is... it just is... like, fuck man. I'm doing this because I have to. */
Event(11509071, Default, function(X0_4) {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, ON);
    WaitFixedTimeFrames(100);
    
    EndUnconditionally(EventEndType.Restart);
});
    
/* TTT Player Resync Flag Fix OFF */
/* For flags that are changed in desync functions, the host (only) resends the values. */
Event(11509072, Default, function(X0_4) {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, OFF);
    WaitFixedTimeFrames(100);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Player Resync Flag Fix ALL ON */
/* Same as 11509071 but clients also run this. For some flags that can be set by any player. (boss triggers) */
Event(11509071, Default, function(X0_4) {
    IfCharacterHasSpeffect(OR_01, 10000, 9500, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9501, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9502, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9503, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, ON);
    WaitFixedTimeFrames(100);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Fall Out Return */
/* If a player falls off the map we catch them and place them somewhere out of the way. */
Event(11509073, Default, function(X0_4, X4_4, X8_4) {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, X0_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetCharacterTeamType(10000, TeamType.Enemy);
    WaitFixedTimeFrames(5);
    SetCharacterGravity(10000, Disabled);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 9521);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, X4_4, 15, 0);
    WarpCharacterAndCopyFloor(10000, TargetEntityType.Area, X4_4, -1, X8_4);
    WaitFixedTimeSeconds(1.0);
    ClearSpeffect(10000, 9520);
    SetSpeffect(10000, 9524);
    BonfirelikeRecovery();
    SetSpecialAnimations(10000, -1, -1, -1, -1, -1);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    SetSpecialAnimations(10000, 6101, -1, -1, -1, -1);

    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Dead Freeze */
/* If a player is dead, we wait for a notifier spell effect and then completely freeze them with a 0.000000001 motionrate effect. */
Event(11509074, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9520, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9522, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9523, false);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9523);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Spectate Boss (CopyBloor) */
/* When a boss is challenged, a flag is set and we teleport the dead players to a spectate area to watch. */
Event(11509075, Default, function(X0_4, X4_4, X8_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(OR_01, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9524, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WaitFixedTimeSeconds(30.0);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterHasSpeffect(OR_02, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_02, 10000, 9524, true);
    IfConditionGroup(AND_02, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_02);
    
    SetCharacterTeamType(10000, TeamType.Enemy);
    WaitFixedTimeFrames(5);
    SetCharacterGravity(10000, Disabled);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 9521);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, X8_4, 15, 0);
    WarpCharacterAndCopyFloor(10000, TargetEntityType.Area, X8_4, -1, X4_4);
    WaitFixedTimeSeconds(1.0);
    ClearSpeffect(10000, 9520);
    SetSpeffect(10000, 9524);
    BonfirelikeRecovery();
    SetSpecialAnimations(10000, -1, -1, -1, -1, -1);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    SetSpecialAnimations(10000, 6101, -1, -1, -1, -1);

});

/* TTT Spectate Boss (SetFloor) */
/* When a boss is challenged, a flag is set and we teleport the dead players to a spectate area to watch. */
Event(11509090, Default, function(X0_4, X4_4, X8_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(OR_01, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9524, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WaitFixedTimeSeconds(30.0);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterHasSpeffect(OR_02, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_02, 10000, 9524, true);
    IfConditionGroup(AND_02, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_02);
    
    SetCharacterTeamType(10000, TeamType.Enemy);
    WaitFixedTimeFrames(5);
    SetCharacterGravity(10000, Disabled);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 9521);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, X8_4, 15, 0);
    WarpCharacterAndSetFloor(10000, TargetEntityType.Area, X8_4, -1, X4_4);
    WaitFixedTimeSeconds(1.0);
    ClearSpeffect(10000, 9520);
    SetSpeffect(10000, 9524);
    BonfirelikeRecovery();
    SetSpecialAnimations(10000, -1, -1, -1, -1, -1);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    SetSpecialAnimations(10000, 6101, -1, -1, -1, -1);

});

/* TTT Fix Boss HP */
/* When a boss is challenged, give it a HP buff and heal it a lot. Also fix it's team. */
Event(11509076, Default, function(X0_4, X4_4, X8_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterAIState(AND_01, X4_4, AIStateType.Combat);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(X4_4, 9535);
    ClearSpeffect(X4_4, 9536);
    ClearSpeffect(X4_4, 9537);
    SetSpeffect(X4_4, X8_4);
    SetSpeffect(X4_4, 9540);
    SetCharacterTeamType(X4_4, TeamType.StrongEnemy);
});

/* TTT Disable Boss Healthbar */
/* Boss HP bars are weird and buggy in this so I just blanket fuck them on init. */
Event(11509077, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11509045);
    IfConditionGroup(MAIN, FAIL, OR_01);
    
    DisplayBossHealthBar(Disabled, 1500800, 0, 0);
    
    WaitFixedTimeFrames(1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Enable Boss Healthbar */
/* Boss HP bars are weird and buggy so I enable them myself. */
Event(11509078, Default, function(X0_4, X4_4, X8_4, X12_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayBossHealthBar(Enabled, X4_4, X8_4, X12_4);
});

/* TTT Boss Health Items */
/* When a boss fight starts, we give players a nice tasty snack. */
Event(11509080, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterHasSpeffect(AND_01, 10000, 9520, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9524, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(9640);
});

/* TTT Malfunction Notifier */
/* Checks for malfunction notifier speff and then forwards to esd. */
Event(11509081, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHasSpeffect(AND_01, 10000, 9600, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    EzstateInstructionRequest(10000, 6969, 1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Revive [Traitor] Desync Stuff */
/* Checks if player is dead and has revive speff. If so we revive them. Desync. */
Event(11509082, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHasSpeffect(AND_01, 10000, 9611, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9610, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1);
    DisplayStatusMessage(9005, Enabled);
    AwardItemsIncludingClients(9660);
    ClearSpeffect(10000, 9610);
    ClearSpeffect(10000, 9611);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Revive [Traitor] Synced Stuff */
/* Checks if player is dead and has revive speff. This part is sycned. Fixes some hilariuos bugs. */
Event(11509085, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHasSpeffect(AND_01, 10000, 9520, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9610, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9520);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    SetSpeffect(10000, 9550);
    SetSpeffect(10000, 9611);
    SetSpeffect(10000, 9612);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Summon Trigger */
/* Checks for summon notifier speff, and then summons the enemy specified. */
Event(11509083, Default, function(X0_4, X4_4, X8_4) {
    SetCharacterGravity(X4_4, Disabled);
    ChangeCharacterEnableState(X4_4, Disabled);
    IfPlayerInoutMap(AND_01, true, 15, 0);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHasSpeffect(AND_01, 10000, X0_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetNetworkUpdateAuthority(X4_4, AuthorityLevel.Forced);
    WarpCharacterAndSetFloor(X4_4, TargetEntityType.Character, 10000, 91, 10000);
    WaitFixedTimeFrames(X8_4);
    ChangeCharacterEnableState(X4_4, Enabled);
    SetCharacterGravity(X4_4, Enabled);
    ClearSpeffect(10000, X0_4);
    WaitFixedTimeFrames(5);
    SetNetworkUpdateAuthority(X4_4, AuthorityLevel.Normal);
});

/* TTT Revive Synced Stuff */
/* Checks if player is dead and has revive speff. This part is sycned. Fixes some hilariuos bugs. */
Event(11509086, Default, function(X0_4, X4_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9520, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9710, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9520);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    SetSpeffect(10000, 9550);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);
    SetEventFlag(X0_4, OFF);
    WaitFixedTimeFrames(5);
    SetEventFlag(X0_4, OFF);
    WaitFixedTimeFrames(5);
    SetEventFlag(X0_4, OFF); // Kinda dumb, but hopefully prevents a desync
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Match Handle Innocent Win */
/* If innocnet win flag is on, show messages then kick players back to their own worlds. Unsync & Uses flow control. */
Event(11509087, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509004);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(2.0);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9500, true);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11509030);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_03, 10000, 9501, true);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11509031);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_03);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_04, 10000, 9502, true);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11509032);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_04);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_05, 10000, 9503, true);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11509033);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_05);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_06, 10000, 9612, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_06);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(1.0);
    AwardItemsIncludingClients(X0_4);
});

/* TTT Checkpoint Victory */
/* For some maps that have long streches with no boss, we have this checkpoint victory instead. */
Event(11509088, Default, function(X0_4, X4_4, X8_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHasSpeffect(AND_01, 10000, 9531, false);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfCharacterHasSpeffect(AND_01, 10000, 9531, false);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, X4_4);
    IfConditionGroup(MAIN, PASS, AND_01);

    SetEventFlag(11509004, ON);
    
    WaitFixedTimeSeconds(7.5);
    WarpPlayer(15, 0, X8_4);
});

/* TTT All Dead */
/* If all players are marked dead, end game. Should only really be triggered by a traitor DC. */
Event(11509089, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509020);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509021);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509022);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509023);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11509002, ON);
    
    WaitFixedTimeSeconds(7.5);
    SetSpeffect(10000, 7);
    
    WaitFixedTimeSeconds(2.0);
    SetSpeffect(10000, 3220);
});

/* TTT Curse Handler */
Event(11509091, Default, function() {
    IfCharacterHasSpeffect(OR_01, 10000, 33, true);
    IfCharacterHasSpeffect(OR_01, 10000, 34, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11509001);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    SetSpeffect(10000, 9520);
    EndUnconditionally(EventEndType.Restart);
});

Event(11508001, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1508001);
    IfCharacterHasSpeffect(AND_01, 10000, 9420, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(19900015, ON);
    AwardItemLot(8650);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 19900000);
    AwardItemLot(8530);
    WaitFixedTimeSeconds(3.0);
    SetEventFlag(19900000, ON);
});
