// ==EMEVD==
// @docs    ds1-common.emedf.json
// @compress    None
// @game    DarkSouls1
// @string    
// @linked    []
// @version    3.2.2
// ==/EMEVD==

// コンストラクタ
Event(0, Default, function() {
    InitializeEvent(0, 11809050, 0);
    InitializeEvent(0, 11808001, 0);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11800100);
    RegisterBonfire(11800992, 1801960, 2, 180, 10);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11800210);
    RegisterBonfire(11800992, 1801960, 2, 180, 30);
    SkipIfMultiplayerState(2, MultiplayerState.Client);
    DeactivateObject(1801994, Disabled);
    DeleteMapSFX(1801995, false);
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 15);
    DeactivateObject(1801960, Disabled);
    DeactivateObject(1801110, Disabled);
    DeactivateObject(1801111, Enabled);
    InitializeEvent(0, 11805090, 0);
    InitializeEvent(0, 11805091, 0);
    InitializeEvent(0, 11805092, 0);
    InitializeEvent(0, 20, 0);
    InitializeEvent(0, 21, 0);
    InitializeEvent(0, 11800100, 0);
    InitializeEvent(0, 11800101, 0);
    InitializeEvent(0, 11800200, 0);
    InitializeEvent(0, 11800230, 1, 180005, 1801960);
    InitializeEvent(1, 11800230, 2, 180006, 1801960);
    InitializeEvent(2, 11800230, 3, 180007, 1801960);
    InitializeEvent(3, 11800230, 4, 180008, 1801960);
    InitializeEvent(0, 11800210, 0);
    InitializeEvent(0, 11800220, 0);
    InitializeEvent(0, 11806100, 1800100, 1802000);
    InitializeEvent(1, 11806100, 1800101, 1802001);
    InitializeEvent(2, 11806100, 1800102, 1802002);
    InitializeEvent(3, 11806100, 1800103, 1802003);
    InitializeEvent(4, 11806100, 1800104, 1802004);
    InitializeEvent(5, 11806100, 1800105, 1802005);
});

// プリコンストラクタ
Event(50, Default, function() {
    InitializeEvent(0, 11800002, 0);
    SetMapSoundState(1803800, Disabled);
    SkipIfEventFlag(4, OFF, TargetEventFlagType.EventFlag, 15);
    InitializeEvent(0, 11805392, 0);
    DeactivateObject(1801990, Disabled);
    DeleteMapSFX(1801991, false);
    SkipUnconditionally(7);
    InitializeEvent(0, 11805390, 0);
    InitializeEvent(0, 11805391, 0);
    InitializeEvent(0, 11805393, 0);
    InitializeEvent(0, 11805392, 0);
    InitializeEvent(0, 11800001, 0);
    InitializeEvent(0, 11805394, 0);
    InitializeEvent(0, 11805395, 0);
    RegisterNPCHumanityEventValue(6544, 8310);
    InitializeEvent(0, 11805030, 0);
    InitializeEvent(0, 11805032, 0);
    InitializeEvent(0, 11800550, 1000, 1029, 1012);
    SetCharacterImmortality(6331, Enabled);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 830);
    ChangeCharacterEnableState(6331, Disabled);
    SkipIfEventFlag(6, ON, TargetEventFlagType.EventFlag, 15);
    InitializeEvent(0, 11800539, 6331, 1640, 1647, 1647);
    InitializeEvent(0, 11800530, 6331, 1640, 1647, 1644);
    InitializeEvent(0, 11800531, 6331, 1640, 1647, 1645);
    InitializeEvent(0, 11800537, 6331, 1640, 1647, 1649);
    InitializeEvent(0, 11800541, 6331);
    InitializeEvent(0, 11806200, 0);
    SetCharacterImmortality(6341, Enabled);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 831);
    ChangeCharacterEnableState(6341, Disabled);
    SkipIfEventFlag(6, ON, TargetEventFlagType.EventFlag, 15);
    InitializeEvent(0, 11800540, 6341, 1670, 1677, 1677);
    InitializeEvent(0, 11800533, 6341, 1670, 1677, 1673);
    InitializeEvent(0, 11800534, 6341, 1670, 1677, 1674);
    InitializeEvent(0, 11800538, 6341, 1670, 1677, 1678);
    InitializeEvent(0, 11800542, 6341);
    InitializeEvent(0, 11806201, 0);
});

// 大墓 黒敵出現
Event(11805090, Restart, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    ChangeCharacterEnableState(1800900, Disabled);
    ChangeCharacterEnableState(1800901, Disabled);
    ChangeCharacterEnableState(1800902, Disabled);
    ChangeCharacterEnableState(1800903, Disabled);
    ChangeCharacterEnableState(1800904, Disabled);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11800050);
    IfConditionGroup(MAIN, PASS, OR_01);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 735);
    SetEventFlag(5000, ON);
    ChangeCharacterEnableState(1800900, Enabled);
    ChangeCharacterEnableState(1800901, Enabled);
    ChangeCharacterEnableState(1800902, Enabled);
    ChangeCharacterEnableState(1800903, Enabled);
    ChangeCharacterEnableState(1800904, Enabled);
});

// 大墓 黒敵消滅
Event(11805091, Restart, function() {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11805095);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 735);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 735);
    SetEventFlag(735, OFF);
    SetEventFlag(11800050, OFF);
    SetEventFlag(11805095, OFF);
    SetEventFlag(5001, ON);
    ForceCharacterDeath(1800900, false);
    ForceCharacterDeath(1800901, false);
    ForceCharacterDeath(1800902, false);
    ForceCharacterDeath(1800903, false);
    ForceCharacterDeath(1800904, false);
});

// 大墓 黒敵タイマー
Event(11805092, Restart, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    IfWorldTendency(AND_01, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11800050);
    IfConditionGroup(MAIN, PASS, OR_01);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_02, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_02, true, 18, 0);
    IfConditionGroup(OR_02, PASS, AND_02);
    IfEventFlag(OR_02, ON, TargetEventFlagType.EventFlag, 11800050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_02);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_03, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_03, true, 18, 0);
    IfConditionGroup(OR_03, PASS, AND_03);
    IfEventFlag(OR_03, ON, TargetEventFlagType.EventFlag, 11800050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_03);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_04, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_04, true, 18, 0);
    IfConditionGroup(OR_04, PASS, AND_04);
    IfEventFlag(OR_04, ON, TargetEventFlagType.EventFlag, 11800050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_04);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_05, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_05, true, 18, 0);
    IfConditionGroup(OR_05, PASS, AND_05);
    IfEventFlag(OR_05, ON, TargetEventFlagType.EventFlag, 11800050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_05);
    WaitFixedTimeFrames(1);
    IfWorldTendency(AND_06, TendencyType.BlackTendency, ComparisonType.Greater, 50);
    IfPlayerInoutMap(AND_06, true, 18, 0);
    IfConditionGroup(OR_06, PASS, AND_06);
    IfEventFlag(OR_06, ON, TargetEventFlagType.EventFlag, 11800050);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, OR_06);
    SetEventFlag(11800050, ON);
    WaitFixedTimeSeconds(600);
    IfWorldTendency(AND_07, TendencyType.BlackTendency, ComparisonType.LessOrEqual, 50);
    IfPlayerInoutMap(AND_07, true, 18, 0);
    EndIfConditionGroupStateUncompiled(EventEndType.Restart, FAIL, AND_07);
    SetEventFlag(11800050, OFF);
    SetEventFlag(11805095, ON);
});

// ホストが大墓ボス部屋入場
Event(11805390, Default, function() {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 15);
    IfActionButtonLineSegmentBossRoom(AND_01, TargetEntityType.Area, 1802998, 0, -1, 0, 10010403, ReactionType.HollowHuman, 0, 1801990);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1802997);
    ForceAnimationPlayback(10000, 7410, false, false, false);
    EndUnconditionally(EventEndType.Restart);
});

// クライアントが大墓ボス部屋入場
Event(11805391, Default, function() {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 15);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805393);
    IfCharacterType(OR_01, 10000, TargetType.WhitePhantom);
    IfCharacterHasSpeffect(OR_01, 10000, 9531, true);
    IfActionButtonLineSegment(AND_01, TargetEntityType.Area, 1802998, 0, -1, 0, 10010403, ReactionType.All, 0, 1801990);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    RotateCharacter(10000, 1802997);
    ForceAnimationPlayback(10000, 7410, false, false, false);
    EndUnconditionally(EventEndType.Restart);
});

// ホストが大墓ボス部屋入場完了
Event(11805393, Default, function() {
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 15);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1802996);
    IfConditionGroup(MAIN, PASS, AND_01);
    SkipIfMultiplayerState(1, MultiplayerState.Client);
    IssueBossRoomEntryNotification(0);
    ActivateMultiplayerdependantBuffs(1800800);
    SetEventFlag(11809045, ON);
    SetSpEffect(1800800, 9539); // Dumb bug fix to make sure bosses don't spawn at half hp. Heals them to full as soon as fight starts.
});

// 大墓ボスが動き出す
Event(11805392, Restart, function() {
    SkipIfEventFlag(3, OFF, TargetEventFlagType.EventFlag, 15);
    ChangeCharacterEnableState(1800800, Disabled);
    ForceCharacterDeath(1800800, false);
    EndUnconditionally(EventEndType.End);
    SetCharacterAIState(1800800, Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805393);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1802996);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetCharacterAIState(1800800, Enabled);
    DisplayBossHealthBar(Enabled, 1800800, 0, 5370);
});

// 大墓ボス撃破
Event(11800001, Default, function() {
    DeactivateObject(1801111, Disabled);
    DeactivateObject(1801950, Disabled);
    IfCharacterDeadalive(MAIN, 1800800, DeathState.Dead);
    SetEventFlag(15, ON);
    HandleBossDefeat(1800800);
    DeactivateObject(1801990, Disabled);
    DeleteMapSFX(1801991, true);
    SetEventFlag(11809004, ON);
    SkipIfMultiplayerState(2, MultiplayerState.Client);
    SetPlayerRespawnPoint(1802130);
    SaveRequest(0);
    SetEventFlag(11807200, OFF);
    SetEventFlag(11807210, OFF);
    SetEventFlag(11807220, OFF);
    SetEventFlag(11807240, OFF);
    DeactivateObject(1801960, Disabled);
    DeactivateObject(1801110, Disabled);
    DeactivateObject(1801111, Enabled);
    DeleteObjectfollowingSFX(1801960, true);
    SpawnOneshotSFX(TargetEntityType.Object, 1801950, -1, 90014);
    WaitFixedTimeSeconds(2);
    DeactivateObject(1801950, Enabled);
});

// エンディング１
Event(20, Default, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 15);
    IfActionButton(AND_01, TargetEntityType.Object, 1801950, 180, -1, 1.5, 10010108, ReactionType.HollowHuman, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    IncrementGameCycle(1);
    PlayCutsceneToPlayer(180000, CutscenePlayMode.Skippable, 10000);
    WaitFixedTimeFrames(1);
    AwardAchievement(1);
    SetEventFlag(20, ON);
});

// エンディング２
Event(21, Default, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 15);
    IfInoutsideArea(AND_01, InsideOutsideState.Outside, 10000, 1802990);
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    IncrementGameCycle(1);
    PlayCutsceneToPlayer(180001, CutscenePlayMode.Skippable, 10000);
    WaitFixedTimeFrames(1);
    AwardAchievement(2);
    SetEventFlag(21, ON);
});

// 大墓ボスBGM ON
Event(11805394, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 15);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805392);
    SkipIfMultiplayerState(1, MultiplayerState.Host);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805391);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1802990);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetMapSoundState(1803800, Enabled);
});

// 大墓ボスBGM OFF
Event(11805395, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 15);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805394);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetMapSoundState(1803800, Disabled);
});

// クリア直前処理
Event(11800002, Restart, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 15);
    ChangeCharacterEnableState(1800200, Disabled);
    ChangeCharacterEnableState(1800201, Disabled);
    ChangeCharacterEnableState(1800202, Disabled);
    ChangeCharacterEnableState(1800203, Disabled);
    ChangeCharacterEnableState(1800204, Disabled);
    ChangeCharacterEnableState(1800900, Disabled);
    ChangeCharacterEnableState(1800901, Disabled);
    ChangeCharacterEnableState(1800902, Disabled);
    ChangeCharacterEnableState(1800903, Disabled);
    ChangeCharacterEnableState(1800904, Disabled);
    ChangeCharacterEnableState(1803900, Disabled);
    ChangeCharacterEnableState(1803901, Disabled);
    ChangeCharacterEnableState(1803902, Disabled);
    ForceCharacterDeath(1800200, false);
    ForceCharacterDeath(1800201, false);
    ForceCharacterDeath(1800202, false);
    ForceCharacterDeath(1800203, false);
    ForceCharacterDeath(1800204, false);
    ForceCharacterDeath(1800900, false);
    ForceCharacterDeath(1800901, false);
    ForceCharacterDeath(1800902, false);
    ForceCharacterDeath(1800903, false);
    ForceCharacterDeath(1800904, false);
    ForceCharacterDeath(1803900, false);
    ForceCharacterDeath(1803901, false);
    ForceCharacterDeath(1803902, false);
});

// 大墓に王の器を安置する
Event(11800100, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    DeactivateObject(1801110, Disabled);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 2510, OwnershipState.Owns);
    IfActionButton(AND_01, TargetEntityType.Object, 1801960, 180, 150, 2, 10010105, ReactionType.HollowHuman, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    PlayCutsceneToPlayer(180015, CutscenePlayMode.Skippable, 10000);
    WaitFixedTimeFrames(1);
    DeactivateObject(1801110, Enabled);
    RegisterBonfire(11800992, 1801960, 2, 180, 10);
    RemoveItemFromPlayer(ItemType.Goods, 2510, 0);
});

// 大墓に王の器を安置できない
Event(11800101, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11800100);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 2510, OwnershipState.DoesntOwn);
    IfActionButton(AND_01, TargetEntityType.Object, 1801960, 180, 150, 2, 10010105, ReactionType.All, 0);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11800100);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    EndIfConditionGroupStateCompiled(EventEndType.End, PASS, AND_02);
    DisplayGenericDialog(10010174, PromptType.OKCANCEL, NumberofOptions.NoButtons, 1801960, 3);
    EndUnconditionally(EventEndType.Restart);
});

// 大墓の封印を解く
Event(11800200, Default, function() {
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 756);
    ForceAnimationPlayback(10000, 7697, false, false, false);
    WaitFixedTimeFrames(75);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11800201);
    IfPlayerHasdoesntHaveItem(AND_01, ItemType.Goods, 2500, OwnershipState.Owns);
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11800202);
    IfPlayerHasdoesntHaveItem(AND_02, ItemType.Goods, 2501, OwnershipState.Owns);
    IfEventFlag(AND_03, OFF, TargetEventFlagType.EventFlag, 11800203);
    IfPlayerHasdoesntHaveItem(AND_03, ItemType.Goods, 2502, OwnershipState.Owns);
    IfEventFlag(AND_04, OFF, TargetEventFlagType.EventFlag, 11800204);
    IfPlayerHasdoesntHaveItem(AND_04, ItemType.Goods, 2503, OwnershipState.Owns);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(OR_01, PASS, AND_03);
    IfConditionGroup(OR_01, PASS, AND_04);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(2, FAIL, AND_01);
    SetEventFlag(11800201, ON);
    RemoveItemFromPlayer(ItemType.Goods, 2500, 0);
    SkipIfConditionGroupStateCompiled(2, FAIL, AND_02);
    SetEventFlag(11800202, ON);
    RemoveItemFromPlayer(ItemType.Goods, 2501, 0);
    SkipIfConditionGroupStateCompiled(2, FAIL, AND_03);
    SetEventFlag(11800203, ON);
    RemoveItemFromPlayer(ItemType.Goods, 2502, 0);
    SkipIfConditionGroupStateCompiled(2, FAIL, AND_04);
    SetEventFlag(11800204, ON);
    RemoveItemFromPlayer(ItemType.Goods, 2503, 0);
    SetEventFlag(11805111, ON);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 11805111);
    WaitFixedTimeFrames(10);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 11800211);
    SetEventFlag(756, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 王の器成長_XX
Event(11800230, Default, function(X0_4, X4_4, X8_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805111);
    IfCountEventFlags(AND_01, TargetEventFlagType.EventFlag, 11800201, 11800204, ComparisonType.Equal, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    DeleteObjectfollowingSFX(X8_4, true);
    CreateObjectfollowingSFX(X8_4, 100, X4_4);
    WaitFixedTimeFrames(95);
    SkipIfBatchEventFlags(1, LogicalOperationType.AllON, TargetEventFlagType.EventFlag, 11800201, 11800204);
    ForceAnimationPlayback(10000, 7701, true, false, false);
    SetEventFlag(11805111, OFF);
});

// 封印された門が開く
Event(11800210, Default, function() {
    SkipIfEventFlag(17, ON, TargetEventFlagType.EventFlag, 15);
    IfCountEventFlags(AND_02, TargetEventFlagType.EventFlag, 11800201, 11800204, ComparisonType.Equal, 1);
    IfCountEventFlags(AND_03, TargetEventFlagType.EventFlag, 11800201, 11800204, ComparisonType.Equal, 2);
    IfCountEventFlags(AND_04, TargetEventFlagType.EventFlag, 11800201, 11800204, ComparisonType.Equal, 3);
    IfCountEventFlags(AND_05, TargetEventFlagType.EventFlag, 11800201, 11800204, ComparisonType.Equal, 4);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(OR_01, PASS, AND_03);
    IfConditionGroup(OR_01, PASS, AND_04);
    IfConditionGroup(OR_01, PASS, AND_05);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(1, FAIL, AND_02);
    CreateObjectfollowingSFX(1801960, 100, 180005);
    SkipIfConditionGroupStateCompiled(1, FAIL, AND_03);
    CreateObjectfollowingSFX(1801960, 100, 180006);
    SkipIfConditionGroupStateCompiled(1, FAIL, AND_04);
    CreateObjectfollowingSFX(1801960, 100, 180007);
    SkipIfConditionGroupStateCompiled(1, FAIL, AND_05);
    CreateObjectfollowingSFX(1801960, 100, 180008);
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventID, 0);
    ReproduceObjectAnimation(1801101, 1);
    EndUnconditionally(EventEndType.End);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800201);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800202);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800203);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800204);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11800211, ON);
    SetEventFlag(756, OFF);
    PlayCutsceneToPlayer(180010, CutscenePlayMode.Skippable, 10000);
    WaitFixedTimeFrames(1);
    ReproduceObjectAnimation(1801101, 1);
    RegisterBonfire(11800992, 1801960, 2, 180, 30);
});

// 封印された門
Event(11800220, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11800210);
    IfActionButtonLineSegment(AND_01, TargetEntityType.Area, 1802100, 0, -1, 0, 10010400, ReactionType.All, 0, 1801101);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11805110);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(2, PASS, AND_02);
    DisplayGenericDialog(10010160, PromptType.OKCANCEL, NumberofOptions.NoButtons, 1801101, 3);
    SkipUnconditionally(2);
    SetEventFlag(11805110, OFF);
    DisplayGenericDialog(10010171, PromptType.OKCANCEL, NumberofOptions.NoButtons, 1801960, 3);
    EndUnconditionally(EventEndType.Restart);
});

// さまよう黒騎士_XX
Event(11806100, Restart, function(X0_4, X4_4) {
    SetNetworkSyncState(Disabled);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IssueShortWarpRequest(X0_4, TargetEntityType.Area, X4_4, -1);
    SetCharacterAIState(X0_4, Disabled);
    ForceAnimationPlayback(X0_4, 200, true, false, false);
    IfInoutsideArea(MAIN, InsideOutsideState.Inside, X0_4, 1802006);
    IssueShortWarpRequest(X0_4, TargetEntityType.Area, X4_4, -1);
    EndUnconditionally(EventEndType.Restart);
});

// 強敵ドロップ強制取得_XX
Event(11805100, Restart, function(X0_4, X4_4) {
    IfCharacterDeadalive(MAIN, X0_4, DeathState.Alive);
    IfCharacterDeadalive(MAIN, X0_4, DeathState.Dead);
    IfCharacterType(OR_07, 10000, TargetType.Alive);
    IfCharacterType(OR_07, 10000, TargetType.Hollow);
    EndIfConditionGroupStateUncompiled(EventEndType.End, FAIL, OR_07);
    AwardItemsIncludingClients(X4_4);
});

// NPC敵対（大墓）
Event(11800510, Default, function(X0_4, X4_4) {
    IfHPRatio(AND_01, X0_4, ComparisonType.LessOrEqual, 0.9);
    IfHPRatio(AND_01, X0_4, ComparisonType.Greater, 0);
    IfCharacterDamagedBy(AND_01, X0_4, 10000);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X4_4);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, X4_4);
    IfEventFlag(AND_03, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(OR_01, PASS, AND_03);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(2, FAIL, AND_03);
    ChangeCharacterEnableState(X0_4, Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 703);
    SetEventFlag(X4_4, ON);
    SetCharacterTeamType(X0_4, TeamType.HostileAlly);
    SaveRequest(0);
});

// NPC死亡（大墓）
Event(11800520, Default, function(X0_4, X4_4, X8_4, X12_4) {
    SkipIfEventFlag(2, OFF, TargetEventFlagType.EventIDAndSlotNumber, 0);
    ForceCharacterTreasure(X0_4);
    EndUnconditionally(EventEndType.End);
    IfHPRatio(MAIN, X0_4, ComparisonType.LessOrEqual, 0);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// 王の探索者　使命を与えたい2（大墓）
Event(11800530, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1643);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 830);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800100);
    IfCharacterDeadalive(AND_01, X0_4, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// 王の探索者　達成してくれて嬉しい
Event(11800531, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1644);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 830);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800210);
    IfCharacterDeadalive(AND_01, X0_4, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// 闇撫で　使命を与えたい2（大墓）
Event(11800533, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1672);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 831);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800100);
    IfCharacterDeadalive(AND_01, X0_4, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// 闇撫で　達成してくれて嬉しい
Event(11800534, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1673);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 831);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800210);
    IfCharacterDeadalive(AND_01, X0_4, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// 王の探索者　嘆かわしい
Event(11800537, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1642);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1643);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 830);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800100);
    IfCharacterDeadalive(AND_01, X0_4, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// 闇撫で　嘆かわしい
Event(11800538, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1671);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1672);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 831);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11800100);
    IfCharacterDeadalive(AND_01, X0_4, DeathState.Alive);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
});

// 王の探索者 敵対でいなくなる（大墓）
Event(11800539, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfEventFlag(OR_07, ON, TargetEventFlagType.EventFlag, 11020598);
    IfHPRatio(AND_07, X0_4, ComparisonType.LessOrEqual, 0.9);
    IfHPRatio(AND_07, X0_4, ComparisonType.Greater, 0);
    IfCharacterDamagedBy(AND_07, X0_4, 10000);
    IfEntityInoutsideRadiusOfEntity(AND_07, InsideOutsideState.Outside, X0_4, 10000, 15);
    IfConditionGroup(OR_07, PASS, AND_07);
    IfConditionGroup(AND_01, PASS, OR_07);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X12_4);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventID, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(3, PASS, AND_02);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
    ForceAnimationPlayback(X0_4, 7009, false, true, false);
    ChangeCharacterEnableState(X0_4, Disabled);
});

// 闇撫で 敵対でいなくなる（大墓）
Event(11800540, Default, function(X0_4, X4_4, X8_4, X12_4) {
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfEventFlag(OR_07, ON, TargetEventFlagType.EventFlag, 11600590);
    IfHPRatio(AND_07, X0_4, ComparisonType.LessOrEqual, 0.9);
    IfHPRatio(AND_07, X0_4, ComparisonType.Greater, 0);
    IfCharacterDamagedBy(AND_07, X0_4, 10000);
    IfEntityInoutsideRadiusOfEntity(AND_07, InsideOutsideState.Outside, X0_4, 10000, 15);
    IfConditionGroup(OR_07, PASS, AND_07);
    IfConditionGroup(AND_01, PASS, OR_07);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X12_4);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventID, 0);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(3, PASS, AND_02);
    BatchSetEventFlags(X4_4, X8_4, OFF);
    SetEventFlag(X12_4, ON);
    ForceAnimationPlayback(X0_4, 7005, false, true, false);
    ChangeCharacterEnableState(X0_4, Disabled);
});

// 王の探索者 表示監視
Event(11800541, Default, function(X0_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 830);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1647);
    IfConditionGroup(MAIN, PASS, AND_01);
    ChangeCharacterEnableState(X0_4, Enabled);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 830);
    ChangeCharacterEnableState(X0_4, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

// 闇撫で 表示監視
Event(11800542, Default, function(X0_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 831);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1676);
    IfConditionGroup(MAIN, PASS, AND_01);
    ChangeCharacterEnableState(X0_4, Enabled);
    IfEventFlag(MAIN, OFF, TargetEventFlagType.EventFlag, 831);
    ChangeCharacterEnableState(X0_4, Disabled);
    EndUnconditionally(EventEndType.Restart);
});

// 太陽の騎士　共闘したい（大墓）
Event(11800550, Default, function(X0_4, X4_4, X8_4) {
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 1004);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1003);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11410595);
    IfConditionGroup(MAIN, PASS, AND_01);
    BatchSetEventFlags(X0_4, X4_4, OFF);
    SetEventFlag(X8_4, ON);
});

// 王の探索者　拠点に運ぶ
Event(11806200, Default, function() {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1643);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1644);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1645);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 824);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(824, OFF);
    PlayCutsceneAndWarpPlayer(180050, CutscenePlayMode.Skippable, 1022110, 10, 2, 10000);
    PlayCutsceneToPlayer(100250, CutscenePlayMode.Skippable, 10000);
    WaitFixedTimeFrames(1);
    ChangeCharacterEnableState(6331, Disabled);
    SetEventFlag(830, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// 闇撫で　深淵に運ぶ
Event(11806201, Default, function() {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1672);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1673);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 1674);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 825);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(825, OFF);
    PlayCutsceneAndWarpPlayer(180051, CutscenePlayMode.Skippable, 1602110, 16, 0, 10000);
    PlayCutsceneToPlayer(160050, CutscenePlayMode.Skippable, 10000);
    WaitFixedTimeFrames(1);
    ChangeCharacterEnableState(6341, Disabled);
    SetEventFlag(831, OFF);
    EndUnconditionally(EventEndType.Restart);
});

// NPC 協力召喚（大墓）
Event(11805030, Default, function() {
    SkipIfMultiplayerState(1, MultiplayerState.Client);
    SetNetworkUpdateAuthority(6544, AuthorityLevel.Forced);
    SkipIfEventFlag(3, ON, TargetEventFlagType.EventFlag, 11805033);
    IfMultiplayerState(AND_02, MultiplayerState.Client);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11805031);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    ChangeCharacterEnableState(6544, Disabled);
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventFlag, 15);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 1012);
    IfCharacterBackreadStatus(AND_01, 6544, true);
    IfEntityInoutsideRadiusOfEntity(AND_01, InsideOutsideState.Inside, 6544, 10000, 30);
    IfConditionGroup(MAIN, PASS, AND_01);
    PlaceNPCSummonSign(SummonSignType.WhiteSign, 6544, 1802050, 11805031, 11805033);
});

// NPC ボス部屋入場（大墓）
Event(11805032, Default, function() {
    EndIfEventFlag(EventEndType.End, ON, TargetEventFlagType.EventID, 0);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805031);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11805393);
    IfConditionGroup(MAIN, PASS, AND_01);
    RequestCharacterAICommand(6544, 10, 0);
    RequestCharacterAIReplan(6544);
    IfEntityInoutsideRadiusOfEntity(MAIN, InsideOutsideState.Inside, 6544, 1801990, 1.5);
    RotateCharacter(6544, 1802997);
    ForceAnimationPlayback(6544, 7410, false, false, false);
    RequestCharacterAICommand(6544, -1, 0);
    RequestCharacterAIReplan(6544);
});

// [TEST] ヒットの上で暴れるテスト
Event(11805200, Restart, function() {
    SetCharacterAIState(1800999, Disabled);
    IfPlayerMovingOnHit(AND_01, 1803000);
    IfPlayerAttackingOnHit(AND_02, 1803000);
    IfConditionGroup(OR_01, PASS, AND_01);
    IfConditionGroup(OR_01, PASS, AND_02);
    IfConditionGroup(MAIN, PASS, OR_01);
    SkipIfConditionGroupStateCompiled(2, PASS, AND_02);
    RequestAnimationPlayback(1800999, 1750, false, true);
    EndUnconditionally(EventEndType.Restart);
    RequestAnimationPlayback(1800999, 2000, false, true);
    EndUnconditionally(EventEndType.Restart);
});


/* TTT Main Init */
Event(11809050, Default, function() {
    
    /* Always remove any temp items at game load. Skip if loading into a multiplayer session. */
    SkipIfMultiplayerState(27, MultiplayerState.Multiplayer);
    RemoveItemFromPlayer(ItemType.Goods, 361, 1);
    RemoveItemFromPlayer(ItemType.Goods, 362, 1);
    RemoveItemFromPlayer(ItemType.Goods, 363, 1);
    RemoveItemFromPlayer(ItemType.Goods, 364, 1);
    RemoveItemFromPlayer(ItemType.Goods, 365, 1);
    RemoveItemFromPlayer(ItemType.Goods, 366, 1);
    RemoveItemFromPlayer(ItemType.Goods, 367, 1);
    RemoveItemFromPlayer(ItemType.Goods, 9510, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9520, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9530, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9540, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9550, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9560, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9570, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9580, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9590, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9600, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9610, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9620, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9630, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9640, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9650, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9660, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9670, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9700, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9710, 99);
    RemoveItemFromPlayer(ItemType.Goods, 9750, 99);
    
    /* Always reset all relevant eventflags at game load. Skip if loading into a multiplayer session. */
    SkipIfMultiplayerState(24, MultiplayerState.Multiplayer);
    SetEventFlag(11809000, OFF); // Match Queue
    SetEventFlag(11809001, OFF); // Match Start
    SetEventFlag(11809002, OFF); // Traitor Win
    SetEventFlag(11809003, OFF); // Match Cancel
    SetEventFlag(11809004, OFF); // Innocent Win
    SetEventFlag(11809010, OFF); // Ready flags [4]
    SetEventFlag(11809011, OFF);
    SetEventFlag(11809012, OFF);
    SetEventFlag(11809013, OFF);
    SetEventFlag(11809015, OFF); // Heartbeat flags [3]
    SetEventFlag(11809016, OFF);
    SetEventFlag(11809017, OFF);
    SetEventFlag(11809020, OFF); // Dead Flags [4]
    SetEventFlag(11809021, OFF);
    SetEventFlag(11809022, OFF);
    SetEventFlag(11809023, OFF);
    SetEventFlag(11809030, OFF); // Role selection flags [4]
    SetEventFlag(11809031, OFF);
    SetEventFlag(11809032, OFF);
    SetEventFlag(11809033, OFF);
    SetEventFlag(11809040, OFF); // Difficulty flags [3]
    SetEventFlag(11809041, OFF);
    SetEventFlag(11809042, OFF);
    SetEventFlag(11809045, OFF); // Bosses
    
    /* Traitor is randomly chosen BEFORE multiplayer starts. To reduce chance of a desync. */
    InitializeEvent(0, 11809070, 0); // Randomly choose traitor
    
    /* Summon init before multiplayer */
    InitializeEvent(0, 11809083, 9620, 1809080, 450); // Summon A1 Handler
    InitializeEvent(1, 11809083, 9620, 1809081, 520); // Summon A2 Handler
    InitializeEvent(2, 11809083, 9620, 1809082, 590); // Summon A3 Handler
    InitializeEvent(3, 11809083, 9630, 1809083, 750); // Summon B Handler
    InitializeEvent(4, 11809083, 9640, 1809084, 420); // Summon C1 Handler
    InitializeEvent(5, 11809083, 9640, 1809085, 450); // Summon C2 Handler
    InitializeEvent(6, 11809083, 9640, 1809086, 480); // Summon C3 Handler
    InitializeEvent(7, 11809083, 9640, 1809087, 520); // Summon C4 Handler
    InitializeEvent(8, 11809083, 9640, 1809088, 550); // Summon C5 Handler
    InitializeEvent(9, 11809083, 9660, 1809089, 600); // Summon E Handler
    
    /* If you try to queue a match in singleplayer... */
    InitializeEvent(0, 11809053, 0); // Match Queue Fail
    
    /* Do not fully init until we are on the appropriate map and in multiplayer. */
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    /* Init some core stuff */
    InitializeEvent(0, 11809051, 0); // Match Queue    
    InitializeEvent(0, 11809052, 0); // Match Queue Notification
    InitializeEvent(0, 11809054, 0); // Match Fail/Disconnect
    InitializeEvent(0, 11809055, 0); // Add Temp Items
    InitializeEvent(0, 11809056, 0); // Remove Temp Items
    
    /* Init full game */
    InitializeEvent(0, 11809057, 11809040, 9510); // Set Difficulty : Easy
    InitializeEvent(1, 11809057, 11809041, 9511); // Set Difficulty : Medium
    InitializeEvent(2, 11809057, 11809042, 9512); // Set Difficulty : Hard
    InitializeEvent(0, 11809058, 11809011, 9501); // Player Ready : A
    InitializeEvent(1, 11809058, 11809012, 9502); // Player Ready : B
    InitializeEvent(2, 11809058, 11809013, 9503); // Player Ready : C
    InitializeEvent(0, 11809059, 0); // Match Start
    InitializeEvent(0, 11809060, 0); // Match Start Notification
    InitializeEvent(0, 11809061, 0); // Update Player Speffs
    InitializeEvent(0, 11809062, 11809020, 9500); // Player OnDeath : Host
    InitializeEvent(1, 11809062, 11809021, 9501); // Player OnDeath : A
    InitializeEvent(2, 11809062, 11809022, 9502); // Player OnDeath : B
    InitializeEvent(3, 11809062, 11809023, 9503); // Player OnDeath : C
    InitializeEvent(0, 11809063, 11809030, 9500, 11809021, 11809022, 11809023); // Traitor Win : Host
    InitializeEvent(1, 11809063, 11809031, 9501, 11809020, 11809022, 11809023); // Traitor Win : A
    InitializeEvent(2, 11809063, 11809032, 9502, 11809021, 11809020, 11809023); // Traitor Win : B
    InitializeEvent(3, 11809063, 11809033, 9503, 11809021, 11809022, 11809020); // Traitor Win : C
    InitializeEvent(0, 11809064, 9720); // Handle Traitor Win
    InitializeEvent(0, 11809065, 0); // Match End Item Trigger
    InitializeEvent(0, 11809066, 0); // Match End Item
    InitializeEvent(0, 11809067, 0); // Host Heartbeat
    InitializeEvent(0, 11809068, 11809015, 9501); // Player Heartbeat Response : A
    InitializeEvent(1, 11809068, 11809016, 9502); // Player Heartbeat Response : B
    InitializeEvent(2, 11809068, 11809017, 9503); // Player Heartbeat Response : C
    InitializeEvent(0, 11809071, 11809000); // Resync fix
    InitializeEvent(1, 11809071, 11809010); // Resync fix
    InitializeEvent(2, 11809071, 11809011); // Resync fix
    InitializeEvent(3, 11809071, 11809012); // Resync fix
    InitializeEvent(4, 11809071, 11809013); // Resync fix
    InitializeEvent(5, 11809071, 11809020); // Resync fix
    InitializeEvent(6, 11809071, 11809021); // Resync fix
    InitializeEvent(7, 11809071, 11809022); // Resync fix
    InitializeEvent(8, 11809071, 11809023); // Resync fix
    InitializeEvent(9, 11809071, 11809015); // Resync fix
    InitializeEvent(10, 11809071, 11809016); // Resync fix
    InitializeEvent(11, 11809071, 11809017); // Resync fix
    InitializeEvent(12, 11809071, 11809030); // Resync fix
    InitializeEvent(13, 11809071, 11809031); // Resync fix
    InitializeEvent(14, 11809071, 11809032); // Resync fix
    InitializeEvent(15, 11809071, 11809033); // Resync fix
    InitializeEvent(0, 11809084, 11809045); // Resync fix all
    InitializeEvent(1, 11809084, 11809046); // Resync fix all
    InitializeEvent(2, 11809084, 11809047); // Resync fix all
    InitializeEvent(3, 11809084, 11809048); // Resync fix all
    InitializeEvent(0, 11809072, 11809030); // Resync fix off
    InitializeEvent(1, 11809072, 11809031); // Resync fix off
    InitializeEvent(2, 11809072, 11809032); // Resync fix off
    InitializeEvent(3, 11809072, 11809033); // Resync fix off
    InitializeEvent(0, 11809073, 1809073, 1809074, 1800202); // Fall Out : 0
    InitializeEvent(0, 11809074, 0); // Dead character freeze
    InitializeEvent(0, 11809075, 11809045, 1800800, 1809075); // Spectate Boss : Gwyn
    InitializeEvent(0, 11809076, 11809045, 1800800, 9539); // Fix Boss HP : Gwyn
    InitializeEvent(0, 11809077, 0); // Disable Boss Health Bars
    InitializeEvent(0, 11809078, 11809045, 1800800, 0, 3471); // Enable Boss Health Bar : Gwyn
    InitializeEvent(0, 11809080, 11809045); // Boss Healing Items : Gwyn
    InitializeEvent(0, 11809081, 0); // Malfunction Notifier
    InitializeEvent(0, 11809082, 0); // Revive [Traitor] Desync Handler
    InitializeEvent(0, 11809085, 0); // Revive [Traitor] Sync Handler
    InitializeEvent(0, 11809086, 11809020, 9500); // Revive Sync Handler : Host
    InitializeEvent(1, 11809086, 11809021, 9501); // Revive Sync Handler : Player A
    InitializeEvent(2, 11809086, 11809022, 9502); // Revive Sync Handler : Player B
    InitializeEvent(3, 11809086, 11809023, 9503); // Revive Sync Handler : Player C
    InitializeEvent(0, 11809087, 9720); // Handle Innocent Win
    InitializeEvent(0, 11809089, 0); // All dead : Traitor DC fix
    InitializeEvent(0, 11809091, 0); // Curse Handler
});

/* TTT Match Queue */
/* When the host uses the Match Queue item we setup the basics for the game. This is a host only script */
Event(11809051, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfCharacterType(AND_01, 10000, TargetType.Alive);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11809000, ON);
    SetEventFlag(11809010, ON);
    
    /* Reset these boss flags at init just incase! */
    SetEventFlag(11809045, OFF); // Bosses
});

/* Randomly choose tratitor */
/* Cycles through each player slot until a MP session starts. */
Event(11809070, Default, function() {
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11809030, ON);
    SetEventFlag(11809031, OFF);
    SetEventFlag(11809032, OFF);
    SetEventFlag(11809033, OFF);
    WaitFixedTimeFrames(7);
    
    IfMultiplayerState(AND_02, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_02);
    SetEventFlag(11809030, OFF);
    SetEventFlag(11809031, ON);
    SetEventFlag(11809032, OFF);
    SetEventFlag(11809033, OFF);
    WaitFixedTimeFrames(7);
    
    IfMultiplayerState(AND_03, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_03);
    SetEventFlag(11809030, OFF);
    SetEventFlag(11809031, OFF);
    SetEventFlag(11809032, ON);
    SetEventFlag(11809033, OFF);
    WaitFixedTimeFrames(7);
    
    IfMultiplayerState(AND_04, MultiplayerState.Singleplayer);
    IfConditionGroup(MAIN, PASS, AND_04);
    SetEventFlag(11809030, OFF);
    SetEventFlag(11809031, OFF);
    SetEventFlag(11809032, OFF);
    SetEventFlag(11809033, ON);
    WaitFixedTimeFrames(7);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Match Queue Notification */
/* If a match is queued, display a message. Unsync since this is a message that should show retroactively. */
Event(11809052, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809000);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayGenericDialog(9000, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
});

/* TTT Match Queue Fail */
/* If the player is not in a multiplayer session the queue fails. */
Event(11809053, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11809000);
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9500);
    SetCharacterTeamType(10000, TeamType.Human);
    DisplayGenericDialog(9001, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Match Fail/Disconnect */
/* If a match is in progress, or queued and the game reverst to singleplayer, we reload the game. */
Event(11809054, Default, function() {
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11809000);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfMultiplayerState(AND_01, MultiplayerState.Singleplayer);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayGenericDialog(9002, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1);
    WaitFixedTimeSeconds(4);
    SetSpeffect(10000, 3220); // Homeward bone effect
});

/* TTT Add Temp items */
/* Add game items when needed. Desync & Uses flow control. */
Event(11809055, Default, function() {
    SetNetworkSyncState(Disabled);
    
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809000);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfCharacterType(AND_02, 10000, TargetType.Alive);
    SkipIfConditionGroupStateUncompiled(2, PASS, AND_02);
    AwardItemsIncludingClients(9600);
    SkipUnconditionally(1);
    AwardItemsIncludingClients(9610);
});

/* TTT Remove Temp Items */
/* Remove items from users inventories based on game state. Desync & Uses flow control. */
Event(11809056, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(MAIN, ON, TargetEventFlagType.EventFlag, 11809000);
    
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, 11809011);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_01);
    RemoveItemFromPlayer(ItemType.Goods, 361, 1);
    
    IfEventFlag(AND_02, OFF, TargetEventFlagType.EventFlag, 11809012);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_02);
    RemoveItemFromPlayer(ItemType.Goods, 362, 1);
    
    IfEventFlag(AND_03, OFF, TargetEventFlagType.EventFlag, 11809013);
    SkipIfConditionGroupStateUncompiled(1, PASS, AND_03);
    RemoveItemFromPlayer(ItemType.Goods, 363, 1);
    
    IfEventFlag(AND_04, OFF, TargetEventFlagType.EventFlag, 11809040);
    IfEventFlag(AND_04, OFF, TargetEventFlagType.EventFlag, 11809041);
    IfEventFlag(AND_04, OFF, TargetEventFlagType.EventFlag, 11809042);
    SkipIfConditionGroupStateUncompiled(3, PASS, AND_04);
    RemoveItemFromPlayer(ItemType.Goods, 365, 1);
    RemoveItemFromPlayer(ItemType.Goods, 366, 1);
    RemoveItemFromPlayer(ItemType.Goods, 367, 1);
    
    WaitFixedTimeFrames(1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Set Difficulty */
/* Sets difficulty flag for match. */
Event(11809057, Default, function(X0_4, X4_4) {
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfMultiplayerState(AND_01, MultiplayerState.Host);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(X0_4, ON);
    ClearSpeffect(10000, X4_4);
    //DisplayGenericDialog(9010, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1); //Debug
});


/* TTT Player Ready */
/* Sets ready flag for player after they use "ready" item. */
Event(11809058, Default, function(X0_4, X4_4) {
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(X0_4, ON);
    //DisplayGenericDialog(9010, PromptType.OKCANCEL, NumberofOptions.NoButtons, 10000, 1); //Debug
});

/* TTT Match Start */
/* Flags match as started when all players ready and difficulty is set. */
Event(11809059, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809010);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809011);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809012);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809013);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11809040);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11809041);
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11809042);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11809001, ON);
});

/* TTT Match Start Notification */
/* If a match is started, display a message and inform player of role. Unsync & Uses flow control. */
Event(11809060, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayMessage(9003, 1);
    WaitFixedTimeSeconds(3.0);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9500, true);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11809030);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_02);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_03, 10000, 9501, true);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11809031);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_03);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_04, 10000, 9502, true);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11809032);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_04);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_05, 10000, 9503, true);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11809033);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_05);
    DisplayStatusMessage(9005, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9750);
    EndUnconditionally(EventEndType.End);
    
    DisplayStatusMessage(9004, Enabled);
    WaitFixedTimeSeconds(2);
    AwardItemsIncludingClients(9630);
    WaitFixedTimeSeconds(1);
    AwardItemsIncludingClients(9650);
});

/* TTT Update Player Speffs */
/* Continually sets speffs needed for TTT. EX: NoDead  Unsync. */
Event(11809061, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 4613);
    SetSpeffect(10000, 4610);
    SetSpeffect(10000, 9530);
    
    WaitFixedTimeSeconds(1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Player OnDeath */
/* When a player dies. Flag it and apply TTT Dead state to trigger the death animation. Repeats just to prevent rare desync softlock. */
Event(11809062, Default, function(X0_4, X4_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfCharacterHPValue(AND_01, 10000, ComparisonType.Greater, 5);
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(X0_4, ON);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 1303);
    ClearSpeffect(10000, 3151);
    WaitFixedTimeFrames(30);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Traitor Win */
/* If you are the traitor, and all other players are dead. You win. */
Event(11809063, Default, function(X0_4, X4_4, X8_4, X12_4, X16_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X8_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X12_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X16_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11809002, ON);
    
    WaitFixedTimeSeconds(7.5);
    SetSpeffect(10000, 7);
    
    WaitFixedTimeSeconds(2.0);
    SetSpeffect(10000, 3220);
});

/* TTT Match Handle Traitor Win */
/* If traitor win flag is on, show messages then kick players back to their own worlds. Unsync & Uses flow control. */
Event(11809064, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809002);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(2.0);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9500, true);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11809030);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_02);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_03, 10000, 9501, true);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11809031);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_03);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_04, 10000, 9502, true);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11809032);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_04);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_05, 10000, 9503, true);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11809033);
    SkipIfConditionGroupStateUncompiled(6, FAIL, AND_05);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_06, 10000, 9612, true);
    SkipIfConditionGroupStateUncompiled(5, FAIL, AND_06);
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(3);
    AwardItemsIncludingClients(X0_4);
    AwardItemsIncludingClients(X0_4);
    EndUnconditionally(EventEndType.End);
    
    DisplayBanner(TextBannerType.YouLose);
});

/* TTT Match End Item Trigger */
/* If a player uses the Match End item we flag "match end" so everyone can disconnect. */
Event(11809065, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9514, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11809003, ON);
});

/* TTT Match End Item */
/* If match end flag is on we kick everyone out and return host to bonfire. */
Event(11809066, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809003);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    DisplayStatusMessage(9006, Enabled);
    
    WaitFixedTimeSeconds(2.5);
    SetSpeffect(10000, 7);
    
    WaitFixedTimeSeconds(1.0);
    
    SkipIfMultiplayerState(1, MultiplayerState.Client);
    WaitFixedTimeSeconds(3.0);
    
    SetSpeffect(10000, 3220);
});

/* TTT Host Heartbeat */
/* In order to properly detect a DC, we send out a hearbeat every 10 seconds via flags. If the clients dont respond by flipping the flags back then we count them dead. */
Event(11809067, Default, function() {
    EndIfMultiplayerState(EventEndType.End, MultiplayerState.Client);
    
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(11809015, ON);
    SetEventFlag(11809016, ON);
    SetEventFlag(11809017, ON);
    
    WaitFixedTimeSeconds(15.0);
    
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11809015);
    SetEventFlag(11809021, ON);
    
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11809016);
    SetEventFlag(11809022, ON);
    
    SkipIfEventFlag(1, OFF, TargetEventFlagType.EventFlag, 11809017);
    SetEventFlag(11809023, ON);
    
    EndUnconditionally(EventEndType.Restart);
});
    
    
/* TTT Player Heartbeat */
/* As a client, every 10 seconds our heartbeat flag will be flipped, we must flip it back or the host will assume we have DC'd. */
Event(11809068, Default, function(X0_4, X4_4) {
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, OFF);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Player Resync Flag Fix ON */
/* For flags that are changed in desync functions, the host (only) resends the values. Additionally, used just to ensure shit isn't fucked. */
/* It may seem insane to just constantly send if(i == 1) { i=1; } but dark souls is... it just is... like, fuck man. I'm doing this because I have to. */
Event(11809071, Default, function(X0_4) {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, ON);
    WaitFixedTimeFrames(100);
    
    EndUnconditionally(EventEndType.Restart);
});
    
/* TTT Player Resync Flag Fix OFF */
/* For flags that are changed in desync functions, the host (only) resends the values. */
Event(11809072, Default, function(X0_4) {
    IfCharacterHasSpeffect(AND_01, 10000, 9500, true);
    IfEventFlag(AND_01, OFF, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, OFF);
    WaitFixedTimeFrames(100);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Player Resync Flag Fix ALL ON */
/* Same as 11809071 but clients also run this. For some flags that can be set by any player. (boss triggers) */
Event(11809071, Default, function(X0_4) {
    IfCharacterHasSpeffect(OR_01, 10000, 9500, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9501, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9502, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9503, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetEventFlag(X0_4, ON);
    WaitFixedTimeFrames(100);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Fall Out Return */
/* If a player falls off the map we catch them and place them somewhere out of the way. */
Event(11809073, Default, function(X0_4, X4_4, X8_4) {
    SetNetworkSyncState(Disabled);
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, X0_4);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetCharacterTeamType(10000, TeamType.Enemy);
    WaitFixedTimeFrames(5);
    SetCharacterGravity(10000, Disabled);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 9521);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, X4_4, 18, 0);
    WarpCharacterAndCopyFloor(10000, TargetEntityType.Area, X4_4, -1, X8_4);
    WaitFixedTimeSeconds(1.0);
    ClearSpeffect(10000, 9520);
    SetSpeffect(10000, 9524);
    BonfirelikeRecovery();
    SetSpecialAnimations(10000, -1, -1, -1, -1, -1);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    SetSpecialAnimations(10000, 6101, -1, -1, -1, -1);

    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Dead Freeze */
/* If a player is dead, we wait for a notifier spell effect and then completely freeze them with a 0.000000001 motionrate effect. */
Event(11809074, Default, function() {
    IfCharacterHasSpeffect(AND_01, 10000, 9520, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9522, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9523, false);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    SetSpeffect(10000, 9523);
    
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Spectate Boss (CopyBloor) */
/* When a boss is challenged, a flag is set and we teleport the dead players to a spectate area to watch. */
Event(11809075, Default, function(X0_4, X4_4, X8_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(OR_01, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9524, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WaitFixedTimeSeconds(30.0);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterHasSpeffect(OR_02, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_02, 10000, 9524, true);
    IfConditionGroup(AND_02, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_02);
    
    SetCharacterTeamType(10000, TeamType.Enemy);
    WaitFixedTimeFrames(5);
    SetCharacterGravity(10000, Disabled);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 9521);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, X8_4, 18, 0);
    WarpCharacterAndCopyFloor(10000, TargetEntityType.Area, X8_4, -1, X4_4);
    WaitFixedTimeSeconds(1.0);
    ClearSpeffect(10000, 9520);
    SetSpeffect(10000, 9524);
    BonfirelikeRecovery();
    SetSpecialAnimations(10000, -1, -1, -1, -1, -1);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    SetSpecialAnimations(10000, 6101, -1, -1, -1, -1);

});

/* TTT Spectate Boss (SetFloor) */
/* When a boss is challenged, a flag is set and we teleport the dead players to a spectate area to watch. */
Event(11809090, Default, function(X0_4, X4_4, X8_4) {
    SetNetworkSyncState(Disabled);
    IfCharacterHasSpeffect(OR_01, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_01, 10000, 9524, true);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    WaitFixedTimeSeconds(30.0);
    
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterHasSpeffect(OR_02, 10000, 9520, true);
    IfCharacterHasSpeffect(OR_02, 10000, 9524, true);
    IfConditionGroup(AND_02, PASS, OR_02);
    IfConditionGroup(MAIN, PASS, AND_02);
    
    SetCharacterTeamType(10000, TeamType.Enemy);
    WaitFixedTimeFrames(5);
    SetCharacterGravity(10000, Disabled);
    SetSpeffect(10000, 9520);
    SetSpeffect(10000, 9521);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    PlayCutsceneAndWarpAllPlayers(0, CutscenePlayMode.Unskippable, X8_4, 18, 0);
    WarpCharacterAndSetFloor(10000, TargetEntityType.Area, X8_4, -1, X4_4);
    WaitFixedTimeSeconds(1.0);
    ClearSpeffect(10000, 9520);
    SetSpeffect(10000, 9524);
    BonfirelikeRecovery();
    SetSpecialAnimations(10000, -1, -1, -1, -1, -1);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    SetSpecialAnimations(10000, 6101, -1, -1, -1, -1);

});

/* TTT Fix Boss HP */
/* When a boss is challenged, give it a HP buff and heal it a lot. Also fix it's team. */
Event(11809076, Default, function(X0_4, X4_4, X8_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterAIState(AND_01, X4_4, AIStateType.Combat);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(X4_4, 9535);
    ClearSpeffect(X4_4, 9536);
    ClearSpeffect(X4_4, 9537);
    SetSpeffect(X4_4, X8_4);
    SetSpeffect(X4_4, 9540);
    SetCharacterTeamType(X4_4, TeamType.StrongEnemy);
});

/* TTT Disable Boss Healthbar */
/* Boss HP bars are weird and buggy in this so I just blanket fuck them on init. */
Event(11809077, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfConditionGroup(MAIN, PASS, AND_01);
    
    IfEventFlag(OR_01, ON, TargetEventFlagType.EventFlag, 11809045);
    IfConditionGroup(MAIN, FAIL, OR_01);
    
    DisplayBossHealthBar(Disabled, 1800800, 0, 0);
    
    WaitFixedTimeFrames(1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Enable Boss Healthbar */
/* Boss HP bars are weird and buggy so I enable them myself. */
Event(11809078, Default, function(X0_4, X4_4, X8_4, X12_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfConditionGroup(MAIN, PASS, AND_01);
    DisplayBossHealthBar(Enabled, X4_4, X8_4, X12_4);
});

/* TTT Boss Health Items */
/* When a boss fight starts, we give players a nice tasty snack. */
Event(11809080, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, X0_4);
    IfCharacterHasSpeffect(AND_01, 10000, 9520, false);
    IfCharacterHasSpeffect(AND_01, 10000, 9524, false);
    IfConditionGroup(MAIN, PASS, AND_01);
    AwardItemsIncludingClients(9640);
});

/* TTT Malfunction Notifier */
/* Checks for malfunction notifier speff and then forwards to esd. */
Event(11809081, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfCharacterHasSpeffect(AND_01, 10000, 9600, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    EzstateInstructionRequest(10000, 6969, 1);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Revive [Traitor] Desync Stuff */
/* Checks if player is dead and has revive speff. If so we revive them. Desync. */
Event(11809082, Default, function() {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfCharacterHasSpeffect(AND_01, 10000, 9611, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9610, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(1);
    DisplayStatusMessage(9005, Enabled);
    AwardItemsIncludingClients(9660);
    ClearSpeffect(10000, 9610);
    ClearSpeffect(10000, 9611);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Revive [Traitor] Synced Stuff */
/* Checks if player is dead and has revive speff. This part is sycned. Fixes some hilariuos bugs. */
Event(11809085, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfCharacterHasSpeffect(AND_01, 10000, 9520, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9610, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9520);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    SetSpeffect(10000, 9550);
    SetSpeffect(10000, 9611);
    SetSpeffect(10000, 9612);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Summon Trigger */
/* Checks for summon notifier speff, and then summons the enemy specified. */
Event(11809083, Default, function(X0_4, X4_4, X8_4) {
    SetCharacterGravity(X4_4, Disabled);
    ChangeCharacterEnableState(X4_4, Disabled);
    IfPlayerInoutMap(AND_01, true, 18, 0);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfCharacterHasSpeffect(AND_01, 10000, X0_4, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetNetworkUpdateAuthority(X4_4, AuthorityLevel.Forced);
    WarpCharacterAndSetFloor(X4_4, TargetEntityType.Character, 10000, 91, 10000);
    WaitFixedTimeFrames(X8_4);
    ChangeCharacterEnableState(X4_4, Enabled);
    SetCharacterGravity(X4_4, Enabled);
    ClearSpeffect(10000, X0_4);
    WaitFixedTimeFrames(5);
    SetNetworkUpdateAuthority(X4_4, AuthorityLevel.Normal);
});

/* TTT Revive Synced Stuff */
/* Checks if player is dead and has revive speff. This part is sycned. Fixes some hilariuos bugs. */
Event(11809086, Default, function(X0_4, X4_4) {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfCharacterHasSpeffect(AND_01, 10000, X4_4, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9520, true);
    IfCharacterHasSpeffect(AND_01, 10000, 9710, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 9520);
    ClearSpeffect(10000, 9522);
    ClearSpeffect(10000, 9523);
    SetSpeffect(10000, 9550);
    RequestCharacterAnimationReset(10000, Interpolation.Uninterpolated);
    RequestAnimationPlayback(10000, 6950, false, false);
    SetEventFlag(X0_4, OFF);
    WaitFixedTimeFrames(5);
    SetEventFlag(X0_4, OFF);
    WaitFixedTimeFrames(5);
    SetEventFlag(X0_4, OFF); // Kinda dumb, but hopefully prevents a desync
    EndUnconditionally(EventEndType.Restart);
});

/* TTT Match Handle Innocent Win */
/* If innocnet win flag is on, show messages then kick players back to their own worlds. Unsync & Uses flow control. */
Event(11809087, Default, function(X0_4) {
    SetNetworkSyncState(Disabled);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809004);
    IfConditionGroup(MAIN, PASS, AND_01);
    WaitFixedTimeSeconds(2.0);
    
    IfCharacterHasSpeffect(AND_02, 10000, 9500, true);
    IfEventFlag(AND_02, ON, TargetEventFlagType.EventFlag, 11809030);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_02);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_03, 10000, 9501, true);
    IfEventFlag(AND_03, ON, TargetEventFlagType.EventFlag, 11809031);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_03);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_04, 10000, 9502, true);
    IfEventFlag(AND_04, ON, TargetEventFlagType.EventFlag, 11809032);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_04);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_05, 10000, 9503, true);
    IfEventFlag(AND_05, ON, TargetEventFlagType.EventFlag, 11809033);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_05);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    IfCharacterHasSpeffect(AND_06, 10000, 9612, true);
    SkipIfConditionGroupStateUncompiled(2, FAIL, AND_06);
    DisplayMessage(9013, 1);
    EndUnconditionally(EventEndType.End);
    
    DisplayBanner(TextBannerType.YouWin);
    WaitFixedTimeSeconds(1.0);
    AwardItemsIncludingClients(X0_4);
});

/* TTT All Dead */
/* If all players are marked dead, end game. Should only really be triggered by a traitor DC. */
Event(11809089, Default, function() {
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfMultiplayerState(AND_01, MultiplayerState.Multiplayer);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809020);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809021);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809022);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809023);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(11809002, ON);
    
    WaitFixedTimeSeconds(7.5);
    SetSpeffect(10000, 7);
    
    WaitFixedTimeSeconds(2.0);
    SetSpeffect(10000, 3220);
});

/* TTT Curse Handler */
Event(11809091, Default, function() {
    IfCharacterHasSpeffect(OR_01, 10000, 33, true);
    IfCharacterHasSpeffect(OR_01, 10000, 34, true);
    IfEventFlag(AND_01, ON, TargetEventFlagType.EventFlag, 11809001);
    IfConditionGroup(AND_01, PASS, OR_01);
    IfConditionGroup(MAIN, PASS, AND_01);
    ClearSpeffect(10000, 33);
    ClearSpeffect(10000, 34);
    SetSpeffect(10000, 9520);
    EndUnconditionally(EventEndType.Restart);
});

Event(11808001, Default, function() {
    IfInoutsideArea(AND_01, InsideOutsideState.Inside, 10000, 1808001);
    IfCharacterHasSpeffect(AND_01, 10000, 9420, true);
    IfConditionGroup(MAIN, PASS, AND_01);
    SetEventFlag(19900023, ON);
    AwardItemLot(8730);
    SkipIfEventFlag(1, ON, TargetEventFlagType.EventFlag, 19900000);
    AwardItemLot(8530);
    WaitFixedTimeSeconds(3.0);
    SetEventFlag(19900000, ON);
});
